/* A simple inet_addr() implementation.
 *
 * PegSoft compatibility library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include "system/headers.h"
#include "system/compat.h"

/*************************************************************************/

in_addr_t compat_inet_addr(char const *cp)
{
	int i;
	long lv;
	char *endptr;
	in_addr_t res;
	unsigned char *bytes = (unsigned char *) &res;
	
	for (i = 0; i < 4; i++) {
		if (!*cp)
			return INADDR_NONE;
			
		lv = strtol(cp, &endptr, 10);
		if (lv < 0 || lv > 255 || (*endptr != 0 && *endptr != '.'))
			return INADDR_NONE;
			
		bytes[i] = (unsigned char) lv; 
		cp = (!*endptr ? endptr : ++endptr);
	}
	
	return ((*endptr) ? INADDR_NONE : res);
}

/*************************************************************************/
