/* A simple inet_aton() implementation.
 *
 * PegSoft compatibility library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include "system/headers.h"
#include "system/compat.h"

#if HAVE_SYS_SOCKET_H
# include <sys/socket.h>
#endif
#if HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif

/*************************************************************************/

int compat_inet_aton(const char *cp, struct in_addr *inp)
{
	int i;
	long lv;
	char *endptr;
	unsigned char *bytes = (unsigned char *) &inp->s_addr;
	
	for (i = 0; i < 4; i++) {
		if (!*cp)
			return 0;
			
		lv = strtol(cp, &endptr, 10);
		if (lv < 0 || lv > 255 || (*endptr != 0 && *endptr != '.'))
			return 0;
			
		bytes[i] = (unsigned char) lv; 
		cp = (!*endptr ? endptr : ++endptr);
	}
	
	return ((*endptr) ? 0 : 1);
}

/*************************************************************************/
