/* Database export module.
 *
 * Database export module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <string>
#include <vector>

#include <modules/module.h>

/*************************************************************************/

namespace modules { class Core; }

/*************************************************************************/

namespace dbexport 
{

/*************************************************************************/

/// DBExport module version
static int const dbexport_version = 0x01000000;

/// The dbexport module class
class DBExport : public modules::Module
{
	public:
		/// Constructor.
		DBExport(modules::Core &core);
		
		/// Overrides Module::load().
		virtual bool load(modules::Core &core);
		
		/// Overrides Module::notify().
		virtual void notify(Module &sender, int msg, void *arg);
		
		/// Overrides Module::start().
		virtual void start(modules::Core &core);
		
		/// Implements Module::version().
		virtual int version() const { return dbexport_version; }
		
		/// Returns the core module.
		modules::Core &core() { return *m_core; }
	private:
		modules::Core *m_core;
		Module *m_src;
		
		typedef std::vector<std::string> dblist_type;
		
		std::string m_source;
		std::string m_dir;
		std::string m_index;
		dblist_type m_db;
};

/*************************************************************************/

} /* namespace dbexport */

/*************************************************************************/

#endif /* MODULE_H */
