/* Database file descriptor structure and file handling routine prototypes.
 *
 * Epona (c) 2000-2002, 2004 PegSoft
 * Contact us at epona@pegsoft.net
 *
 * Based on the original code of Services by Andy Church.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DATAFILES_H
#define DATAFILES_H

/*************************************************************************/

namespace legacydb
{

/*************************************************************************/

struct dbFILE 
{
    FILE *fp;			        /* The normal file descriptor */
    char filename[PATH_MAX];    /* Name of the database file */
};

/*************************************************************************/

/* Prototypes and macros: */

extern int get_file_version(dbFILE *f);

extern dbFILE *open_db(char const *filename);
extern void close_db(dbFILE *f);

#define read_db(f,buf,len)	(fread((buf),1,(len),(f)->fp))
#define getc_db(f)		(fgetc((f)->fp))

extern int read_int16(uint16_t *ret, dbFILE *f);
extern int read_int32(uint32_t *ret, dbFILE *f);
extern int read_string(char **ret, dbFILE *f);

#define read_buffer(buf,f)	(read_db((f),(buf),sizeof(buf)) == sizeof(buf))

/*************************************************************************/

} /* namespace legacydb */

/*************************************************************************/

#endif	/* DATAFILES_H */
