/* Private declarations.
 *
 * MySQL database module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DECL_H
#define DECL_H

/*************************************************************************/

#include <log/levels.h>

/*************************************************************************/
	
namespace mysql 
{

/*************************************************************************/

class MySQL;

/*************************************************************************/

extern MySQL *me;

/*************************************************************************/

LOGLEVELH(DebugMySQL, xlog::LogDebug, "Debug::MySQL", "debug: mysql: ");
LOGLEVELH(InfoMySQL, xlog::LogInfo, "Info::MySQL", "mysql: ");
LOGLEVELH(InfoMySQLConn, InfoMySQL, "Info::MySQL::Connection",
		"mysql connection: ");
LOGLEVELH(InfoMySQLQueries, InfoMySQL, "Info::MySQL::Queries",
		"mysql query: ");
LOGLEVELH(InfoMySQLWarnings, InfoMySQL, "Info::MySQL::Warnings",
		"mysql query warning: ");
LOGLEVELH(WarningMySQL, xlog::LogWarning, "Warning::MySQL", "warning: mysql: ");
LOGLEVELH(ErrorMySQL, xlog::LogError, "Error::MySQL", "Error: mysql: ");
LOGLEVELH(ErrorMySQLConn, ErrorMySQL, "Error::MySQL::Connection",
		"Error: mysql connection: ");
LOGLEVELH(CriticalMySQL, xlog::LogCritical, "Critical::MySQL",
		"Critical error: mysql: ");
LOGLEVELH(CriticalMySQLConn, CriticalMySQL, "Critical::MySQL::Connection",
		"Critical error: mysql connection: ");

/*************************************************************************/

} /* namespace mysql */

/*************************************************************************/

#endif /* DECL_H */
