/* Sendmail mail transport module.
 *
 * Sendmail mail transport module (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <modules/module.h>

#include "transport.h"

/*************************************************************************/

namespace modules { class Core; }

/*************************************************************************/

/// Namespace for module sendmail.

namespace sendmail 
{

/*************************************************************************/

class Directives;

/*************************************************************************/

/// The module version.
static int const sendmail_version = 0x01000000;

/// The sendmail module class.

class Sendmail : public modules::Module
{
	public:
		/// Constructor.
		Sendmail(modules::Core &core);
		/// Destructor.
		~Sendmail();
		
		/// Overrides Module::config().
		virtual conf::ConfQ *config(modules::Core &core,
				conf::ConfGlobalQ &global);
		
		/// Overrides Module::interface().
		virtual modules::Interface *interface(modules::PSIID iid);
		
		/// Implements Module::version().
		virtual int version() const { return sendmail_version; }
		
		/// Returns the core module.
		modules::Core &core() { return *m_core; }
		
		/// Returns the configuration directives.
		Directives const &cd() const { return *m_cd; }
	private:
		modules::Core *m_core;
		Directives *m_cd;
		
		Transport transport;
};

/*************************************************************************/

} /* namespace sendmail */

/*************************************************************************/

#endif /* MODULE_H */
