/* Configuration.
 *
 * SMTP mail transport module (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <system/headers.h>

#include <sockets/socket.h>

#include "conf.h"

using namespace std;

/*************************************************************************/

namespace smtp_cli
{

/*************************************************************************/

#define CHECK_ADD(x, y, z) if (!(x).add((z))) { \
	(y).errorf("Can't add directive %s: out of memory?", (z).name().c_str()); \
	return false; }

/*************************************************************************/

Directives::Directives(conf::ConfLogger &logger) : DirectivesQ(logger),
		relay("relay", "127.0.0.1", true, 1, 63, ""),
		port("port", 25, true),
		fqdn("fqdn", sockets::Socket::hostname(), true, 1, 255, ""),
		limit("limit", 32, true, 1, 65535)
{
	
}

/*************************************************************************/

bool Directives::add(conf::Conf &conf)
{
	CHECK_ADD(conf, conf, relay);
	CHECK_ADD(conf, conf, port);
	CHECK_ADD(conf, conf, fqdn);
	CHECK_ADD(conf, conf, limit);
	
	return true;
}

/*************************************************************************/

} /* namespace smtp_cli */

/*************************************************************************/
