# French language file.
#	 
# Epona (c) 2000-2002, 2004 PegSoft
# Contact us at epona@pegsoft.net
#
# This program is free but copyrighted software; see the file COPYING for
# details.
#
# Based on the original code of Services by Andy Church.
#
# When translating this file to another language, keep in mind that the
# order of parameters for sprintf() is fixed in the source code, so your
# messages need to take the same parameters in the same order as the
# English messages do.  (Obviously, this doesn't hold for the strftime()
# format lines immediately below.)  If you can't get a natural translation
# of a message without changing the order of the parameters, let me know
# (achurch@dragonfire.net) which message is causing a problem and I'll see
# what I can do.
#
# In help messages, "%S" (capital S, not lowercase) refers to the name of
# the service sending the message; for example, in NickServ help messages,
# "%S" is replaced by "NickServ" (or whatever it is renamed to in
# config.h).  The %S's do not count as sprintf() parameters, so they can be
# rearranged, removed, or added as necessary.
#
# Also in help messages, please try to limit line lengths to 60 characters
# of text (not including the leading tab).  This length was chosen because
# it does not cause line wrap under default settings on most current IRC
# clients.  Remember that format characters (control-B, control-_) are not
# included in that 60-character limit (since they don't show on the user's
# screen).  Also remember that format specifiers (%S, etc.) will expand
# when displayed, so remember to take this into account; you can assume
# that the length of a pseudoclient name (%S replacement) will be eight
# characters, so reduce the maximum line length by 6 for every %S on a
# line.
#
# Finally, remember to put a tab at the beginning of every line of text
# (including empty lines).  This has to be a tab, not spaces.

###########################################################################
#
# Name of this language
#
###########################################################################

# For languages other than English, this string should have the following
# format:
#     language-name-in-language (language-name-in-English)
# For example, "Espaol (Spanish)" or "Franais (French)".

LANG_NAME
	Franais (French)

###########################################################################
#
# General messages
#
###########################################################################

# strftime() format strings.  man 3 strftime for information on the
# meanings of the format specifiers.  Short version:
#	%a = weekday name (short)	%H = hour
#	%b = month name (short)		%M = minute
#	%d = day of month		%S = second
#	%Y = year			%Z = time zone

# This is used as the format string for strftime() for a date and time
# together.
STRFTIME_DATE_TIME_FORMAT
	%d %b %Y %H:%M:%S %Z
# This is used as the format string for strftime() for a date alone in long
# format (English: including weekday).
STRFTIME_LONG_DATE_FORMAT
	%a %d %b %Y
# This is used as the format string for strftime() for a date alone in
# short format (English: without weekday).
STRFTIME_SHORT_DATE_FORMAT
	%d %b %Y

# These tell our strftime() what the names of months and days are.  If you
# don't use %a, %A, %b, or %B in your strftime() strings above, you can
# leave these empty.  However, if you enter names, they MUST stay in order,
# one per line, and the list MUST be complete!

# %a
STRFTIME_DAYS_SHORT
	Dim
	Lun
	Mar
	Mer
	Jeu
	Ven
	Sam
# %A
STRFTIME_DAYS_LONG
	Dimanche
	Lundi
	Mardi
	Mercredi
	Jeudi
	Vendredi
	Samedi
# %b
STRFTIME_MONTHS_SHORT
	Jan
	Fv
	Mar
	Avr
	Mai
	Jun
	Jul
	Ao
	Sep
	Oct
	Nov
	Dc
# %B
STRFTIME_MONTHS_LONG
	Janvier
	Fvrier
	Mars
	Avril
	Mai
	Juin
	Juillet
	Aot
	Septembre
	Octobre
	Novembre
	Dcembre


# This is used in ChanServ/NickServ INFO displays.
COMMA_SPACE
	, 


# Various error messages.
USER_RECORD_NOT_FOUND
	Erreur interne - impossible d'effectuer la commande.
UNKNOWN_COMMAND
	La commande %s est inconnue.
UNKNOWN_COMMAND_HELP
	La commande %s est inconnue. Tapez "/msg %s HELP" pour obtenir de l'aide.
SYNTAX_ERROR
	Syntaxe: %s
MORE_INFO
	Tapez /msg %s HELP %s pour plus d'informations.
NO_HELP_AVAILABLE
	Aucune aide sur %s n'est disponible.
OBSOLETE_COMMAND
	Cette commande est dpasse; utilisez %s dsormais.
REMOVED_COMMAND
	Cette commande a t supprime; utilisez %s %s dsormais.

BAD_USERHOST_MASK
	Le masque utilisateur doit avoir le format user@host.
BAD_EXPIRY_TIME
	Echance invalide.
USERHOST_MASK_TOO_WIDE
	Le champ d'application de %s est trop grand; utilisez un masque plus prcis.

SERVICE_OFFLINE
	%s n'est pas connect actuellement.
READ_ONLY_MODE
	Note: les services sont en mode lecture-seule; les changements ne sont pas sauvegards!
PASSWORD_INCORRECT
	Mot de passe incorrect.

# What's the difference between "Access denied" and "Permission denied"?
# Very little; you can safely make them the same message with no real loss
# of meaning.  If you want to make a distinction, "Access denied" is
# usually used more generally; for example, a non-oper trying to access
# OperServ gets "Access denied", while a non-Services admin trying to use
# NickServ SET NOEXPIRE gets "Permission denied".
ACCESS_DENIED
	Accs refus.
PERMISSION_DENIED
	Permission refuse.

MORE_OBSCURE_PASSWORD
	Veuillez ressayer avec un mot de passe plus difficile  trouver. Les mots de passe doivent tre constitus d'au moins cinq caractres, ne doivent pas tre trop facilement devinables (par exemple votre vrai nom ou votre pseudo), et ne doivent pas contenir d'espaces ou de tabulations.
PASSWORD_TRUNCATED
	Note: Votre mot de passe a t tronqu  %d caractres.

NICK_NOT_REGISTERED
	Votre pseudo n'est pas enregistr.
NICK_NOT_REGISTERED_HELP
	Votre pseudo n'est pas enregistr. Tapez /msg %s HELP pour obtenir des informations  propos de l'enregistrement des pseudos.
NICK_X_NOT_REGISTERED
	Le pseudo %s n'est pas enregistr.
NICK_X_NOT_IN_USE
	Le pseudo %s n'est pas utilis actuellement.
NICK_X_NOT_ON_CHAN
	%s n'est pas sur %s actuellement.
CHAN_X_NOT_REGISTERED
	Le canal %s n'est pas enregistr.
CHAN_X_NOT_IN_USE
	Le canal %s n'existe pas.
NICK_IDENTIFY_REQUIRED
	L'identification par mot de passe est requise pour cette commande.
	Ressayez aprs avoir tap /msg %s IDENTIFY motdepasse.
CHAN_IDENTIFY_REQUIRED
	L'identification par mot de passe est requise pour cette commande.
	Ressayez aprs avoir tap /msg %s IDENTIFY %s motdepasse.

MAIL_DISABLED
	Les services sont configurs pour ne pas envoyer de courriel.
MAIL_INVALID
	L'adresse de courriel de %s est invalide.
MAIL_X_INVALID
	%s n'est pas une adresse de courriel valide.
MAIL_LATER
	Impossible d'envoyer un courriel maintenant; ressayez un peu plus tard.
MAIL_DELAYED
	Attendez %d secondes et ressayez.

NO_REASON
	Aucune raison
UNKNOWN
	<inconnu>

DURATION_DAY
	1 jour
DURATION_DAYS
	%d jours
DURATION_HOUR
	1 heure
DURATION_HOURS
	%d heures
DURATION_MINUTE
	1 minute
DURATION_MINUTES
	%d minutes
DURATION_SECOND
	1 seconde
DURATION_SECONDS
	%d secondes

# Human readable expiration
NO_EXPIRE
	n'expire pas
EXPIRES_SOON
	expire  la prochaine mise  jour de la base de donnes
EXPIRES_M
	expire dans %d minutes
EXPIRES_1M
	expire dans %d minute
EXPIRES_HM
	expire dans %d heures, %d minutes
EXPIRES_H1M
	expire dans %d heures, %d minute
EXPIRES_1HM
	expire dans %d heure, %d minutes
EXPIRES_1H1M
	expire dans %d heure, %d minute
EXPIRES_D
	expire dans %d jours
EXPIRES_1D
	expire dans %d jour

###########################################################################
#
# NickServ messages
#
###########################################################################

# Automatic messages
NICK_IS_REGISTERED
	Ce pseudo appartient  quelqu'un d'autre. Veuillez en changer.
	(Si c'est votre pseudo, tapez /msg %s IDENTIFY motdepasse.)
NICK_IS_SECURE
	Ce pseudo est enregistr et protg. Si c'est votre pseudo,
	tapez /msg %s IDENTIFY motdepasse. 
	Sinon, veuillez utiliser un pseudo diffrent.
FORCENICKCHANGE_IN_1_MINUTE
	Si vous n'en changez pas d'ici 1 minute, je changerai votre pseudo.
FORCENICKCHANGE_IN_20_SECONDS
	Si vous n'en changez pas d'ici 20 secondes, je changerai votre pseudo.
FORCENICKCHANGE_NOW
	Ce pseudo a t enregistr; vous ne pouvez pas l'utiliser.
FORCENICKCHANGE_CHANGING
	Vous n'tes pas autoris  utiliser ce pseudo, je vous ai attribu %s en remplacement.

# REGISTER responses
NICK_REGISTER_SYNTAX
	REGISTER motdepasse [courriel]
NICK_REGISTER_SYNTAX_EMAIL
	REGISTER motdepasse courriel
NICK_REGISTRATION_DISABLED
	Dsol, l'enregistrement de pseudos est temporairement suspendu.
NICK_REGISTRATION_FAILED
	Dsol, l'enregistrement a chou.
NICK_REG_PLEASE_WAIT
	Veuillez attendre %d secondes avant d'utiliser la commande REGISTER  nouveau.
NICK_CANNOT_BE_REGISTERED
	Le pseudo %s ne peut tre enregistr.
NICK_ALREADY_REGISTERED
	Le pseudo %s est dj enregistr!
NICK_REGISTERED
	Le pseudo %s est maintenant enregistr avec votre masque utilisateur: %s
NICK_PASSWORD_IS
	Votre mot de passe est %s - notez-le pour vos utilisations ultrieures.

# GROUP responses
NICK_GROUP_SYNTAX
	GROUP cible motdepasse
NICK_GROUP_DISABLED
	Dsol, le groupement de pseudos est temporairement suspendu.
NICK_GROUP_FAILED
	Dsol, le groupement de pseudos a chou.
NICK_GROUP_PLEASE_WAIT
	Attendez %d secondes avant d'utiliser la commande GROUP  nouveau.
NICK_GROUP_CHANGE_DISABLED
	Votre pseudo est dj enregistr; tapez /msg %s DROP d'abord.
NICK_GROUP_SAME
	Votre pseudo est dj membre du groupe de %s.
NICK_GROUP_NOT_AUTH
	Vous ne pouvez pas rejoindre un groupe dont l'adresse de courriel n'est pas authentifie.
NICK_GROUP_TOO_MANY
	Il y a trop de pseudos dans le groupe de %s; listez-les et 
	effacez-en quelques uns.
	Tapez /msg %s HELP GLIST et /msg %s HELP DROP pour
	plus d'informations.
NICK_GROUP_JOINED
	Votre pseudo a rejoint le groupe de %s.

# IDENTIFY responses
NICK_IDENTIFY_SYNTAX
	IDENTIFY motdepasse
NICK_IDENTIFY_NOT_AUTH
	Vous ne pouvez pas vous identifier  un pseudo dont l'adresse de courriel n'est pas authentifie.
NICK_IDENTIFY_NOT_AUTH_HOWTO
	Tapez /msg %s HELP AUTH pour plus d'information sur le processus d'authentification.
NICK_IDENTIFY_SUCCEEDED
	Mot de passe accept - vous tes maintenant identifi.
NICK_IDENTIFY_EMAIL_REQUIRED
	Vous devez maintenant associer une adresse de courriel 
	votre pseudo. Cela vous permettra de retrouver votre mot de
	passe au cas o vous l'oublieriez.
NICK_IDENTIFY_EMAIL_HOWTO
	Tapez /msg %s SET EMAIL e-mail pour dfinir votre
	adresse de courriel. Votre vie prive est respecte;
	cette adresse ne sera pas divulgue  des tiers.

# LOGOUT responses
NICK_LOGOUT_SYNTAX
	LOGOUT
NICK_LOGOUT_SUCCEEDED
	Votre pseudo n'est plus identifi.
NICK_LOGOUT_X_SUCCEEDED
	Le pseudo %s n'est plus identifi.

# AUTH responses
NICK_AUTH_SYNTAX
	AUTH [code | PASS | CANCEL] [code nouveau-mot-de-passe]
NICK_AUTH_UNAVAILABLE
	Dsol, l'authentification des adresses de courriel est dsactive.
NICK_AUTH_DISABLED
	Dsol, l'authentification des adresses de courriel est temporairement suspendue.
NICK_AUTH_NOT_IN_PROGRESS
	Il n'y a pas de processus d'authentification en cours.
NICK_AUTH_START_EMAIL_MISSING
	Vous devez configurer une adresse de courriel avant d'utiliser cette commande.
	Tapez /msg %s HELP SET EMAIL pour plus d'informations.
NICK_AUTH_START_AUTHENTIFIED
	Votre adresse de courriel est dj authentifie.
NICK_AUTH_START_ALREADY
	Il y a dj un processus d'authentification en cours.
NICK_AUTH_START_FAILED
	Dsol, le processus d'authentification n'a pas pu commencer. Veuillez ressayer ultrieurement.
NICK_AUTH_START_REQUIRED
	Nous souhaiterions vrifier la validit de votre adresse de courriel.
NICK_AUTH_START_REQUIRED_NO_IDENTIFY
	Nous souhaiterions vrifier la validit de votre adresse de courriel avant de vous permettre de vous identifier pour ce pseudo.
NICK_AUTH_START_DONE
	Un courriel contenant des instructions pour terminer le processus d'authentification vous a t envoy sur %s.
NICK_AUTH_START_DONE_PRIVATE
	Un courriel contenant des instructions pour terminer le processus d'authentification vous a t envoy.
NICK_AUTH_END_BAD_CODE
	%s n'est pas le bon code d'authentification.
NICK_AUTH_END_TOO_MANY
	Le processus d'authentification a t annul  cause d'un trop grand nombre de tentatives.
NICK_AUTH_END_FAILED
	Dsol, le processus d'authentification n'a pas pu se terminer. Veuillez ressayer ultrieurement.
NICK_AUTH_END_DONE
	Votre adresse de courriel est dsormais authentifie.
NICK_AUTH_PASS_UNAVAILABLE
	La commande AUTH PASS n'est pas disponible pour votre pseudo.
NICK_AUTH_CANCEL_DONE
	Le processus d'authentification a t annul.
NICK_AUTH_MAIL_SUBJECT
	Validation de l'adresse de courriel de votre pseudo %s
NICK_AUTH_MAIL_HEAD
	Bonjour,
NICK_AUTH_MAIL_LINE_1
	Ce message vous est envoy dans le cadre du processus d'authentification utilis par %s pour vrifier la validit de votre adresse de courriel et rduire les risques d'abus.
NICK_AUTH_MAIL_LINE_2
	Pour terminer le processus, veuillez taper la commande suivante: /msg %s AUTH %X
NICK_AUTH_MAIL_LINE_2_WEB
	Pour terminer le processus, veuillez cliquer sur ce lien: <%s>
NICK_AUTH_MAIL_LINE_3
	Si vous n'tes pas le propritaire du pseudo %s ou ne savez pas pourquoi vous recevez ce courriel, veuillez l'ignorer.
NICK_AUTH_MAIL_LINE_4
	Nous sommes  votre disposition sur le canal %s pour rpondre  vos questions ventuelles concernant nos politiques de scurit et de confidentialit.
NICK_AUTH_MAIL_LINE_5
	Les administrateurs de %s.

# DROP responses
NICK_DROP_DISABLED
	Dsol, l'effacement de pseudos est temporairement suspendu.
NICK_DROP_FAILED
	Dsol, l'effacement du pseudo a chou.
NICK_DROPPED
	Votre pseudo a t effac.
NICK_X_DROPPED
	Le pseudo %s a t effac.

# SET responses
NICK_SET_SYNTAX
	SET option paramtres
NICK_SET_SERVADMIN_SYNTAX
	SET [=pseudo] option paramtres
NICK_SET_DISABLED
	Dsol, la modification des options des pseudos est temporairement suspendue.
NICK_SET_UNKNOWN_OPTION
	L'option SET %s est inconnue.
NICK_SET_OPTION_DISABLED
	L'option %s est dsactive et ne peut tre modifie.

# SET GNAME responses
NICK_SET_GNAME_INVALID
	Le nouveau nom DOIT tre un pseudo membre de votre groupe de pseudos!
NICK_SET_GNAME_CHANGED
	Le nom du groupe est dsormais %s.
NICK_SET_SERVADMIN_GNAME_CHANGED
	Le nom du groupe de %s est dsormais %s.

# SET PASSWORD responses
NICK_SET_PASSWORD_FAILED
	Impossible de changer le mot de passe.
NICK_SET_PASSWORD_CHANGED
	Le mot de passe a t chang.
NICK_SET_SERVADMIN_PASSWORD_CHANGED
	Le mot de passe du pseudo %s a t chang.
NICK_SET_PASSWORD_CHANGED_TO
	Le mot de passe est dsormais %s.
NICK_SET_SERVADMIN_PASSWORD_CHANGED_TO
	Le mot de passe du pseudo %s est dsormais %s.

# SET LANGUAGE responses
NICK_SET_LANGUAGE_SYNTAX
	SET LANGUAGE numro
NICK_SET_LANGUAGE_UNKNOWN
	Numro de langue %d inconnu. Tapez /msg %s HELP SET LANGUAGE pour une liste de langues.
NICK_SET_LANGUAGE_CHANGED
	La langue associe au pseudo est dsormais le Franais.
NICK_SET_SERVADMIN_LANGUAGE_CHANGED
	La langue associe au pseudo %s est dsormais le Franais.

# SET URL responses
NICK_SET_URL_CHANGED
	L'adresse du site est dsormais %s.
NICK_SET_SERVADMIN_URL_CHANGED
	L'adresse du site du pseudo %s est dsormais %s.
NICK_SET_URL_UNSET
	L'adresse du site a t supprime.
NICK_SET_SERVADMIN_URL_UNSET
	L'adresse du site du pseudo %s a t supprime.

# SET EMAIL responses
NICK_SET_EMAIL_CHANGED
	L'adresse de courriel est dsormais %s.
NICK_SET_SERVADMIN_EMAIL_CHANGED
	L'adresse de courriel du pseudo %s est dsormais %s.
NICK_SET_EMAIL_UNSET
	L'adresse de courriel a t supprime.
NICK_SET_SERVADMIN_EMAIL_UNSET
	L'adresse de courriel du pseudo %s a t supprime.
NICK_SET_EMAIL_UNSET_IMPOSSIBLE
	Il est impossible de supprimer l'adresse de courriel sur ce rseau.

# SET IM responses
NICK_SET_IM_SYNTAX
	SET IM [logiciel identifiant]
NICK_SET_IM_UNSUPPORTED_TYPE
	%s n'est pas un logiciel de messagerie instantane valide. Les possibilits sont: %s.
NICK_SET_IM_CHANGED
	Les informations de messagerie instantane sont dsormais %s (%s).
NICK_SET_SERVADMIN_IM_CHANGED
	Les informations de messagerie instantane du pseudo %s sont dsormais %s (%s).
NICK_SET_IM_UNSET
	Les informations de messagerie instantane ont t supprimes.
NICK_SET_SERVADMIN_IM_UNSET
	Les informations de messagerie instantane du pseudo %s ont t supprimes.

# SET GREET responses
NICK_SET_GREET_CHANGED
	Le message d'accueil est dsormais %s.
NICK_SET_SERVADMIN_GREET_CHANGED
	Le message d'accueil du pseudo %s est dsormais %s.
NICK_SET_GREET_UNSET
	Le message d'accueil a t supprim.
NICK_SET_SERVADMIN_GREET_UNSET
	Le message d'accueil du pseudo %s a t supprim.

# SET KILL responses
NICK_SET_KILL_SYNTAX
	SET KILL {ON | QUICK | OFF}
NICK_SET_KILL_IMMED_SYNTAX
	SET KILL {ON | QUICK | IMMED | OFF}
NICK_SET_KILL_ON
	La protection est dsormais active.
NICK_SET_SERVADMIN_KILL_ON
	La protection du pseudo %s est dsormais active.
NICK_SET_KILL_QUICK
	La protection est dsormais active, avec un dlai rduit.
NICK_SET_SERVADMIN_KILL_QUICK
	La protection du pseudo %s est dsormais active, avec un dlai rduit.
NICK_SET_KILL_IMMED
	La protection est dsormais active, sans dlai.
NICK_SET_SERVADMIN_KILL_IMMED
	La protection du pseudo %s est dsormais active, sans dlai.
NICK_SET_KILL_IMMED_DISABLED
	L'option IMMED n'est pas disponible sur ce rseau.
NICK_SET_KILL_OFF
	La protection est dsormais dsactive.
NICK_SET_SERVADMIN_KILL_OFF
	La protection du pseudo %s est dsormais dsactive.

# SET SECURE responses
NICK_SET_SECURE_SYNTAX
	SET SECURE {ON | OFF}
NICK_SET_SECURE_ON
	La scurit est dsormais active.
NICK_SET_SERVADMIN_SECURE_ON
	La scurit du pseudo %s est dsormais active.
NICK_SET_SECURE_OFF
	La scurit est dsormais dsactive.
NICK_SET_SERVADMIN_SECURE_OFF
	La scurit du pseudo %s est dsormais dsactive.

# SET PRIVATE responses
NICK_SET_PRIVATE_SYNTAX
	SET PRIVATE {ON | OFF}
NICK_SET_PRIVATE_ON
	La confidentialit est dsormais active.
NICK_SET_SERVADMIN_PRIVATE_ON
	La confidentialit du pseudo %s est dsormais active.
NICK_SET_PRIVATE_OFF
	La confidentialit est dsormais dsactive.
NICK_SET_SERVADMIN_PRIVATE_OFF
	La confidentialit du pseudo %s est dsormais dsactive.

# SET HIDE responses
NICK_SET_HIDE_SYNTAX
	SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
NICK_SET_HIDE_EMAIL_ON
	L'adresse de courriel ne sera plus affiche par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_EMAIL_ON
	L'adresse de courriel du pseudo %s ne sera plus affiche par la commande INFO de %s.
NICK_SET_HIDE_EMAIL_OFF
	L'adresse de courriel sera affiche par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_EMAIL_OFF
	L'adresse de courriel du pseudo %s sera affiche par la commande INFO de %s.
NICK_SET_HIDE_MASK_ON
	Le masque utilisateur ne sera plus affich par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_MASK_ON
	Le masque utilisateur du pseudo %s ne sera plus affich par la commande INFO de %s.
NICK_SET_HIDE_MASK_OFF
	Le masque utilisateur sera affich par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_MASK_OFF
	Le masque utilisateur du pseudo %s sera affich par la commande INFO de %s.
NICK_SET_HIDE_QUIT_ON
	La dernire raison de /QUIT ne sera plus affiche par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_QUIT_ON
	La dernire raison de /QUIT du pseudo %s ne sera plus affiche par la commande INFO de %s.
NICK_SET_HIDE_QUIT_OFF
	La dernire raison de /QUIT sera affiche par la commande INFO de %s.
NICK_SET_SERVADMIN_HIDE_QUIT_OFF
	La dernire raison de /QUIT du pseudo %s sera affiche par la commande INFO de %s.

# SET HOST responses
NICK_SET_HOST_SYNTAX
	SET HOST {ON | OFF}
NICK_SET_HOST_UNSET
	Aucun nom d'hte personnalis n'est attribu actuellement.
NICK_SET_HOST_ON
	Le nom d'hte personnalis est dsormais activ.
NICK_SET_SERVADMIN_HOST_ON
	Le nom d'hte personnalis du pseudo %s est dsormais activ.
NICK_SET_HOST_OFF
	Le nom d'hte personnalis est dsormais dsactiv.
NICK_SET_SERVADMIN_HOST_OFF
	Le nom d'hte personnalis du pseudo %s est dsormais dsactiv.

# SET NOEXPIRE responses
NICK_SET_NOEXPIRE_SYNTAX
	SET [pseudo] NOEXPIRE {ON | OFF}
NICK_SET_NOEXPIRE_ON
	Le pseudo %s n'expirera pas.
NICK_SET_NOEXPIRE_OFF
	Le pseudo %s expirera.

# ACCESS responses
NICK_ACCESS_SYNTAX
	ACCESS {ADD | DEL | LIST | CLEAR} {masque | liste-d'entres}
NICK_ACCESS_ADD_SYNTAX
	ACCESS ADD masque
NICK_ACCESS_DEL_SYNTAX
	ACCESS %s {masque | liste-d'entres}
NICK_ACCESS_DISABLED
	Dsol, la modification de la liste d'accs est temporairement suspendue.
NICK_ACCESS_EMPTY
	La liste d'accs est vide.
NICK_ACCESS_MASK_INVALID
	%s n'est pas un masque d'accs valide.
NICK_ACCESS_MASK_NO_NICK
	Rappel: Les masques d'accs ne peuvent pas contenir de pseudos; assurez-vous de ne pas avoir inclus la partie pseudo dans votre masque.
NICK_ACCESS_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
NICK_ACCESS_ALREADY_PRESENT
	Le masque %s est dj dans la liste d'accs.
NICK_ACCESS_REACHED_LIMIT
	Dsol, il ne peut y avoir que %d entres dans la liste d'accs.
NICK_ACCESS_CREATION_FAILED
	Dsol, la cration d'une nouvelle entre dans la liste d'accs a chou.
NICK_ACCESS_ADDED
	%s a t ajout  la liste d'accs.
NICK_ACCESS_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste d'accs.
NICK_ACCESS_NOT_FOUND
	%s n'a pas t trouv dans la liste d'accs.
NICK_ACCESS_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste d'accs.
NICK_ACCESS_DELETED
	%s a t supprim de la liste d'accs.
NICK_ACCESS_DELETED_ONE
	1 entre a t supprime de la liste d'accs.
NICK_ACCESS_DELETED_SEVERAL
	%d entres ont t supprimes de la liste d'accs.
NICK_ACCESS_LIST_HEADER
	Liste d'accs:
NICK_ACCESS_LIST_COLHEAD
	  Num   Masque
# mask, reason
NICK_ACCESS_LIST_FORMAT
	  %3d   %s
NICK_ACCESS_LISTED_ONE
	1 entre a t affiche.
NICK_ACCESS_LISTED_SEVERAL
	%d entres ont t affiches.
NICK_ACCESS_CLEAR_PARTIALLY
	La liste d'accs a t partiellement vide.
NICK_ACCESS_CLEAR
	La liste d'accs a t vide.

# INFO responses
NICK_INFO_SYNTAX
	INFO pseudo [ALL]
NICK_INFO_REALNAME
	%s est %s
NICK_INFO_SERVICES_OPER
	%s est oprateur des services.
NICK_INFO_SERVICES_ADMIN
	%s est administrateur des services.
NICK_INFO_ADDRESS
	            Adresse: %s
NICK_INFO_ADDRESS_ONLINE
	   Connect(e) sous: %s
NICK_INFO_ADDRESS_ONLINE_NOHOST
	%s est actuellement connect(e).
NICK_INFO_TIME_REGGED
	      Enregistr le: %s
NICK_INFO_GROUP_CREATED
	     Groupe cr le: %s
NICK_INFO_LAST_SEEN
	  Dernire prsence: %s
NICK_INFO_LAST_QUIT
	      Dernier /QUIT: %s
NICK_INFO_URL
	Adresse de son site: %s
NICK_INFO_EMAIL
	Adresse de courriel: %s
NICK_INFO_EMAIL_AUTH
	Adresse de courriel: %s (authentifie)
NICK_INFO_IM
	%19s: %s
NICK_INFO_GREET
	  Message d'accueil: %s
NICK_INFO_CUSTOM_HOST
	   Nom d'hte perso: %s
NICK_INFO_CUSTOM_HOST_WHO
	   Nom d'hte perso: %s (mis par %s le %s)
NICK_INFO_OPTIONS
	            Options: %s
# These strings MUST NOT be empty
NICK_INFO_OPT_KILL
	Protection
NICK_INFO_OPT_SECURE
	Scurit
NICK_INFO_OPT_PRIVATE
	Confidentialit
NICK_INFO_OPT_CUSTOM_HOST
	Nom d'hte personnalis
NICK_INFO_OPT_NONE
	Aucune
NICK_INFO_PENDING_EXPIRE
	Ce pseudo risque d'expirer bientt.
NICK_INFO_NO_EXPIRE
	Ce pseudo n'expirera pas.
NICK_INFO_FOR_MORE
	Pour plus d'informations, tapez /msg %s INFO %s ALL.

# LIST responses
NICK_LIST_SYNTAX
	LIST [[modle] [liste]]
NICK_LIST_SERVADMIN_SYNTAX
	LIST [[modle] [liste] [NOLIMIT] [NOEXPIRE]]
NICK_LIST_INVALID_RANGE
	%s n'est pas une liste de rsultats valide.
NICK_LIST_NO_NICKS_MATCH
	Il n'y a aucun pseudo enregistr correspondant  %s.
NICK_LIST_HEADER
	Liste des pseudos enregistrs correspondant  %s:
NICK_LIST_HEADER_NO_PATTERN
	Liste des pseudos enregistrs:
NICK_LIST_RESULTS
	Fin de la liste - %d/%d rsultats affichs.
NICK_LIST_RESULTS_RANGE
	Fin de la liste - Rsultats %d  %d affichs.
NICK_LIST_RESULTS_RANGE_ONE
	Fin de la liste - Rsultat %d affich.

# GLIST responses
NICK_GLIST_HEADER
	Liste des pseudos dans votre groupe %s:
	  Pseudo               Date d'expiration
NICK_GLIST_HEADER_X
	Liste des pseudos dans le groupe de %s:
	  Pseudo               Date d'expiration
NICK_GLIST_ENTRY
	  %-20s %s
NICK_GLIST_ENTRY_PENDING
	  %-20s Imminente
NICK_GLIST_ENTRY_NOEXPIRE
	  %-20s Jamais
NICK_GLIST_FOOTER
	%d pseudos dans le groupe.

# RECOVER responses
NICK_RECOVER_SYNTAX
	RECOVER pseudo [motdepasse]
NICK_NO_RECOVER_SELF
	Vous ne pouvez pas utiliser la commande RECOVER sur vous-mme!
NICK_RECOVERED
	L'utilisateur se servant de votre pseudo a t dconnect.
	Tapez /msg %s RELEASE %s si vous souhaitez le rcuprer avant que la minute de tutelle ne soit coule.

# RELEASE responses
NICK_RELEASE_SYNTAX
	RELEASE pseudo [motdepasse]
NICK_RELEASE_NOT_HELD
	Le pseudo %s n'est pas sous tutelle.
NICK_RELEASED
	La tutelle des services sur votre pseudo a t te.

# GHOST responses
NICK_GHOST_SYNTAX
	GHOST pseudo [motdepasse]
NICK_NO_GHOST_SELF
	Vous ne pouvez pas utiliser la commande GHOST sur vous-mme!
NICK_GHOST_KILLED
	L'utilisateur fantme utilisant votre pseudo a t dconnect.

# HOST responses
NICK_HOST_SYNTAX
	HOST {SET | LIST} [pseudo | masque] [hte-perso | liste]
NICK_HOST_UNAVAILABLE
	La commande HOST n'est pas disponible sur ce rseau.
NICK_HOST_SET_DISABLED
	Dsol, la modification des noms d'htes personnaliss est temporairement suspendue.
NICK_HOST_TOO_LONG
	Le nom d'hte personnalis est trop long (limit  %d caractres).
NICK_HOST_INVALID
	Les noms d'htes personnaliss ne peuvent contenir que des caractres alphanumriques, des points et des tirets et doivent comporter au moins un point.
NICK_HOST_TOO_YOUNG
	Ce groupe a t cr trop rcemment. Vous ne pouvez pas encore dfinir de nom d'hte personnalis.
NICK_HOST_TOO_FAST
	Le nom d'hte personnalis  de ce groupe a t modifi trop rcemment. Vous ne pouvez pas en changer encore pour le moment.
NICK_HOST_UNCHANGED
	Votre nom d'hte personnalis tait dj %s.
NICK_HOST_UNCHANGED_X
	Le nom d'hte personnalis de %s tait dj %s.
NICK_HOST_SET_FAILED
	Dsol, le nom d'hte personnalis n'a pu tre chang.
NICK_HOST_CHANGED
	Votre nom d'hte personnalis est dsormais %s.
NICK_HOST_CHANGED_X
	Le nom d'hte personnalis de %s est dsormais %s.
NICK_HOST_UNSET
	Votre nom d'hte personnalis a t supprim.
NICK_HOST_UNSET_X
	Le nom d'hte personnalis de %s a t supprim.
NICK_HOST_INVALID_RANGE
	%s n'est pas une liste de rsultats valide.
NICK_HOST_LIST_HEADER
	Liste des noms d'hte personnaliss:
NICK_HOST_LIST_HEADER_MATCH
	Liste des noms d'hte personnaliss correspondant  %s:
NICK_HOST_LIST_ENTRY
	%-15s  %s (par %s le %s)
NICK_HOST_LIST_RESULTS
	Fin de la liste - %d/%d rsultats affichs.
NICK_HOST_LIST_RESULTS_RANGE
	Fin de la liste - Rsultats %d  %d affichs.
NICK_HOST_LIST_RESULTS_RANGE_ONE
	Fin de la liste - Rsultat %d affich.

# GETPASS responses
NICK_GETPASS_SYNTAX
	GETPASS pseudo
NICK_GETPASS_DISABLED
	Dsol, la rcupration des mots de passe des pseudos est temporairement suspendue.
NICK_GETPASS_UNAVAILABLE
	La commande GETPASS est indisponible car l'encryption des mots de passe est active.
NICK_GETPASS_PASSWORD_IS
	Le mot de passe de %s est %s.

# SENDPASS responses
NICK_SENDPASS_SYNTAX
	SENDPASS pseudo
NICK_SENDPASS_DISABLED
	Dsol, la rcupration des mots de passe des pseudos est temporairement suspendue.
NICK_SENDPASS_UNAVAILABLE
	La commande SENDPASS est indisponible car l'encryption des mots de passe est active.
NICK_SENDPASS_UNCONFIGURED
	Dsol, la commande SENDPASS est indisponible.
NICK_SENDPASS_SUBJECT
	Mot de passe du pseudo %s
NICK_SENDPASS_HEAD
	Bonjour,
NICK_SENDPASS_LINE_1
	Vous avez demand  recevoir le mot de passe du pseudo %s par courriel.
NICK_SENDPASS_LINE_2
	Le mot de passe est %s. Pour des raisons de scurit, il vous est recommand d'en changer ds  prsent.
NICK_SENDPASS_LINE_2_ENCRYPTION
	Malheureusement, pour des raisons de scurit, nous ne pouvons vous communiquer le mot de passe que vous aviez dfini. Vous pouvez toutefois en changer en tapant la commande suivante: /msg %s AUTH PASS %X nouveau-mot-de-passe
NICK_SENDPASS_LINE_3
	Si vous ne savez pas pourquoi ce courriel vous a t envoy, il s'agit probablement d'une erreur; nous vous prions de nous en excuser et vous demandons d'ignorer ce message.
NICK_SENDPASS_LINE_4
	NE REPONDEZ PAS A CE COURRIEL !
NICK_SENDPASS_LINE_5
	Les administrateurs de %s.
NICK_SENDPASS_FAILURE
	Le mot de passe de %s n'a pas pu tre envoy.
NICK_SENDPASS_FAILURE_TEMPORARY
	Le mot de passe de %s n'a pas pu tre envoy; veuillez ressayer ultrieurement.
NICK_SENDPASS_OK
	Le mot de passe de %s a t envoy.

###########################################################################
#
# ChanServ messages
#
###########################################################################

# Access level descriptions
CHAN_LEVEL_AUTOOP
	Status automatique d'oprateur du canal
CHAN_LEVEL_AUTOVOICE
	Mode +v automatique sur le canal
CHAN_LEVEL_AUTOHALFOP
	Mode +h automatique sur le canal
CHAN_LEVEL_AUTOPROTECT
	Mode +a automatique sur le canal
CHAN_LEVEL_AUTODEOP
	Non autoris(e)  avoir le status d'oprateur du canal
CHAN_LEVEL_NOJOIN
	Non autoris(e)  joindre le canal s'il est restreint
CHAN_LEVEL_INVITE
	Autoris(e)  utiliser la commande INVITE
CHAN_LEVEL_AKICK
	Autoris(e)  utiliser la commande AKICK
CHAN_LEVEL_SET
	Autoris(e)  utiliser la commande SET (sauf SET FOUNDER/PASSWORD)
CHAN_LEVEL_CLEAR
	Autoris(e)  utiliser la commande CLEAR
CHAN_LEVEL_UNBAN
	Autoris(e)  utiliser la commande UNBAN
CHAN_LEVEL_OPDEOP
	Autoris(e)  utiliser les commandes OP/DEOP
CHAN_LEVEL_ACCESS_LIST
	Autoris(e)  voir la liste d'accs
CHAN_LEVEL_ACCESS_CHANGE
	Autoris(e)  modifier la liste d'accs
CHAN_LEVEL_MEMO
	Autoris(e)  lister/lire les mmos
CHAN_LEVEL_ASSIGN
	Autoris(e)  attribuer/retirer un robot
CHAN_LEVEL_BADWORDS
	Autoris(e)  utiliser la commande BADWORDS
CHAN_LEVEL_NOKICK
	Jamais expuls(e) par les expulseurs du robot
CHAN_LEVEL_FANTASIA
	Autoris(e)  utiliser les commandes fantaisistes
CHAN_LEVEL_SAY
	Autoris(e)  utiliser les commandes ACT et SAY
CHAN_LEVEL_GREET
	Message d'accueil affich
CHAN_LEVEL_VOICEME
	Autoris(e)  se donner/s'ter le mode +v
CHAN_LEVEL_VOICE
	Autoris(e)  utiliser les commandes VOICE/DEVOICE
CHAN_LEVEL_GETKEY
	Autoris(e)  utiliser la commande GETKEY
CHAN_LEVEL_OPDEOPME
	Autoris(e)  se donner/se supprimer le status d'oprateur
CHAN_LEVEL_HALFOPME
	Autoris(e)  se donner/s'ter le mode +h
CHAN_LEVEL_HALFOP
	Autoris(e)  utiliser les commandes HALFOP/DEHALFOP
CHAN_LEVEL_PROTECTME
	Autoris(e)  se donner/s'ter le mode +a
CHAN_LEVEL_PROTECT
	Autoris(e)  utiliser les commandes PROTECT/DEPROTECT
CHAN_LEVEL_KICKME
	Autoris(e)  s'expulser
CHAN_LEVEL_KICK
	Autoris(e)  utiliser la commande KICK
CHAN_LEVEL_SIGNKICK
	Dispens(e) de signature pour la commande KICK quand SIGNKICK LEVEL est activ
CHAN_LEVEL_BANME
	Autoris(e)  se bannir
CHAN_LEVEL_BAN
	Autoris(e)  utiliser la commande BAN
CHAN_LEVEL_TOPIC
	Autoris(e)  utiliser la commande TOPIC
CHAN_LEVEL_INFO
	Autoris(e)  utiliser la commande INFO avec l'option ALL

# Automatic responses
CHAN_IS_REGISTERED
	Ce canal a t enregistr avec %s.
CHAN_NOT_ALLOWED_OP
	Vous ne pouvez pas tre oprateur du canal %s.
CHAN_NOT_ALLOWED_TO_JOIN
	Vous n'tes pas autoris  tre sur ce canal.

# REGISTER responses
CHAN_REGISTER_SYNTAX
	REGISTER canal motdepasse description
CHAN_REGISTER_DISABLED
	Dsol, l'enregistrement de canaux est temporairement suspendu.
CHAN_REGISTER_NOT_LOCAL
	Les canaux locaux ne peuvent pas tre enregistrs.
CHAN_MUST_REGISTER_NICK
	Vous devez d'abord enregistrer votre pseudo. Tapez /msg %s HELP pour savoir comment faire.
CHAN_MUST_IDENTIFY_NICK
	Vous devez d'abord vous identifier avec %s, en utilisant la commande:
	/msg %s IDENTIFY motdepasse
CHAN_REGISTER_NOT_AUTH
	Vous devez authentifier votre adresse de courriel avant de pouvoir enregistrer un canal.
CHAN_REGISTER_NOT_AUTH_HOWTO
	Tapez /msg %s HELP AUTH pour plus d'information sur le processus d'authentification.
CHAN_ALREADY_REGISTERED
	Le canal %s est dj enregistr!
CHAN_MUST_BE_CHANOP
	Vous devez tre oprateur sur le canal pour l'enregistrer.
CHAN_REACHED_CHANNEL_LIMIT
	Dsol, vous avez dj atteint votre limite de %d canaux enregistrs.
CHAN_EXCEEDED_CHANNEL_LIMIT
	Dsol, vous avez dj dpass votre limite de %d canaux enregistrs.
CHAN_REGISTRATION_FAILED
	Dsol, l'enregistrement a chou.
CHAN_REGISTERED
	Le canal %s a t enregistr sous votre pseudo: %s
CHAN_PASSWORD_IS
	Le mot de passe du canal est %s - notez le pour une utilisation ultrieure.

# IDENTIFY responses
CHAN_IDENTIFY_SYNTAX
	IDENTIFY canal motdepasse
CHAN_IDENTIFY_NOT_AUTH
	Vous devez authentifier votre adresse de courriel avant de pouvoir vous identifier  un canal.
CHAN_IDENTIFY_NOT_AUTH_HOWTO
	Tapez /msg %s HELP AUTH pour plus d'information sur le processus d'authentification.
CHAN_IDENTIFY_SUCCEEDED
	Mot de passe accept - vous avez maintenant un niveau
	d'accs quivalent  celui du propritaire de %s.

# LOGOUT responses
CHAN_LOGOUT_SYNTAX
	LOGOUT canal pseudo
CHAN_LOGOUT_SERVADMIN_SYNTAX
	LOGOUT canal [pseudo]
CHAN_LOGOUT_SUCCEEDED
	L'utilisateur %s n'est plus identifi pour le canal %s.
CHAN_LOGOUT_ALL_SUCCEEDED
	Tous les utilisateurs prcdemment identifis au canal %s ne le sont plus.

# DROP responses
CHAN_DROP_SYNTAX
	DROP canal
CHAN_DROP_DISABLED
	Dsol, l'effacement de canaux est temporairement suspendu.
CHAN_DROP_FAILED
	Dsol, l'effacement a chou.
CHAN_DROPPED
	Le canal %s a t effac.

# SET responses
CHAN_SET_SYNTAX
	SET canal option paramtres
CHAN_SET_DISABLED
	Dsol, la configuration des options du canal est temporairement suspendue.
CHAN_SET_UNKNOWN_OPTION
	Option SET %s inconnue.

# SET FOUNDER responses
CHAN_SET_FOUNDER_NOT_AUTH
	%s n'est pas autoris  tre propritaire car son adresse de courriel n'est pas authentifie.
CHAN_SET_FOUNDER_TOO_MANY_CHANS
	%s a trop de canaux enregistrs.
CHAN_FOUNDER_CHANGED
	Le propritaire de %s est dsormais %s.

# SET SUCCESSOR responses
CHAN_SUCCESSOR_IS_FOUNDER
	%s ne peut pas tre  la fois successeur et propritaire du canal %s.
CHAN_SET_SUCCESSOR_NOT_AUTH
	%s n'est pas autoris  tre successeur car son adresse de courriel n'est pas authentifie.
CHAN_SUCCESSOR_CHANGED
	Le successeur de %s est dsormais %s.
CHAN_SUCCESSOR_UNSET
	Il n'y a plus de successeur sur %s.

# SET PASSWORD responses
CHAN_SET_PASSWORD_FAILED
	Impossible de changer le mot de passe.
CHAN_PASSWORD_CHANGED
	Le mot de passe de %s a t chang.
CHAN_PASSWORD_CHANGED_TO
	Le mot de passe de %s est dsormais %s.

# SET DESC responses
CHAN_DESC_CHANGED
	La description de %s est dsormais %s.

# SET URL responses
CHAN_URL_CHANGED
	L'adresse du site de %s est dsormais %s.
CHAN_URL_UNSET
	L'adresse du site de %s a t supprime.

# SET EMAIL responses
CHAN_EMAIL_CHANGED
	L'adresse de courriel de %s est dsormais %s.
CHAN_EMAIL_UNSET
	L'adresse de courriel de %s a t supprime.

# SET ENTRYMSG responses
CHAN_ENTRY_MSG_CHANGED
	Le message d'entre de %s a t chang.
CHAN_ENTRY_MSG_UNSET
	Le message d'entre de %s a t supprim.
	
# SET BANTYPE responses
CHAN_SET_BANTYPE_INVALID
	%s n'est pas un type de bannissement valide.
CHAN_SET_BANTYPE_CHANGED
	Le type de bannissement du canal %s est dsormais le numro %d.

# SET MLOCK responses
CHAN_SET_MLOCK_UNKNOWN_CHAR
	Le mode %c a t ignor car il est inconnu.
CHAN_SET_MLOCK_IMPOSSIBLE_CHAR
	Le mode %c a t ignor car il ne peut tre maintenu.
CHAN_SET_MLOCK_L_REQUIRED
	Verrouiller le mode +L impose que le mode +l le soit galement.
CHAN_SET_MLOCK_K_REQUIRED
	Verrouiller le mode +K impose que le mode +i le soit galement.
CHAN_MLOCK_CHANGED
	Les modes verrouills du canal %s sont dsormais %s.

# SET KEEPTOPIC responses
CHAN_SET_KEEPTOPIC_SYNTAX
	SET canal KEEPTOPIC {ON | OFF}
CHAN_SET_KEEPTOPIC_ON
	Le maintien du topic est maintenant activ.
CHAN_SET_KEEPTOPIC_OFF
	Le maintien du topic est maintenant dsactiv.

# SET TOPICLOCK responses
CHAN_SET_TOPICLOCK_SYNTAX
	SET canal TOPICLOCK {ON | OFF}
CHAN_SET_TOPICLOCK_ON
	Le verrouillage du topic est maintenant activ.
CHAN_SET_TOPICLOCK_OFF
	Le verrouillage du topic est maintenant dsactiv.

# SET PEACE responses
CHAN_SET_PEACE_SYNTAX
	SET canal PEACE {ON | OFF}
CHAN_SET_PEACE_ON
	L'option de paix est maintenant active.
CHAN_SET_PEACE_OFF
	L'option de paix est maintenant dsactive.

# SET PRIVATE responses
CHAN_SET_PRIVATE_SYNTAX
	SET canal PRIVATE {ON | OFF}
CHAN_SET_PRIVATE_ON
	La confidentialit est dsormais active.
CHAN_SET_PRIVATE_OFF
	La confidentialit est dsormais dsactive.

# SET SECUREOPS responses
CHAN_SET_SECUREOPS_SYNTAX
	SET canal SECUREOPS {ON | OFF}
CHAN_SET_SECUREOPS_ON
	Le contrle des oprateurs est dsormais activ.
CHAN_SET_SECUREOPS_OFF
	Le contrle des oprateurs est dsormais dsactiv.
	
# SET SECUREFOUNDER responses
CHAN_SET_SECUREFOUNDER_SYNTAX
	SET canal SECUREFOUNDER {ON | OFF}
CHAN_SET_SECUREFOUNDER_ON
	Le contrle du propritaire est dsormais activ.
CHAN_SET_SECUREFOUNDER_OFF
	Le contrle du propritaire est dsormais dsactiv.

# SET RESTRICTED responses
CHAN_SET_RESTRICTED_SYNTAX
	SET canal RESTRICTED {ON | OFF}
CHAN_SET_RESTRICTED_ON
	L'accs restreint est dsormais activ.
CHAN_SET_RESTRICTED_OFF
	L'accs restreint est dsormais dsactiv.

# SET SECURE responses
CHAN_SET_SECURE_SYNTAX
	SET canal SECURE {ON | OFF}
CHAN_SET_SECURE_ON
	La scurit est dsormais active.
CHAN_SET_SECURE_OFF
	La scurit est dsormais dsactive.
	
# SET SIGNKICK responses
CHAN_SET_SIGNKICK_SYNTAX
	SET canal SIGNKICK {ON | LEVEL | OFF}
CHAN_SET_SIGNKICK_ON
	Les expulsions signes sont dsormais actives.
CHAN_SET_SIGNKICK_LEVEL
	Les expulsions signes sont dsormais actives, selon le niveau de l'utilisateur utilisant la commande.
CHAN_SET_SIGNKICK_OFF
	Les expulsions signes sont dsormais dsactives.

# SET OPNOTICE responses
CHAN_SET_OPNOTICE_SYNTAX
	SET canal OPNOTICE {ON | OFF}
CHAN_SET_OPNOTICE_ON
	La notice sur OP/DEOP est dsormais active.
CHAN_SET_OPNOTICE_OFF
	La notice sur OP/DEOP est dsormais dsactive.

# SET NOEXPIRE responses
CHAN_SET_NOEXPIRE_SYNTAX
	SET canal NOEXPIRE {ON | OFF}
CHAN_SET_NOEXPIRE_ON
	Le canal %s n'expirera pas.
CHAN_SET_NOEXPIRE_OFF
	Le canal %s expirera normalement.

# ACCESS messages
CHAN_ACCESS_SYNTAX
	ACCESS canal {ADD | DEL | LIST | CLEAR} [pseudo [niveau] | liste-d'entres]
CHAN_ACCESS_ADD_SYNTAX
	ACCESS canal ADD pseudo niveau
CHAN_ACCESS_DEL_SYNTAX
	ACCESS canal %s {pseudo | liste-d'entres}
CHAN_ACCESS_DISABLED
	Dsol, la modification des listes d'accs des canaux est temporairement suspendue.
CHAN_ACCESS_EMPTY
	La liste d'accs de %s est vide.
CHAN_ACCESS_NOT_AUTH
	%s n'est pas autoris  tre dans la liste d'accs car son adresse de courriel n'est pas authentifie.
CHAN_ACCESS_LEVEL_INVALID
	%s n'est pas un niveau d'accs valide.
CHAN_ACCESS_LEVEL_NONZERO
	Le niveau d'accs ne peut pas tre zro.
CHAN_ACCESS_LEVEL_RANGE
	Le niveau d'accs doit tre compris entre %d et %d inclus.
CHAN_ACCESS_NICKS_ONLY
	Les listes d'accs des canaux ne peuvent contenir que des pseudos enregistrs.
CHAN_ACCESS_REACHED_LIMIT
	Dsol, il ne peut y avoir que %d entres dans la liste d'accs d'un canal.
CHAN_ACCESS_CREATION_FAILED
	Dsol, la cration d'une nouvelle entre dans la liste d'accs a chou.
CHAN_ACCESS_LEVEL_UNCHANGED
	Le niveau d'accs de %s sur %s est inchang.
CHAN_ACCESS_LEVEL_CHANGED
	Le niveau d'accs de %s sur %s est dsormais de %d.
CHAN_ACCESS_ADDED
	%s a t ajout  la liste d'accs de %s au niveau %d.
CHAN_ACCESS_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste d'accs de %s.
CHAN_ACCESS_NOT_FOUND
	%s n'a pas t trouv dans la liste d'accs de %s.
CHAN_ACCESS_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste d'accs de %s.
CHAN_ACCESS_DELETED
	%s a t supprim de la liste d'accs de %s.
CHAN_ACCESS_DELETED_ONE
	1 entre a t supprime de la liste d'accs de %s.
CHAN_ACCESS_DELETED_SEVERAL
	%d entres ont t supprimes de la liste d'accs de %s.
CHAN_ACCESS_LIST_HEADER
	Liste d'accs de %s:
CHAN_ACCESS_LIST_COLHEAD
	  Num   Niv  Pseudo
CHAN_ACCESS_LIST_FORMAT
	  %3d  %4d  %s
CHAN_ACCESS_LISTED_ONE
	1 entre a t affiche.
CHAN_ACCESS_LISTED_SEVERAL
	%d entres ont t affiches.
CHAN_ACCESS_CLEAR_PARTIALLY
	La liste d'accs de %s a t partiellement vide.
CHAN_ACCESS_CLEAR
	La liste d'accs de %s a t vide.

# AKICK responses
CHAN_AKICK_SYNTAX
	AKICK canal {ADD | STICK | UNSTICK | DEL | LIST | VIEW | ENFORCE | CLEAR} [pseudo-ou-masque-utilisateur [raison] | liste-d'entres]
CHAN_AKICK_ADD_SYNTAX
	AKICK canal ADD pseudo-ou-masque-utilisateur [raison]
CHAN_AKICK_DEL_SYNTAX
	AKICK canal %s {masque | liste-d'entres}
CHAN_AKICK_STICK_SYNTAX
	AKICK canal %s masque
CHAN_AKICK_DISABLED
	Dsol, la modification de la liste des expulsions automatiques du canal est temporairement suspendue.
CHAN_AKICK_EMPTY
	la liste des expulsions automatiques de %s est vide.
CHAN_AKICK_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
CHAN_AKICK_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
CHAN_AKICK_ALREADY_PRESENT
	%s est dj dans la liste des expulsions automatiques de %s.
CHAN_AKICK_REACHED_LIMIT
	Dsol, il ne peut y avoir que %d entres dans la liste des expulsions automatiques d'un canal.
CHAN_AKICK_CREATION_FAILED
	Dsol, la cration d'une nouvelle entre dans la liste des expulsions automatiques a chou.
CHAN_AKICK_ADDED
	%s a t ajout  la liste des expulsions automatiques de %s.
CHAN_AKICK_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des expulsions automatiques de %s.
CHAN_AKICK_NOT_FOUND
	%s n'a pas t trouv dans la liste des expulsions automatiques de %s.
CHAN_AKICK_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des expulsions automatiques de %s.
CHAN_AKICK_STUCK
	%s est dsormais maintenu en permanence sur le canal %s.
CHAN_AKICK_UNSTUCK
	%s n'est plus maintenu en permanence sur le canal %s.
CHAN_AKICK_DELETED
	%s a t supprim de la liste des expulsions automatiques de %s.
CHAN_AKICK_DELETED_ONE
	1 entre a t supprime de la liste des expulsions automatiques de %s.
CHAN_AKICK_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des expulsions automatiques de %s.
CHAN_AKICK_LIST_HEADER
	Liste des expulsions automatiques de %s:
CHAN_AKICK_LIST_FORMAT
	  %3d %s (%s)
CHAN_AKICK_VIEW_FORMAT
	%3d %s (par %s le %s; %s)
	    %s
CHAN_AKICK_VIEW_FORMAT_STUCK
	%3d %s (par %s le %s; maintenu)
	    %s
CHAN_AKICK_LISTED_ONE
	1 entre a t affiche.
CHAN_AKICK_LISTED_SEVERAL
	%d entres ont t affiches.
CHAN_AKICK_ENFORCE_DONE
	L'application des expulsions automatiques de %s est termine;
	%d utilisateurs taient concerns.
CHAN_AKICK_CLEAR_PARTIALLY
	La liste des expulsions automatiques de %s a t partiellement vide.
CHAN_AKICK_CLEAR
	La liste des expulsions automatiques de %s a t vide.

# LEVELS responses
CHAN_LEVELS_SYNTAX
	LEVELS canal {SET | DIS[ABLE] | LIST | RESET} [option [niveau]]
CHAN_LEVELS_RANGE
	Le niveau doit tre compris entre %d et %d inclus.
CHAN_LEVELS_CHANGED
	Le niveau requis pour %s du canal %s est dsormais de %d.
CHAN_LEVELS_UNKNOWN
	L'option %s est inconnue. Tapez /msg %s HELP LEVELS DESC pour une 
	liste d'options valides.
CHAN_LEVELS_DISABLED
	Le niveau %s est maintenant dsactiv sur le canal %s.
CHAN_LEVELS_LIST_HEADER
	Options de niveau d'accs du canal %s:
CHAN_LEVELS_LIST_DISABLED
	    %-*s  (dsactiv)
CHAN_LEVELS_LIST_FOUNDER
	    %-*s  (propritaire uniquement)
CHAN_LEVELS_LIST_NORMAL
	    %-*s  %d
CHAN_LEVELS_RESET
	Les niveaux d'accs de %s ont t rinitialiss  leur valeur par dfaut.

# INFO responses
CHAN_INFO_SYNTAX
	INFO canal [ALL]
CHAN_INFO_HEADER
	Informations pour le canal %s:
CHAN_INFO_FOUNDER
	        Propritaire: %s (%s)
CHAN_INFO_NO_FOUNDER
	        Propritaire: %s
CHAN_INFO_SUCCESSOR
	          Successeur: %s (%s)
CHAN_INFO_NO_SUCCESSOR
	          Successeur: %s
CHAN_INFO_DESCRIPTION
	         Description: %s
CHAN_INFO_ENTRYMSG
	    Message d'entre: %s
CHAN_INFO_TIME_REGGED
	          Enregistr: %s
CHAN_INFO_LAST_USED
	Dernire utilisation: %s
CHAN_INFO_LAST_TOPIC
	       Dernier topic: %s
CHAN_INFO_TOPIC_SET_BY
	    Topic chang par: %s
CHAN_INFO_URL
	     Adresse du site: %s
CHAN_INFO_EMAIL
	 Adresse de courriel: %s
CHAN_INFO_BANTYPE
	Type de bannissement: %d
CHAN_INFO_OPTIONS
	             Options: %s
CHAN_INFO_MODE_LOCK
	   Modes verrouills: %s
CHAN_INFO_OPT_KEEPTOPIC
	Maintien du topic
CHAN_INFO_OPT_OPNOTICE
	Notice sur OP/DEOP
CHAN_INFO_OPT_PEACE
	Paix
CHAN_INFO_OPT_PRIVATE
	Confidentialit
CHAN_INFO_OPT_RESTRICTED
	Accs restreint
CHAN_INFO_OPT_SECURE
	Scurit
CHAN_INFO_OPT_SECUREOPS
	Contrle des oprateurs
CHAN_INFO_OPT_SECUREFOUNDER
	Contrle du propritaire
CHAN_INFO_OPT_SIGNKICK
	Expulsions signes
CHAN_INFO_OPT_TOPICLOCK
	Verrouillage du topic
CHAN_INFO_OPT_NONE
	Aucune
CHAN_INFO_PENDING_EXPIRE
	Ce canal risque d'expirer bientt.
CHAN_INFO_NO_EXPIRE
	Ce canal n'expirera pas.

# LIST responses
CHAN_LIST_SYNTAX
	LIST [[modle] [liste]]
CHAN_LIST_SERVADMIN_SYNTAX
	LIST [[modle] [liste] [NOLIMIT] [NOEXPIRE]]
CHAN_LIST_INVALID_RANGE
	%s n'est pas une liste de rsultats valide.
CHAN_LIST_NO_NICKS_MATCH
	Il n'y a aucun canal enregistr correspondant  %s.
CHAN_LIST_HEADER
	Liste des canaux enregistrs correspondant  %s:
CHAN_LIST_HEADER_NO_PATTERN
	Liste des canaux enregistrs:
CHAN_LIST_RESULTS
	Fin de la liste - %d/%d rsultats affichs.
CHAN_LIST_RESULTS_RANGE
	Fin de la liste - Rsultats %d  %d affichs.
CHAN_LIST_RESULTS_RANGE_ONE
	Fin de la liste - Rsultat %d affich.

# CLIST responses
CHAN_CLIST_SYNTAX
	CLIST [privilge]
CHAN_CLIST_SYNTAX_X
	CLIST [pseudo] [privilge]
CHAN_CLIST_HEADER
	Liste des privilges de canaux:
	   Canal                 Niveau      Description
CHAN_CLIST_HEADER_X
	Liste des privilges de canaux de %s:
	   Canal                 Niveau      Description
CHAN_CLIST_FORMAT
	  %c%-20s  %-10d  %s
CHAN_CLIST_FORMAT_STR
	  %c%-20s  %-10s  %s
CHAN_CLIST_FORMAT_STR_FOUNDER
	Proprio
CHAN_CLIST_FORMAT_STR_SUCCESSOR
	Successeur
CHAN_CLIST_FOOTER
	%d canaux rpertoris.

# INVITE responses
CHAN_INVITE_SYNTAX
	INVITE canal

# UNBAN responses
CHAN_UNBAN_SYNTAX
	UNBAN canal
CHAN_UNBANNED
	Vous avez t dbanni de %s.

# TOPIC responses
CHAN_TOPIC_SYNTAX
	TOPIC canal [topic]
CHAN_TOPIC_DISABLED
	Dsol, la modification du topic est temporairement suspendue.
CHAN_TOPIC_FAILED
	Dsol, la modification du topic a chou.

# CLEAR responses
CHAN_CLEAR_SYNTAX
	CLEAR canal quoi
CHAN_CLEARED_BANS
	Tous les bannissements du canal %s ont t supprims.
CHAN_CLEARED_MODES
	Tous les modes du canal %s ont t rinitialiss.
CHAN_CLEARED_OPS
	Tous les status d'oprateur du canal %s ont t ts.
CHAN_CLEARED_VOICES
	Tous les modes +v du canal %s ont t ts.
CHAN_CLEARED_USERS
	Tous les utilisateurs du canal %s ont t expulss.

# GETPASS responses
CHAN_GETPASS_SYNTAX
	GETPASS canal
CHAN_GETPASS_DISABLED
	Dsol, la rcupration des mots de passe des canaux est temporairement suspendue.
CHAN_GETPASS_UNAVAILABLE
	La commande GETPASS est indisponible car l'encryption est active.
CHAN_GETPASS_PASSWORD_IS
	Le mot de passe du canal %s est %s.
	
# SENDPASS responses
CHAN_SENDPASS_SYNTAX
	SENDPASS canal
CHAN_SENDPASS_UNAVAILABLE
	La commande SENDPASS est indisponible car l'encryption est utilise.
CHAN_SENDPASS_UNCONFIGURED
	Dsol, la commande SENDPASS est indisponible.
CHAN_SENDPASS_SUBJECT
	Mot de passe du canal %s
CHAN_SENDPASS_HEAD
	Bonjour,
CHAN_SENDPASS_LINE_1
	Vous avez demand  recevoir le mot de passe du canal %s par courriel.
CHAN_SENDPASS_LINE_2
	Le mot de passe est %s. Pour des raisons de scurit, nous vous recommandons d'en changer ds  prsent.
CHAN_SENDPASS_LINE_3
	Si vous ne savez pas pourquoi ce courriel vous a t adress, il s'agit probablement d'une erreur; nous vous prions de nous en excuser et vous demandons de l'ignorer.
CHAN_SENDPASS_LINE_4
	NE REPONDEZ PAS A CE COURRIEL !
CHAN_SENDPASS_LINE_5
	Les administrateurs de %s.
CHAN_SENDPASS_FAILURE
	Le mot de passe du canal %s n'a pas pu tre envoy.
CHAN_SENDPASS_FAILURE_TEMPORARY
	Le mot de passe du canal %s n'a pas pu tre envoy; veuillez ressayer ultrieurement.
CHAN_SENDPASS_OK
	Le mot de passe du canal %s a t envoy.

###########################################################################
#
# MemoServ messages
#
###########################################################################

# Automatic messages
MEMO_HAVE_NEW_MEMO
	Vous avez 1 nouveau mmo.
MEMO_HAVE_NEW_MEMOS
	Vous avez %d nouveaux mmos.
MEMO_TYPE_READ_LAST
	Tapez /msg %s READ LAST pour le lire.
MEMO_TYPE_READ_NUM
	Tapez /msg %s READ %d pour le lire.
MEMO_TYPE_LIST_NEW
	Tapez /msg %s LIST NEW pour en afficher la liste.
MEMO_AT_LIMIT
	Attention: Vous avez atteint votre limite de mmos (%d). Vous ne pourrez plus en recevoir d'autres  moins d'en supprimer quelques-uns.
MEMO_OVER_LIMIT
	Attention: Vous avez dpass votre limite de mmos (%d). Vous ne pourrez plus en recevoir d'autres  moins d'en supprimer quelques-uns.

MEMO_NEW_MEMO_ARRIVED
	Vous avez un nouveau mmo de %s.
	Tapez /msg %s READ %d pour le lire.

# Multi-use responses
MEMO_HAVE_NO_MEMOS
	Vous n'avez pas de mmos.
MEMO_DOES_NOT_EXIST
	Le mmo %d n'existe pas!
MEMO_LIST_NOT_FOUND
	Aucun mmo correspondant n'a t trouv.

# SEND responses
MEMO_SEND_SYNTAX
	SEND pseudo texte-du-mmo
MEMO_SEND_DISABLED
	Dsol, l'envoi de mmos est temporairement suspendu.
MEMO_SEND_NOT_AUTH
	Vous devez authentifier votre adresse de courriel pour pouvoir envoyer un mmo.
MEMO_SEND_NOT_AUTH_HOWTO
	Tapez /msg %s HELP AUTH pour plus d'information sur le processus d'authentification.
MEMO_SEND_TARGET_NOT_AUTH
	%s ne peut pas recevoir de mmos car son adresse de courriel n'est pas authentifie.
MEMO_SEND_PLEASE_WAIT
	Veuillez patienter %d secondes avant d'utiliser la commande SEND  nouveau.
MEMO_SEND_CHANNEL_TARGET_DISABLED
	Dsol, l'envoi de mmos  un canal est dsactiv.
MEMO_X_GETS_NO_MEMOS
	%s ne peut pas recevoir de mmos.
MEMO_X_HAS_TOO_MANY_MEMOS
	%s a trop de mmos et ne peut pas en recevoir plus.
MEMO_SEND_FAILED
	Dsol, l'envoi du mmo a chou.
MEMO_SENT
	Le mmo a bien t envoy  %s.
	
# CANCEL responses
MEMO_CANCEL_SYNTAX
	CANCEL pseudo
MEMO_CANCEL_DISABLED
	Dsol, l'annulation de mmos est temporairement suspendue.
MEMO_CANCEL_NONE
	Aucun mmo n'tait annulable.
MEMO_CANCEL_FAILED
	Dsol, l'annulation des mmos a chou.
MEMO_CANCELLED
	Le dernier mmo que vous avez envoy  %s a t supprim.

# LIST responses
MEMO_LIST_SYNTAX
	LIST [liste | NEW]
MEMO_HAVE_NO_NEW_MEMOS
	Vous n'avez pas de nouveaux mmos.
MEMO_LIST_MEMOS
	Liste des mmos de %s. Pour en lire un, tapez: /msg %s READ num
MEMO_LIST_NEW_MEMOS
	Liste des nouveaux mmos de %s. Pour en lire un, tapez: /msg %s READ num
MEMO_LIST_HEADER
	 Num  Expditeur        Date/Heure
MEMO_LIST_FORMAT
	%c%3d  %-16s  %s

# READ responses
MEMO_READ_SYNTAX
	READ {liste | LAST | NEW}
MEMO_HEADER
	Mmo %d de %s (%s). Pour le supprimer, tapez: /msg %s DEL %d
MEMO_HEADER_TARGET
	Mmo %d de %s  %s (%s). Pour le supprimer, tapez: /msg %s DEL %d
MEMO_TEXT
	%s

# DEL responses
MEMO_DEL_SYNTAX
	DEL {num | liste | ALL}
MEMO_DEL_DISABLED
	Dsol, la suppression de mmos est temporairement suspendue.
MEMO_DEL_FAILED
	Dsol, la suppression des mmos a chou.
MEMO_DELETED_NONE
	Aucun mmo n'a t supprim.
MEMO_DELETED_ONE
	Le mmo %d a t supprim.
MEMO_DELETED_SEVERAL
	Les mmos %s ont t supprims.
MEMO_DELETED_ALL
	Tous vos mmos ont t supprims.

# SET responses
MEMO_SET_SYNTAX
	SET option paramtres
MEMO_SET_DISABLED
	Dsol, la configuration des options est temporairement suspendue.
MEMO_SET_UNKNOWN_OPTION
	Option SET %s inconnue.

# SET NOTIFY responses
MEMO_SET_NOTIFY_SYNTAX
	SET NOTIFY {ON | LOGON | NEW | OFF}
MEMO_SET_NOTIFY_ON
	%s vous notifiera  prsent des nouveaux mmos  la connexion et au moment o ils vous sont envoys.
MEMO_SET_NOTIFY_LOGON
	%s vous notifiera  prsent des nouveaux mmos  la connexion ou que vous utilisez /AWAY sans paramtre.
MEMO_SET_NOTIFY_NEW
	%s vous notifiera  prsent des nouveaux mmos au moment o ils vous sont envoys.
MEMO_SET_NOTIFY_OFF
	%s ne vous enverra aucune notification de mmos.

# SET LIMIT responses
MEMO_SET_LIMIT_SYNTAX
	SET LIMIT limite
MEMO_SET_LIMIT_SERVADMIN_SYNTAX
	SET LIMIT [utilisateur] {limite | NONE} [HARD]
MEMO_SET_YOUR_LIMIT_FORBIDDEN
	Vous n'tes pas autoris(e)  changer votre limite de mmos.
MEMO_SET_YOUR_LIMIT_TOO_HIGH
	Vous ne pouvez pas choisir une limite de mmos suprieure  %d.
MEMO_SET_LIMIT_OVERFLOW
	Cette limite de mmos est trop grande et a t tronque  %d.
MEMO_SET_YOUR_LIMIT
	Votre limite de mmos est dsormais de %d.
MEMO_SET_YOUR_LIMIT_ZERO
	Vous ne pourrez dsormais plus recevoir de mmos.
MEMO_UNSET_YOUR_LIMIT
	Votre limite de mmos a t dsactive.
MEMO_SET_LIMIT
	La limite de mmos de %s est de %d.
MEMO_SET_LIMIT_ZERO
	La limite de mmos de %s est de 0.
MEMO_UNSET_LIMIT
	La limite de mmos de %s est dsactive.

# SET FORWARD responses
MEMO_SET_FORWARD_SYNTAX
	SET FORWARD {ON | OFF}
MEMO_SET_FORWARD_UNAVAILABLE
	Dsol, le transfert de mmos est dsactiv.
MEMO_SET_FORWARD_NO_EMAIL
	Vous n'avez pas configur d'adresse de courriel.
	Tapez /msg %s HELP SET EMAIL pour plus d'informations.
MEMO_SET_FORWARD_NOT_AUTH
	Votre adresse de courriel doit tre authentifie.
	Tapez /msg %s HELP AUTH pour plus d'informations.
MEMO_SET_FORWARD_ON
	Vous allez dsormais recevoir une copie de vos nouveaux mmos par courriel.
MEMO_SET_FORWARD_OFF
	Vous ne recevrez dsormais plus une copie de vos nouveaux mmos par courriel.
MEMO_SET_FORWARD_SUBJECT
	Vous avez un nouveau memo sur %s !
MEMO_SET_FORWARD_SUBJECT_TARGET
	Vous avez un nouveau memo pour %s sur %s !

# INFO responses
MEMO_INFO_SYNTAX
	INFO
MEMO_INFO_SERVADMIN_SYNTAX
	INFO [pseudo | canal]
MEMO_INFO_NO_MEMOS
	Vous n'avez aucun mmo actuellement.
MEMO_INFO_MEMO
	Vous avez actuellement 1 mmo.
MEMO_INFO_MEMO_UNREAD
	Vous avez actuellement 1 mmo, qui n'a pas encore t lu.
MEMO_INFO_MEMOS
	Vous avez actuellement %d mmos.
MEMO_INFO_MEMOS_ONE_UNREAD
	Vous avez actuellement %d mmos, desquels 1 n'a pas t lu.
MEMO_INFO_MEMOS_SOME_UNREAD
	Vous avez actuellement %d mmos, desquels %d n'ont pas t lus.
MEMO_INFO_MEMOS_ALL_UNREAD
	Vous avez actuellement %d mmos; aucun d'entre eux n'a t lu.
MEMO_INFO_LIMIT
	Votre limite de mmos est de %d.
MEMO_INFO_HARD_LIMIT
	Votre limite de mmos est de %d, et ne peut tre change.
MEMO_INFO_LIMIT_ZERO
	Votre limite de mmos est de 0; vous ne recevrez aucun nouveau mmo.
MEMO_INFO_HARD_LIMIT_ZERO
	Votre limite de mmos est de 0; vous ne recevrez aucun nouveau mmo. Vous ne pouvez pas changer cette limite.
MEMO_INFO_NO_LIMIT
	Vous n'avez aucune limite sur le nombre de mmos que vous pouvez conserver.
MEMO_INFO_NOTIFY_OFF
	Vous n'tes pas notifi des nouveaux mmos.
MEMO_INFO_NOTIFY_ON
	Vous tes notifi de nouveaux mmos  la connexion et quand ils arrivent.
MEMO_INFO_NOTIFY_RECEIVE
	Vous tes notifi de nouveaux mmos quand ils arrivent.
MEMO_INFO_NOTIFY_SIGNON
	Vous tes notifi de nouveaux mmos  la connexion.
MEMO_INFO_FORWARD_ON
	Vous recevez une copie de vos nouveaux mmos par courriel.
MEMO_INFO_FORWARD_OFF
	Vous ne recevez pas de copie de vos nouveaux mmos par courriel.
MEMO_INFO_X_NO_MEMOS
	%s n'a actuellement aucun mmo.
MEMO_INFO_X_MEMO
	%s a actuellement 1 mmo.
MEMO_INFO_X_MEMO_UNREAD
	%s a actuellement 1 mmo, qui n'a pas encore t lu.
MEMO_INFO_X_MEMOS
	%s a actuellement %d mmos.
MEMO_INFO_X_MEMOS_ONE_UNREAD
	%s a actuellement %d mmos, desquels 1 n'a pas t lu.
MEMO_INFO_X_MEMOS_SOME_UNREAD
	%s a actuellement %d mmos, desquels %d n'ont pas t lus.
MEMO_INFO_X_MEMOS_ALL_UNREAD
	%s a actuellement %d mmos; desquels aucun n'a t lu.
MEMO_INFO_X_LIMIT
	La limite de mmos de %s est de %d.
MEMO_INFO_X_HARD_LIMIT
	La limite de mmos de %s est de %d, et ne peut pas tre change.
MEMO_INFO_X_NO_LIMIT
	%s n'a aucune limite de mmos.
MEMO_INFO_X_NOTIFY_OFF
	%s n'est pas notifi de nouveaux mmos.
MEMO_INFO_X_NOTIFY_ON
	%s est notifi de nouveaux mmos quand ils arrivent et  la connexion.
MEMO_INFO_X_NOTIFY_RECEIVE
	%s est notifi de nouveaux mmos quand ils arrivent.
MEMO_INFO_X_NOTIFY_SIGNON
	%s est notifi de nouveaux mmos  la connexion.
MEMO_INFO_X_FORWARD_ON
	%s reoit une copie de ses nouveaux mmos par courriel.
MEMO_INFO_X_FORWARD_OFF
	%s ne reoit pas une copie de ses nouveaux mmos par courriel.

###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
BOT_DOES_NOT_EXIST
	Le robot %s n'existe pas.
BOT_NOT_ASSIGNED
	Vous devez attribuer un robot au canal avant d'utiliser cette commande.
	Tapez /msg %S HELP ASSIGN pour plus d'informations.
BOT_NOT_ON_CHANNEL
	Le robot n'est pas sur le canal %s.
	
# Kick reasons (must be a single line)
BOT_REASON_BADWORD
	On ne dit pas %s !
BOT_REASON_BADWORD_GENTLE
	Surveillez vos paroles!
BOT_REASON_BOLD
	N'utilisez pas de caractres gras!
BOT_REASON_CAPS
	Arrtez d'utiliser autant de majuscules!
BOT_REASON_COLOR
	N'utilisez pas de couleurs!
BOT_REASON_FLOOD
	Arrtez d'envoyer autant de messages!
BOT_REASON_REPEAT
	Arrtez de vous rpter!
BOT_REASON_REVERSE
	N'utilisez pas de caractres inverss!
BOT_REASON_UNDERLINE
	N'utilisez pas de caractres souligns!
	
# !seen replies
BOT_SEEN_BOT
	Je suis l, %s!
BOT_SEEN_YOU
	%s est en pleine recherche spirituelle...
BOT_SEEN_ON_CHANNEL
	%s est sur le canal actuellement!
BOT_SEEN_ON_CHANNEL_AS
	%s est sur le canal actuellement (c'est %s) ! 
BOT_SEEN_ON
	%s a t vu pour la dernire fois ici il y a %s.
BOT_SEEN_NEVER
	Je n'ai jamais vu %s sur ce canal.
BOT_SEEN_UNKNOWN
	Je ne sais pas qui est %s.

# BOT responses
BOT_BOT_SYNTAX
	BOT {ADD | CHANGE | DEL | LIST} [[ancien-pseudo] pseudo [nom-utilisateur [nom-d'hte [vrai-nom]]]]
BOT_BOT_ALREADY_EXISTS
	Le robot %s existe dj.
BOT_BOT_CREATION_FAILED
	Dsol, la cration du robot a chou.
BOT_BOT_READONLY
	Dsol, la modification des robots est temporairement suspendue.
BOT_BOT_ADDED
	%s!%s@%s (%s) a t ajout  la liste des robots.
BOT_BOT_ANY_CHANGES
	Aucun changement n'a d tre effectu.
BOT_BOT_CHANGED
	Le robot %s est dsormais %s!%s@%s (%s).
BOT_BOT_DELETION_FAILED
	Dsol, la suppression du robot a chou.
BOT_BOT_DELETED
	Le robot %s a t supprim.
	
# BOTLIST responses
BOT_BOTLIST_HEADER
	Liste des robots:
BOT_BOTLIST_PRIVATE_HEADER
	Robots rservs aux oprateurs IRC:
BOT_BOTLIST_FOOTER
	%d robot(s) disponible(s).
BOT_BOTLIST_EMPTY
	Il n'y a aucun robot disponible actuellement.
	Demandez  un administrateur des services d'en crer un!
	
# ASSIGN responses
BOT_ASSIGN_SYNTAX
	ASSIGN canal pseudo
BOT_ASSIGN_READONLY
	Dsol, l'attribution des robots est temporairement suspendue.
BOT_ASSIGN_ALREADY
	Le canal %s a dj un robot attribu.
BOT_ASSIGN_ASSIGNED
	Le robot %s a t attribu  %s.
	
# UNASSIGN responses
BOT_UNASSIGN_SYNTAX
	UNASSIGN canal
BOT_UNASSIGN_UNASSIGNED
	Il n'y a plus de robot attribu  %s.
	
# INFO responses
BOT_INFO_SYNTAX
	INFO {canal | pseudo}
BOT_INFO_NOT_FOUND
	%s n'est pas un robot ou canal enregistr valide.
BOT_INFO_BOT_HEADER
	Informations concernant le robot %s:
BOT_INFO_BOT_MASK
	      Masque : %s@%s
BOT_INFO_BOT_REALNAME
	    Vrai nom : %s
BOT_INFO_BOT_CREATED
	     Cr le : %s
BOT_INFO_BOT_USAGE
	 Utilis sur : %d canaux
BOT_INFO_BOT_OPTIONS
	     Options : %s
BOT_INFO_OPT_PRIVATE
	Priv
BOT_INFO_CHAN_HEADER
	Informations concernant le canal %s:
BOT_INFO_CHAN_BOT
	              Pseudo du robot : %s
BOT_INFO_CHAN_BOT_NONE
	              Pseudo du robot : non attribu.
BOT_INFO_CHAN_KICK_BADWORDS
	Expulseur de mots interdits   : %s
BOT_INFO_CHAN_KICK_BADWORDS_BAN
	Expulseur de mots interdits   : %s (%d expulsion(s) pour un bannissement)
BOT_INFO_CHAN_KICK_BOLDS
	     Expulseur de car. gras   : %s
BOT_INFO_CHAN_KICK_BOLDS_BAN
	     Expulseur de car. gras   : %s (%d expulsion(s) pour un bannissement)
BOT_INFO_CHAN_KICK_CAPS_ON
	    Expulseur de majuscules   : %s (minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_BAN
	    Expulseur de majuscules   : %s (%d expulsion(s) pour un bannissement; minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_OFF
	    Expulseur de majuscules   : %s
BOT_INFO_CHAN_KICK_COLORS
	      Expulseur de couleurs   : %s
BOT_INFO_CHAN_KICK_COLORS_BAN
	      Expulseur de couleurs   : %s (%d expulsion(s) pour un bannissement)
BOT_INFO_CHAN_KICK_FLOOD_ON
	         Expulseur de flood   : %s (%d lignes en %ds)
BOT_INFO_CHAN_KICK_FLOOD_BAN
	         Expulseur de flood   : %s (%d expulsion(s) pour un bannissement; %d lignes en %ds)
BOT_INFO_CHAN_KICK_FLOOD_OFF
	         Expulseur de flood   : %s
BOT_INFO_CHAN_KICK_REPEAT_ON
	    Expulseur de rptition   : %s (%d fois)
BOT_INFO_CHAN_KICK_REPEAT_BAN
	    Expulseur de rptition   : %s (%d expulsion(s) pour un bannissement; %d fois)
BOT_INFO_CHAN_KICK_REPEAT_OFF
	    Expulseur de rptition   : %s
BOT_INFO_CHAN_KICK_REVERSES
	      Expulseur de reverses   : %s
BOT_INFO_CHAN_KICK_REVERSES_BAN
	      Expulseur de reverses   : %s (%d expulsion(s) pour un bannissement)
BOT_INFO_CHAN_KICK_UNDERLINES
	Expulseur de car. souligns   : %s
BOT_INFO_CHAN_KICK_UNDERLINES_BAN
	Expulseur de car. souligns   : %s (%d expulsion(s) pour un bannissement)
BOT_INFO_ACTIVE
	actif
BOT_INFO_INACTIVE
	inactif
BOT_INFO_CHAN_OPTIONS
	                    Options : %s
BOT_INFO_OPT_DONTKICKOPS
	Protection des oprateurs
BOT_INFO_OPT_DONTKICKVOICES
	Protection des modes +v
BOT_INFO_OPT_FANTASY
	Commandes fantaisistes
BOT_INFO_OPT_GREET
	Messages d'accueil personnaliss
BOT_INFO_OPT_NOBOT
	Interdit de robot
BOT_INFO_OPT_SYMBIOSIS
	Symbiose
BOT_INFO_OPT_NONE
	Aucune
	
# SET responses
BOT_SET_SYNTAX
	SET canal option paramtres
BOT_SET_DISABLED
	Dsol, la configuration des options des robots est temporairement suspendue.
BOT_SET_UNKNOWN
	Option %s inconnue. Tapez /msg %S HELP SET pour plus d'informations.
	
# SET DONTKICKOPS messages
BOT_SET_DONTKICKOPS_SYNTAX
	SET canal DONTKICKOPS {ON|OFF}
BOT_SET_DONTKICKOPS_ON
	Le robot n'expulse pas les oprateurs du canal %s.
BOT_SET_DONTKICKOPS_OFF
	Le robot expulse les oprateurs du canal %s.
	
# SET DONTKICKVOICES messages
BOT_SET_DONTKICKVOICES_SYNTAX
	SET canal DONTKICKVOICES {ON|OFF}
BOT_SET_DONTKICKVOICES_ON
	Le robot n'expulse pas les utilisateurs ayant le mode +v du canal %s.
BOT_SET_DONTKICKVOICES_OFF
	Le robot expulse les utilisateurs ayant le mode +v du canal %s.

# SET FANTASY messages
BOT_SET_FANTASY_SYNTAX
	SET canal FANTASY {ON|OFF}
BOT_SET_FANTASY_ON
	Les commandes fantaisistes sont dsormais actives sur le canal %s.
BOT_SET_FANTASY_OFF
	Les commandes fantaisistes sont dsormais dsactives sur le canal %s.
	
# SET GREET messages
BOT_SET_GREET_SYNTAX
	SET canal GREET {ON|OFF}
BOT_SET_GREET_ON
	Les messages d'accueil personnaliss sont dsormais activs sur le canal %s.
BOT_SET_GREET_OFF
	Les messages d'accueil personnaliss sont dsormais dsactivs sur le canal %s.
	
# SET NOBOT
BOT_SET_NOBOT_SYNTAX
	SET canal NOBOT {ON|OFF}
BOT_SET_NOBOT_ON
	L'interdiction de robot est dsormais active sur le canal %s.
BOT_SET_NOBOT_OFF
	L'interdiction de robot est dsormais dsactive sur le canal %s.

# SET PRIVATE
BOT_SET_PRIVATE_SYNTAX
	SET canal PRIVATE {ON|OFF
BOT_SET_PRIVATE_ON
	Le mode priv du robot %s est maintenant activ.
BOT_SET_PRIVATE_OFF
	Le mode priv du robot %s est maintenant dsactiv.
	
# SET SYMBIOSIS
BOT_SET_SYMBIOSIS_SYNTAX
	SET canal SYMBIOSIS {ON|OFF}
BOT_SET_SYMBIOSIS_ON
	La symbiose est maintenant active sur le canal %s.
BOT_SET_SYMBIOSIS_OFF
	La symbiose est maintenant dsactive sur le canal %s.
	
# KICK responses
BOT_KICK_SYNTAX
	KICK canal option {ON | OFF} [paramtres]
BOT_KICK_DISABLED
	Dsol, la configuration des expulseurs est temporairement dsactive.
BOT_KICK_UNKNOWN
	Option %s inconnue. Tapez /msg %S HELP KICK pour plus d'informations.
BOT_KICK_BAD_TTB
	%s n'est pas un nombre de fois avant un bannissement valide.

BOT_KICK_BADWORDS_ON
	Le robot sanctionne dsormais les mots interdits.
	Utilisez la commande BADWORDS pour ajouter ou supprimer un mot.
BOT_KICK_BADWORDS_ON_BAN
	Le robot sanctionne dsormais les mots interdits,
	et bannit aprs %d expulsions d'un mme utilisateur.
	Utilisez la commande BADWORDS pour ajouter ou supprimer un mot.
BOT_KICK_BADWORDS_OFF
	Le robot ne sanctionne plus les mots interdits.

BOT_KICK_BOLDS_ON
	Le robot sanctionne dsormais les caractres gras.
BOT_KICK_BOLDS_ON_BAN
	Le robot sanctionne dsormais les caractres gras,
	et bannit aprs %d expulsions d'un mme utilisateur.
BOT_KICK_BOLDS_OFF
	Le robot ne sanctionne plus les caractres gras.

BOT_KICK_CAPS_ON
	Le robot sanctionne dsormais les majuscules (qui doivent
	constituer au moins %d caractres et %d%% du message entier).
BOT_KICK_CAPS_ON_BAN
	Le robot sanctionne dsormais les majuscules (qui doivent
	constituer au moins %d caractres et %d%% du message 
	entier), et bannit aprs %d expulsions d'un mme utilisateur.
BOT_KICK_CAPS_ON_INVALID_MIN
	Le nombre minimum de lettres capitales doit tre compris entre %d et %d inclus.
BOT_KICK_CAPS_ON_INVALID_PERCENT
	Le pourcentage de lettres capitales doit tre compris entre %d et %d inclus.
BOT_KICK_CAPS_OFF
	Le robot ne sanctionne plus les majuscules.

BOT_KICK_COLORS_ON
	Le robot sanctionne dsormais les couleurs.
BOT_KICK_COLORS_ON_BAN
	Le robot sanctionne dsormais les couleurs, et bannit
	aprs %d expulsions d'un mme utilisateur.
BOT_KICK_COLORS_OFF
	Le robot ne sanctionne plus les couleurs.

BOT_KICK_FLOOD_ON
	Le robot sanctionne dsormais le flood (%d lignes en %d 
	secondes).
BOT_KICK_FLOOD_ON_BAN
	Le robot sanctionne dsormais le flood (%d lignes en %d 
	secondes), et bannit aprs %d expulsions d'un mme utilisateur.
BOT_KICK_FLOOD_ON_INVALID_LINES
	Le nombre de lignes doit tre compris entre %d et %d inclus.
BOT_KICK_FLOOD_ON_INVALID_SECONDS
	Le nombre de secondes doit tre compris entre %d et %d inclus.
BOT_KICK_FLOOD_OFF
	Le robot ne sanctionne plus le flood.

BOT_KICK_REPEAT_ON
	Le robot sanctionne dsormais les rptitions (les 
	utilisateurs qui disent %d fois la mme chose).
BOT_KICK_REPEAT_ON_BAN
	Le robot sanctionne dsormais les rptitions (les 
	utilisateurs qui disent %d fois la mme chose), et bannit
	aprs %d expulsions d'un mme utilisateur.
BOT_KICK_REPEAT_ON_INVALID_TIMES
	Le nombre de fois doit tre compris entre %d et %d inclus.
BOT_KICK_REPEAT_OFF
	Le robot ne sanctionne plus les rptitions.

BOT_KICK_REVERSES_ON
	Le robot sanctionne dsormais les caractres inverss.
BOT_KICK_REVERSES_ON_BAN
	Le robot sanctionne dsormais les caractres inverss, et
	bannit aprs %d expulsions d'un mme utilisateur.
BOT_KICK_REVERSES_OFF
	Le robot ne sanctionne plus les caractres inverss.

BOT_KICK_UNDERLINES_ON
	Le robot sanctionne dsormais les caractres souligns.
BOT_KICK_UNDERLINES_ON_BAN
	Le robot sanctionne dsormais les caractres souligns, 
	et bannit aprs %d expulsions d'un mme utilisateur.
BOT_KICK_UNDERLINES_OFF
	Le robot ne sanctionne plus les caractres souligns.
	
# BADWORDS messages
BOT_BADWORDS_SYNTAX
	BADWORDS canal {ADD | DEL | LIST | CLEAR} [expr | liste-d'entres] [SINGLE | START | END]
BOT_BADWORDS_ADD_SYNTAX
	BADWORDS canal ADD expr [SINGLE | START | END]
BOT_BADWORDS_DEL_SYNTAX
	BADWORDS canal %s {expr | liste-d'entres}
BOT_BADWORDS_DISABLED
	Dsol, la modification de la liste des mots interdits est temporairement suspendue.
BOT_BADWORDS_EMPTY
	La liste des mots interdits de %s est vide.
BOT_BADWORDS_EXPR_TOO_SHORT
	%s est trop court et donc non significatif.
BOT_BADWORDS_EXPR_TOO_LONG
	L'expression doit avoir une longueur infrieure ou gale  %u caractres.
BOT_BADWORDS_ALREADY_PRESENT
	Le masque %s est dj dans la liste des mots interdits de %s.
BOT_BADWORDS_REACHED_LIMIT
	Dsol, il ne peut y avoir que %d entres dans la liste des mots interdits d'un canal.
BOT_BADWORDS_CREATION_FAILED
	Dsol, la cration d'une nouvelle entre dans la liste des mots interdits a chou.
BOT_BADWORDS_ADDED
	%s a t ajout  la liste des mots interdits de %s.
BOT_BADWORDS_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des mots interdits de %s.
BOT_BADWORDS_NOT_FOUND
	%s n'a pas t trouv dans la liste des mots interdits de %s.
BOT_BADWORDS_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des mots interdits de %s.
BOT_BADWORDS_DELETED
	%s a t supprim de la liste des mots interdits de %s.
BOT_BADWORDS_DELETED_ONE
	1 entre a t supprime de la liste des mots interdits de %s.
BOT_BADWORDS_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des mots interdits de %s.
BOT_BADWORDS_LIST_HEADER
	Liste des mots interdits de %s:
BOT_BADWORDS_LIST_COLHEAD
	  Num   Expr                            Type
BOT_BADWORDS_LIST_FORMAT
	  %3d   %-30s  %s
BOT_BADWORDS_LISTED_ONE
	1 entre a t affiche.
BOT_BADWORDS_LISTED_SEVERAL
	%d entres ont t affiches.
BOT_BADWORDS_CLEAR_PARTIALLY
	La liste des mots interdits de %s a t partiellement vide.
BOT_BADWORDS_CLEAR
	La liste des mots interdits de %s a t vide.

# SAY responses
BOT_SAY_SYNTAX
	SAY canal texte
	
# ACT responses
BOT_ACT_SYNTAX
	ACT canal texte

###########################################################################
#
# OperServ messages
#
###########################################################################

# General messages
OPER_BOUNCY_MODES
	Les services ne peuvent pas changer les modes. Vos serveurs sont-ils configurs correctement?
OPER_BOUNCY_MODES_U_LINE
	Les services ne peuvent pas changer les modes. Les U:lines de vos serveurs sont-elles configures correctement?

# GLOBAL responses
OPER_GLOBAL_SYNTAX
	GLOBAL message

# STATS responses
OPER_STATS_UNKNOWN_OPTION
	L'option %s est invalide pour la commande STATS.
OPER_STATS_CURRENT_USERS
	Utilisateurs actuels: %d (%d oprateurs IRC)
OPER_STATS_MAX_USERS
	Utilisateurs maximum: %d (%s)
# This is ugly, but at least it's language-portable...
# Note that you can include seconds in any of these--my personal preference
# is to only give resolution to the nearest minute when uptime is one hour
# or more, but just add a %d to get seconds as well.
OPER_STATS_UPTIME_DHMS
	Les services fonctionnent depuis %d jours, %02d:%02d
OPER_STATS_UPTIME_1DHMS
	Les services fonctionnent depuis %d jour, %02d:%02d
OPER_STATS_UPTIME_HMS
	Les services fonctionnent depuis %d heures, %d minutes
OPER_STATS_UPTIME_HM1S
	Les services fonctionnent depuis %d heures, %d minutes
OPER_STATS_UPTIME_H1MS
	Les services fonctionnent depuis %d heures, %d minute
OPER_STATS_UPTIME_H1M1S
	Les services fonctionnent depuis %d heures, %d minute
OPER_STATS_UPTIME_1HMS
	Les services fonctionnent depuis %d heure, %d minutes
OPER_STATS_UPTIME_1HM1S
	Les services fonctionnent depuis %d heure, %d minutes
OPER_STATS_UPTIME_1H1MS
	Les services fonctionnent depuis %d heure, %d minute
OPER_STATS_UPTIME_1H1M1S
	Les services fonctionnent depuis %d heure, %d minute
OPER_STATS_UPTIME_MS
	Les services fonctionnent depuis %d minutes, %d secondes
OPER_STATS_UPTIME_M1S
	Les services fonctionnent depuis %d minutes, %d seconde
OPER_STATS_UPTIME_1MS
	Les services fonctionnent depuis %d minute, %d secondes
OPER_STATS_UPTIME_1M1S
	Les services fonctionnent depuis %d minute, %d seconde
OPER_STATS_BYTES_READ
	Octets reus   : %5d ko
OPER_STATS_BYTES_WRITTEN
	Octets envoys : %5d ko
OPER_STATS_USER_MEM
	Utilisateurs         : %6d enregistrements, %5d ko
OPER_STATS_CHANNEL_MEM
	Canaux               : %6d enregistrements, %5d ko
OPER_STATS_SESSIONS_MEM
	Sessions             : %6d enregistrements, %5d ko
OPER_STATS_BLACKLIST_MEM
	Liste noire          : %6d enregistrements, %5d ko
OPER_STATS_MEM
	%-20s : %6d enregistrements, %5d kB
OPER_STATS_MEM_ONE
	%-20s : %6d enregistrement,  %5d kB
OPER_STATS_AKILL_COUNT
	Nombre d'AKILLs actuel: %d
OPER_STATS_AKILL_EXPIRE_DAYS
	Temps d'chance des AKILLs par dfaut: %d jours
OPER_STATS_AKILL_EXPIRE_DAY
	Temps d'chance des AKILLs par dfaut: 1 jour
OPER_STATS_AKILL_EXPIRE_HOURS
	Temps d'chance des AKILLs par dfaut: %d heures
OPER_STATS_AKILL_EXPIRE_HOUR
	Temps d'chance des AKILLs par dfaut: 1 heure
OPER_STATS_AKILL_EXPIRE_MINS
	Temps d'chance des AKILLs par dfaut: %d minutes
OPER_STATS_AKILL_EXPIRE_MIN
	Temps d'chance des AKILLs par dfaut: 1 minute
OPER_STATS_AKILL_EXPIRE_NONE
	Temps d'chance des AKILLs par dfaut: Pas d'chance
OPER_STATS_SGLINE_COUNT
	Nombre de SGLINEs actuel: %d
OPER_STATS_SGLINE_EXPIRE_DAYS
	Temps d'chance des SGLINEs par dfaut: %d jours
OPER_STATS_SGLINE_EXPIRE_DAY
	Temps d'chance des SGLINEs par dfaut: 1 jour
OPER_STATS_SGLINE_EXPIRE_HOURS
	Temps d'chance des SGLINEs par dfaut: %d heures
OPER_STATS_SGLINE_EXPIRE_HOUR
	Temps d'chance des SGLINEs par dfaut: 1 heure
OPER_STATS_SGLINE_EXPIRE_MINS
	Temps d'chance des SGLINEs par dfaut: %d minutes
OPER_STATS_SGLINE_EXPIRE_MIN
	Temps d'chance des SGLINEs par dfaut: 1 minute
OPER_STATS_SGLINE_EXPIRE_NONE
	Temps d'chance des SGLINEs par dfaut: Pas d'chance
OPER_STATS_SQLINE_COUNT
	Nombre de SQLINEs actuel: %d
OPER_STATS_SQLINE_EXPIRE_DAYS
	Temps d'chance des SQLINEs par dfaut: %d jours
OPER_STATS_SQLINE_EXPIRE_DAY
	Temps d'chance des SQLINEs par dfaut: 1 jour
OPER_STATS_SQLINE_EXPIRE_HOURS
	Temps d'chance des SQLINEs par dfaut: %d heures
OPER_STATS_SQLINE_EXPIRE_HOUR
	Temps d'chance des SQLINEs par dfaut: 1 heure
OPER_STATS_SQLINE_EXPIRE_MINS
	Temps d'chance des SQLINEs par dfaut: %d minutes
OPER_STATS_SQLINE_EXPIRE_MIN
	Temps d'chance des SQLINEs par dfaut: 1 minute
OPER_STATS_SQLINE_EXPIRE_NONE
	Temps d'chance des SQLINEs par dfaut: Pas d'chance
OPER_STATS_SZLINE_COUNT
	Nombre de SZLINEs actuel: %d
OPER_STATS_SZLINE_EXPIRE_DAYS
	Temps d'chance des SZLINEs par dfaut: %d jours
OPER_STATS_SZLINE_EXPIRE_DAY
	Temps d'chance des SZLINEs par dfaut: 1 jour
OPER_STATS_SZLINE_EXPIRE_HOURS
	Temps d'chance des SZLINEs par dfaut: %d heures
OPER_STATS_SZLINE_EXPIRE_HOUR
	Temps d'chance des SZLINEs par dfaut: 1 heure
OPER_STATS_SZLINE_EXPIRE_MINS
	Temps d'chance des SZLINEs par dfaut: %d minutes
OPER_STATS_SZLINE_EXPIRE_MIN
	Temps d'chance des SZLINEs par dfaut: 1 minute
OPER_STATS_SZLINE_EXPIRE_NONE
	Temps d'chance des SZLINEs par dfaut: Pas d'chance
OPER_STATS_RESET
	Les statistiques ont t rinitialises.
OPER_STATS_RESET_DISABLED
	Dsol, la rinitialisation des statistiques est temporairement suspendue.

# MODE responses
OPER_MODE_SYNTAX
	MODE canal modes

# CLEARMODES responses
OPER_CLEARMODES_SYNTAX
	CLEARMODES canal [ALL]
OPER_CLEARMODES_DONE
	Les modes binaires et les bannissements ont t retirs du canal %s.
OPER_CLEARMODES_ALL_DONE
	Tous les modes ont t retirs du canal %s.

# KICK responses
OPER_KICK_SYNTAX
	KICK canal utilisateur raison

# ADMIN responses
OPER_ADMIN_SYNTAX
	ADMIN {ADD | DEL | LIST | VIEW | CLEAR} [pseudo | liste-d'entres]
OPER_ADMIN_ADD_SYNTAX
	ADMIN ADD pseudo
OPER_ADMIN_DEL_SYNTAX
	ADMIN %s {pseudo | liste-d'entres}
OPER_ADMIN_DISABLED
	Dsol, la modification de la liste des administrateurs des services est temporairement suspendue.
OPER_ADMIN_EMPTY
	La liste des administrateurs des services est vide.
OPER_ADMIN_ALREADY_PRESENT
	L'utilisateur %s est dj dans la liste des administrateurs des services.
OPER_ADMIN_TOO_MANY
	La liste des administrateurs des services est pleine!
OPER_ADMIN_ADDED
	%s a t ajout  la liste des administrateurs des services.
OPER_ADMIN_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des administrateurs des services.
OPER_ADMIN_NOT_FOUND
	%s n'a pas t trouv dans la liste des administrateurs des services.
OPER_ADMIN_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des administrateurs des services.
OPER_ADMIN_DELETED
	%s a t supprim de la liste des administrateurs des services.
OPER_ADMIN_DELETED_ONE
	1 entre a t supprime de la liste des administrateurs des services.
OPER_ADMIN_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des administrateurs des services.
OPER_ADMIN_LIST_HEADER
	Liste des administrateurs des services:
OPER_ADMIN_LIST_COLHEAD
	  Num   Pseudo
OPER_ADMIN_LIST_FORMAT
	  %3d   %s
OPER_ADMIN_LISTED_ONE
	1 entre a t affiche.
OPER_ADMIN_LISTED_SEVERAL
	%d entres ont t affiches.
OPER_ADMIN_CLEAR_PARTIALLY
	La liste des administrateurs des services a t partiellement vide.
OPER_ADMIN_CLEAR
	La liste des administrateurs des services a t vide.

# OPER responses
OPER_OPER_SYNTAX
	OPER {ADD | DEL | LIST | VIEW | CLEAR} [pseudo | liste-d'entres]
OPER_OPER_ADD_SYNTAX
	OPER ADD pseudo
OPER_OPER_DEL_SYNTAX
	OPER %s {pseudo | liste-d'entres}
OPER_OPER_DISABLED
	Dsol, la modification de la liste des oprateurs des services est temporairement suspendue.
OPER_OPER_EMPTY
	La liste des oprateurs des services est vide.
OPER_OPER_ALREADY_PRESENT
	L'utilisateur %s est dj dans la liste des oprateurs des services.
OPER_OPER_TOO_MANY
	La liste des oprateurs des services est pleine!
OPER_OPER_ADDED
	%s a t ajout  la liste des oprateurs des services.
OPER_OPER_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des oprateurs des services.
OPER_OPER_NOT_FOUND
	%s n'a pas t trouv dans la liste des oprateurs des services.
OPER_OPER_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des oprateurs des services.
OPER_OPER_DELETED
	%s a t supprim de la liste des oprateurs des services.
OPER_OPER_DELETED_ONE
	1 entre a t supprime de la liste des oprateurs des services.
OPER_OPER_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des oprateurs des services.
OPER_OPER_LIST_HEADER
	Liste des oprateurs des services:
OPER_OPER_LIST_COLHEAD
	  Num   Pseudo
OPER_OPER_LIST_FORMAT
	  %3d   %s
OPER_OPER_LISTED_ONE
	1 entre a t affiche.
OPER_OPER_LISTED_SEVERAL
	%d entres ont t affiches.
OPER_OPER_CLEAR_PARTIALLY
	La liste des oprateurs des services a t partiellement vide.
OPER_OPER_CLEAR
	La liste des oprateurs des services a t vide.

# AKILL responses
OPER_AKILL_SYNTAX
	AKILL {ADD | DEL | LIST | VIEW | CLEAR} [[+chance] {masque | pseudo[:type] | liste-d'entres} [raison]]
OPER_AKILL_ADD_SYNTAX
	AKILL ADD [+chance] {masque | pseudo[:type]} raison
OPER_AKILL_DEL_SYNTAX
	AKILL %s {masque | liste-d'entres}
OPER_AKILL_UNSUPPORTED
	Dsol, la commande AKILL n'est pas disponible sur ce rseau.
OPER_AKILL_DISABLED
	Dsol, la modification de la liste des AKILLs est temporairement suspendue.
OPER_AKILL_EMPTY
	La liste des AKILLs est vide.
OPER_AKILL_MASK_INVALID
	%s n'est pas un masque valide pour un AKILL.
OPER_AKILL_MASK_NO_NICK
	Rappel: Les masques d'AKILL ne peuvent pas contenir de pseudos; assurez-vous de ne pas avoir inclus la partie pseudo dans votre masque.
OPER_AKILL_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
OPER_AKILL_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
OPER_AKILL_ALREADY_PRESENT
	Le masque %s est dj dans la liste des AKILLs.
OPER_AKILL_ALREADY_COVERED
	Le masque %s est dj couvert par l'AKILL %s.
OPER_AKILL_TOO_MANY
	La liste des AKILLs est pleine!
OPER_AKILL_CREATION_FAILED
	Dsol, la cration d'un nouvel AKILL a chou.
OPER_AKILL_ADDED
	%s a t ajout  la liste des AKILLs.
OPER_AKILL_CHANGED
	L'chance de l'AKILL %s a t change.
OPER_AKILL_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des AKILLs.
OPER_AKILL_NOT_FOUND
	%s n'a pas t trouv dans la liste des AKILLs.
OPER_AKILL_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des AKILLs.
OPER_AKILL_DELETED
	%s a t supprim de la liste des AKILLs.
OPER_AKILL_DELETED_ONE
	1 entre a t supprime de la liste des AKILLs.
OPER_AKILL_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des AKILLs.
OPER_AKILL_LIST_HEADER
	Liste des AKILLs:
OPER_AKILL_LIST_COLHEAD
	  Num   Masque                            Raison
# mask, reason
OPER_AKILL_LIST_FORMAT
	  %3d   %-32s  %s
OPER_AKILL_LISTED_ONE
	1 entre a t affiche.
OPER_AKILL_LISTED_SEVERAL
	%d entres ont t affiches.
# number, mask, set-by, set-time, expires, reason
OPER_AKILL_VIEW_FORMAT
	%3d  %s (par %s le %s; %s)
	      %s
OPER_AKILL_CLEAR_PARTIALLY
	La liste des AKILLs a t partiellement vide.
OPER_AKILL_CLEAR
	La liste des AKILLs a t vide.

# SGLINE responses
OPER_SGLINE_SYNTAX
	SGLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+chance] {masque | liste-d'entres}[:raison]]
OPER_SGLINE_ADD_SYNTAX
	SGLINE ADD [+chance] masque:raison
OPER_SGLINE_DEL_SYNTAX
	SGLINE %s {masque | liste-d'entres}
OPER_SGLINE_UNSUPPORTED
	Dsol, la commande SGLINE n'est pas disponible sur ce rseau.
OPER_SGLINE_DISABLED
	Dsol, la modification de la liste des SGLINEs est temporairement suspendue.
OPER_SGLINE_EMPTY
	La liste des SGLINEs est vide.
OPER_SGLINE_MASK_INVALID
	%s n'est pas un masque valide pour un SGLINE.
OPER_SGLINE_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SGLINE_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SGLINE_ALREADY_PRESENT
	Le masque %s est dj dans la liste des SGLINEs.
OPER_SGLINE_ALREADY_COVERED
	Le masque %s est dj couvert par le SGLINE %s.
OPER_SGLINE_TOO_MANY
	La liste des SGLINEs est pleine!
OPER_SGLINE_CREATION_FAILED
	Dsol, la cration d'un nouvel SGLINE a chou.
OPER_SGLINE_ADDED
	%s a t ajout  la liste des SGLINEs.
OPER_SGLINE_CHANGED
	L'chance de l'SGLINE %s a t change.
OPER_SGLINE_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des SGLINEs.
OPER_SGLINE_NOT_FOUND
	%s n'a pas t trouv dans la liste des SGLINEs.
OPER_SGLINE_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des SGLINEs.
OPER_SGLINE_DELETED
	%s a t supprim de la liste des SGLINEs.
OPER_SGLINE_DELETED_ONE
	1 entre a t supprime de la liste des SGLINEs.
OPER_SGLINE_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des SGLINEs.
OPER_SGLINE_LIST_HEADER
	Liste des SGLINEs:
OPER_SGLINE_LIST_COLHEAD
	  Num   Masque                            Raison
# mask, reason
OPER_SGLINE_LIST_FORMAT
	  %3d   %-32s  %s
OPER_SGLINE_LISTED_ONE
	1 entre a t affiche.
OPER_SGLINE_LISTED_SEVERAL
	%d entres ont t affiches.
# number, mask, set-by, set-time, expires, reason
OPER_SGLINE_VIEW_FORMAT
	%3d  %s (par %s le %s; %s)
	      %s
OPER_SGLINE_CLEAR_PARTIALLY
	La liste des SGLINEs a t partiellement vide.
OPER_SGLINE_CLEAR
	La liste des SGLINEs a t vide.

# SQLINE responses
OPER_SQLINE_SYNTAX
	SQLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+chance] {masque | liste-d'entres} [raison]]
OPER_SQLINE_ADD_SYNTAX
	SQLINE ADD [+chance] masque raison
OPER_SQLINE_DEL_SYNTAX
	SQLINE %s {masque | liste-d'entres}
OPER_SQLINE_DISABLED
	Dsol, la modification de la liste des SQLINEs est temporairement suspendue.
OPER_SQLINE_EMPTY
	La liste des SQLINEs est vide.
OPER_SQLINE_MASK_INVALID
	%s n'est pas un masque valide pour un SQLINE.
OPER_SQLINE_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SQLINE_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SQLINE_ALREADY_PRESENT
	Le masque %s est dj dans la liste des SQLINEs.
OPER_SQLINE_ALREADY_COVERED
	Le masque %s est dj couvert par le SQLINE %s.
OPER_SQLINE_TOO_MANY
	La liste des SQLINEs est pleine!
OPER_SQLINE_CREATION_FAILED
	Dsol, la cration d'un nouvel SQLINE a chou.
OPER_SQLINE_ADDED
	%s a t ajout  la liste des SQLINEs.
OPER_SQLINE_CHANGED
	L'chance du SQLINE %s a t change.
OPER_SQLINE_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des SQLINEs.
OPER_SQLINE_NOT_FOUND
	%s n'a pas t trouv dans la liste des SQLINEs.
OPER_SQLINE_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des SQLINEs.
OPER_SQLINE_DELETED
	%s a t supprim de la liste des SQLINEs.
OPER_SQLINE_DELETED_ONE
	1 entre a t supprime de la liste des SQLINEs.
OPER_SQLINE_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des SQLINEs.
OPER_SQLINE_LIST_HEADER
	Liste des SQLINEs:
OPER_SQLINE_LIST_COLHEAD
	  Num   Masque                            Raison
# mask, reason
OPER_SQLINE_LIST_FORMAT
	  %3d   %-32s  %s
OPER_SQLINE_LISTED_ONE
	1 entre a t affiche.
OPER_SQLINE_LISTED_SEVERAL
	%d entres ont t affiches.
# number, mask, set-by, set-time, expires, reason
OPER_SQLINE_VIEW_FORMAT
	%3d  %s (par %s le %s; %s)
	      %s
OPER_SQLINE_CLEAR_PARTIALLY
	La liste des SQLINEs a t partiellement vide.
OPER_SQLINE_CLEAR
	La liste des SQLINEs a t vide.

# SZLINE responses
OPER_SZLINE_SYNTAX
	SZLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+chance] {masque | liste-d'entres} [raison]]
OPER_SZLINE_ADD_SYNTAX
	SZLINE ADD [+chance] masque raison
OPER_SZLINE_DEL_SYNTAX
	SZLINE %s {masque | liste-d'entres}
OPER_SZLINE_UNSUPPORTED
	Dsol, la commande SZLINE n'est pas disponible sur ce rseau.
OPER_SZLINE_DISABLED
	Dsol, la modification de la liste des SZLINEs est temporairement suspendue.
OPER_SZLINE_EMPTY
	La liste des SZLINEs est vide.
OPER_SZLINE_MASK_INVALID
	%s n'est pas un masque valide pour un SZLINE.
OPER_SZLINE_MASK_ONLY_IPS
	Rappel: Les masques de SZLINE ne peuvent pas contenir de pseudos ou noms d'utilisateurs; assurez-vous de ne pas en avoir inclus dans votre masque.
OPER_SZLINE_MASK_TOO_LONG
	Le masque doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SZLINE_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
OPER_SZLINE_ALREADY_PRESENT
	Le masque %s est dj dans la liste des SZLINEs.
OPER_SZLINE_ALREADY_COVERED
	Le masque %s est dj couvert par le SZLINE %s.
OPER_SZLINE_TOO_MANY
	La liste des SZLINEs est pleine!
OPER_SZLINE_CREATION_FAILED
	Dsol, la cration d'un nouvel SZLINE a chou.
OPER_SZLINE_ADDED
	%s a t ajout  la liste des SZLINEs.
OPER_SZLINE_CHANGED
	L'chance de l'SZLINE %s a t change.
OPER_SZLINE_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des SZLINEs.
OPER_SZLINE_NOT_FOUND
	%s n'a pas t trouv dans la liste des SZLINEs.
OPER_SZLINE_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des SZLINEs.
OPER_SZLINE_DELETED
	%s a t supprim de la liste des SZLINEs.
OPER_SZLINE_DELETED_ONE
	1 entre a t supprime de la liste des SZLINEs.
OPER_SZLINE_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des SZLINEs.
OPER_SZLINE_LIST_HEADER
	Liste des SZLINEs:
OPER_SZLINE_LIST_COLHEAD
	  Num   Masque                Raison
# mask, reason
OPER_SZLINE_LIST_FORMAT
	  %3d   %-20s  %s
OPER_SZLINE_LISTED_ONE
	1 entre a t affiche.
OPER_SZLINE_LISTED_SEVERAL
	%d entres ont t affiches.
# number, mask, set-by, set-time, expires, reason
OPER_SZLINE_VIEW_FORMAT
	%3d  %s (par %s le %s; %s)
	      %s
OPER_SZLINE_CLEAR_PARTIALLY
	La liste des SZLINEs a t partiellement vide.
OPER_SZLINE_CLEAR
	La liste des SZLINEs a t vide.

# SET responses
OPER_SET_SYNTAX
	SET option valeur
OPER_SET_IGNORE_ON
	Le mcanisme d'ignorance sera utilis.
OPER_SET_IGNORE_OFF
	Le mcanisme d'ignorance ne sera pas utilis.
OPER_SET_IGNORE_ERROR
	La valeur de l'option IGNORE doit tre ON ou OFF.
OPER_SET_READONLY_ON
	Les services sont dsormais en mode lecture-seule.
OPER_SET_READONLY_OFF
	Les services sont dsormais en mode lecture-criture.
OPER_SET_READONLY_ERROR
	La valeur de l'option READONLY doit tre ON ou OFF.
OPER_SET_DEBUG_ON
	Les services sont dsormais en mode dbogage.
OPER_SET_DEBUG_OFF
	Les Services ne sont plus en mode dbogage.
OPER_SET_DEBUG_LEVEL
	Les Services sont dsormais en mode dbogage de niveau %d.
OPER_SET_DEBUG_ERROR
	La valeur de l'option DEBUG doit tre ON, OFF, ou un nombre positif.
OPER_SET_NOEXPIRE_ON
	Les services sont dsormais en mode sans expiration.
OPER_SET_NOEXPIRE_OFF
	Les services sont dsormais en mode avec expiration.
OPER_SET_NOEXPIRE_ERROR
	La valeur de l'option NOEXPIRE doit tre ON ou OFF.
OPER_SET_UNKNOWN_OPTION
	Option inconnue %s.

# NOOP responses
OPER_NOOP_SYNTAX
	NOOP {SET|REVOKE} serveur
OPER_NOOP_SET
	Toutes les O:lines de %s ont t supprimes.
OPER_NOOP_REVOKE
	Toutes les O:lines de %s ont t rinitialises.

# JUPE responses
OPER_JUPE_SYNTAX
	JUPE nom-serveur [raison]
OPER_JUPE_USE_SZLINE
	Utilisez plutt la commande SZLINE pour bannir l'adresse IP du serveur.

# RAW responses
OPER_RAW_SYNTAX
	RAW texte

# SYNC responses
OPER_SYNC_IN_PROGRESS
	La demande de synchronisation a t envoye.
	
# RELOAD responses
OPER_RELOAD
	La configuration a t recharge.

# LISTIGNORE responses
OPER_IGNORE_LIST
	Liste des utilisateurs ignors par les services:
OPER_IGNORE_LIST_EMPTY
	La liste des utilisateurs ignors est vide.
		
# CHANLIST responses
OPER_CHANLIST_SYNTAX
	CHANLIST [{[modle] [liste] [NOLIMIT] | pseudo} [SECRET]]
OPER_CHANLIST_INVALID_RANGE
	%s n'est pas une liste de rsultats valide.
OPER_CHANLIST_NO_CHANNELS
	Il n'y a aucun canal pour l'instant.
OPER_CHANLIST_NO_CHANNELS_MATCH
	Il n'y a aucun canal correspondant  %s.
OPER_CHANLIST_NO_CHANNELS_USER
	%s n'est prsent sur aucun canal.
OPER_CHANLIST_HEADER
	Liste des canaux:
	Nom                   Util.  Modes    Topic
OPER_CHANLIST_HEADER_MATCH
	Liste des canaux correspondant  %s:
	Nom                   Util.  Modes    Topic
OPER_CHANLIST_HEADER_USER
	Liste des canaux de %s:
	Nom                   Util.  Modes    Topic
OPER_CHANLIST_ENTRY
	%-20s   %4d  +%-6s  %s
OPER_CHANLIST_RESULTS
	Fin de la liste - %d/%d rsultats affichs.
OPER_CHANLIST_RESULTS_RANGE
	Fin de la liste - Rsultats %d  %d affichs.
OPER_CHANLIST_RESULTS_RANGE_ONE
	Fin de la liste - Rsultat %d affich.

# USERLIST responses
OPER_USERLIST_SYNTAX
	USERLIST [{[modle] [liste] [NOLIMIT] | canal} [INVISIBLE]]
OPER_USERLIST_INVALID_RANGE
	%s n'est pas une liste de rsultats valide.
OPER_USERLIST_NO_USERS_MATCH
	Il n'y a aucun utilisateur correspondant  %s.
OPER_USERLIST_HEADER
	Liste des utilisateurs:
	Pseudo                Masque
OPER_USERLIST_HEADER_MATCH
	Liste des utilisateurs correspondant  %s:
	Pseudo                Masque
OPER_USERLIST_HEADER_CHAN
	Liste des utilisateurs de %s:
	Pseudo                Masque
OPER_USERLIST_ENTRY
	%-20s  %s@%s
OPER_USERLIST_RESULTS
	Fin de la liste - %d/%d rsultats affichs.
OPER_USERLIST_RESULTS_RANGE
	Fin de la liste - Rsultats %d  %d affichs.
OPER_USERLIST_RESULTS_RANGE_ONE
	Fin de la liste - Rsultat %d affich.

# BLACKLIST responses
OPER_BLACKLIST_SYNTAX
	BLACKLIST {DEL | LIST} {nom d'hte | modle}
OPER_BLACKLIST_DISABLED
	La liste noire est dsactive.
OPER_BLACKLIST_NOT_FOUND
	%s n'a pas t trouv dans la liste noire.
OPER_BLACKLIST_REMOVED
	%s a t supprim de la liste noire.
OPER_BLACKLIST_HEADER
	Noms d'hte dans la liste noire:
OPER_BLACKLIST_LIST
	%s
OPER_BLACKLIST_FOOTER
	Fin de la liste - %d/%d correspondance(s) affiches.

# MODULES responses
OPER_MODULES_SYNTAX
	MODULES {LOAD | UNLOAD | LIST | INFO | QUERY} [nom] [requte]
OPER_MODULES_QUERY_SYNTAX
	MODULES QUERY [nom] [requte]
OPER_MODULES_DISABLED
	La commande MODULES %s est dsactive.
OPER_MODULES_NOT_LOADED
	Le module %s n'est pas charg.
OPER_MODULES_LOAD_ALREADY
	Le module %s est dj charg!
OPER_MODULES_LOAD_ERROR
	Le module %s ne peut pas tre charg.
OPER_MODULES_LOADED
	Le module %s a t charg.
OPER_MODULES_UNLOAD_ERROR
	Le module %s ne peut tre dcharg.
OPER_MODULES_UNLOADED
	Le module %s a t dcharg.
OPER_MODULES_HEADER
	Liste des modules chargs:
	Nom               Ref.  Description
OPER_MODULES_LIST
	%-16s  %4d  %s
OPER_MODULES_FOOTER
	%d modules chargs.
OPER_MODULES_INFO_HEADER
	Informations  propos du module %s:
OPER_MODULES_INFO_VERSION
	      Version: %d.%d.%d
OPER_MODULES_INFO_DESC
	  Description: %s
OPER_MODULES_INFO_AUTHOR
	       Auteur: %s
OPER_MODULES_INFO_URL
	      Adresse: %s
OPER_MODULES_INFO_MEMORY_USAGE
	Util. mmoire: %d octets
OPER_MODULES_INFO_MEMORY_USAGE_K
	Util. mmoire: %d ko
OPER_MODULES_QUERY_UNSUPPORTED
	Le module %s ne prend pas en charge cette requte.
OPER_MODULES_QUERY_UNANSWERED
	Le module %s a excut la requte; aucune rponse n'a t fournie.
OPER_MODULES_QUERY_ANSWERED
	Le module %s a excut la requte et rpondu:

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
OPER_EXCEPTION_SYNTAX
	EXCEPTION {ADD | DEL | LIST | VIEW | CLEAR} [masque-d'hte | liste-d'entres]
OPER_EXCEPTION_ADD_SYNTAX
	EXCEPTION ADD [+chance] masque-d'hte limite raison
OPER_EXCEPTION_DEL_SYNTAX
	EXCEPTION %s {masque-d'hte | liste}
OPER_EXCEPTION_SESSIONS_DISABLED
	La limitation de sessions est dsactive.
OPER_EXCEPTION_DISABLED
	Dsol, la modification des exceptions  la limite de sessions est temporairement suspendue.
OPER_EXCEPTION_EMPTY
	La liste des exceptions  la limite de sessions est vide.
OPER_EXCEPTION_INVALID_LIMIT
	La limite de session doit tre un entier valide suprieur ou gal  zero et infrieur  %d.
OPER_EXCEPTION_INVALID_HOSTMASK
	Masque d'hte invalide. Rappel: il ne doit y avoir ni pseudo, ni nom d'utilisateur dans le masque d'hte d'une exception.
OPER_EXCEPTION_HOSTMASK_TOO_LONG
	Le masque d'hte doit avoir une longueur infrieure ou gale  %u caractres.
OPER_EXCEPTION_REASON_TOO_LONG
	La raison doit avoir une longueur infrieure ou gale  %u caractres.
OPER_EXCEPTION_CREATION_FAILED
	Dsol, la cration d'une nouvelle exception a chou.
OPER_EXCEPTION_ALREADY_PRESENT
	Le masque %s est dj dans la liste des exceptions.
OPER_EXCEPTION_TOO_MANY
	La liste des exceptions est pleine!
OPER_EXCEPTION_ADDED
	La limite de sessions de %s est maintenant de %d.
OPER_EXCEPTION_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_NOT_FOUND
	%s n'a pas t trouv dans la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_DELETED
	%s a t supprim de la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_DELETED_ONE
	1 entre a t supprime de la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des exceptions  la limite de sessions.
OPER_EXCEPTION_LIST_HEADER
	Liste des exceptions  la limite de sessions:
OPER_EXCEPTION_LIST_COLHEAD
	Num  Limite  Masque d'hte
# limit, mask
OPER_EXCEPTION_LIST_FORMAT
	%3d  %4d    %s
OPER_EXCEPTION_LISTED_ONE
	1 entre a t affiche.
OPER_EXCEPTION_LISTED_SEVERAL
	%d entres ont t affiches.
# mask, set-by, set-time, expires, limit, reason
OPER_EXCEPTION_VIEW_FORMAT
	%3d.  %s  (par %s le %s; %s)
	    Limite: %-4d  - %s
OPER_EXCEPTION_CLEAR_PARTIALLY
	La liste des exceptions  la limite de sessions a t partiellement vide.
OPER_EXCEPTION_CLEAR
	La liste des exceptions  la limite de sessions a t vide.

# SESSION responses
OPER_SESSION_SYNTAX
	SESSION {LIST limite | VIEW host}
OPER_SESSION_LIST_SYNTAX
	SESSION LIST limite
OPER_SESSION_VIEW_SYNTAX
	SESSION VIEW host
OPER_SESSION_DISABLED
	La limitation de session est dsactive.
OPER_SESSION_INVALID_THRESHOLD
	Valeur minimale invalide. Elle doit tre un entier valide suprieur  1.
OPER_SESSION_NOT_FOUND
	%s introuvable sur la liste des sessions.
OPER_SESSION_LIST_HEADER
	Hosts ayant au moins %d sessions:
OPER_SESSION_LIST_COLHEAD
	Sessions  Host
# limit, host
OPER_SESSION_LIST_FORMAT
	%6d    %s
# host, sessions, limit
OPER_SESSION_VIEW_FORMAT
	L'host %s a actuellement %d sessions avec une limite de %d.

# EXCEPTION help

OPER_HELP_EXCEPTION
	Syntax: EXCEPTION ADD [+chance] masque limite raison
	        EXCEPTION DEL {masque | liste}
	        EXCEPTION LIST [masque | liste-d'entres]
	        EXCEPTION VIEW [masque | liste-d'entres]
	        EXCEPTION CLEAR
	
	Permet aux administrateurs des services de manipuler la liste
	des noms d'htes ayant des limites de session spcifiques -
	autorisant certaines machines, telles que des serveurs
	mutualiss,  avoir plus de connexions  la fois que ce qui
	est permis par dfaut. Lorsqu'un nom d'hte atteint son
	nombre maximum de sessions, tous les clients essayant de se
	connecter avec ce nom d'hte ultrieurement sont dconnects,
	en ayant pralablement t averti via un /NOTICE de %S du lieu
	o ils pourront trouver de l'aide concernant la limitation
	de sessions. Le contenu du message est dtermin par une
	directive de configuration.
		
	EXCEPTION ADD ajoute le masque  la liste des exceptions.
	Notez que les masques du type nick!user@host et user@host sont 
	invalides! Seuls les masques d'htes rels, tels que box.host.dom 
	ou *.host.dom, sont autoriss parce que la limite de sessions
	ne prend pas en compte le pseudo ou le nom d'utilisateur. limite
	doit tre un nombre suprieur ou gal  zero dterminant le nombre
	de clients autoriss  se connecter  la fois, une valeur de zero
	signifiant que ces noms d'htes n'ont aucune limite de session.
	Consultez l'aide de la commande AKILL pour plus de dtails sur
	le format du paramtre optionnel chance.
	EXCEPTION DEL supprime le masque donn de la liste des exceptions.
	EXCEPTION LIST et EXCEPTION VIEW montrent toutes les 
	exceptions de la liste; si un masque est spcifi, seules les
	exceptions correspondantes sont affiches. EXCEPTION VIEW est
	plus informative, puisqu'elle affiche galement le pseudo de la
	personne qui a ajout l'exception, le nombre maximum de sessions
	autoris, la raison, le masque ainsi que la date d'expiration.
	EXCEPTION CLEAR supprime toutes les entres de la liste des
	exceptions.
	
	Notez que lorsqu'un client se connecte, la premire exception de
	la liste  laquelle son nom d'hte correspond est utilis pour
	dterminer le nombre maximum de sessions autoris, mme si une
	autre exception existe dans la liste qui donnerait un nombre
	de sessions autorises plus grand.
	
	Veillez  ne pas ajouter trop d'exceptions ou des exceptions
	utilisant trop intensivement des caractres joker car cela
	pourrait entraner une dgradation des performances des
	services si votre rseau est trs frquent.
	
	Rserve aux administrateurs des services.

OPER_HELP_SESSION
	Syntax: SESSION LIST minimal
	        SESSION VIEW host
	
	Permet aux administrateurs des services de voir la liste des sessions.
	
	SESSION LIST liste les hosts ayant au minimum minimal
	sessions. La limite minimale doit tre un nombre suprieur 
	1. Ceci pour prvenir d'un listing accidentel d'un large
	nombre d'hosts  session unique.

	SESSION VIEW affiche des informations dtailles sur une
	host spcifique - comprenant le nombre de sessions actuelles
	ainsi que la limite de sessions. La valeur host ne doit
	pas contenir de wildcards.
		
	Consultez l'aide de EXCEPTION pour plus d'informations 
	concernant la limitation et comment dfinir les limites de
	sessions pour certaines hosts et groupes.
	
	Rserve aux administrateurs des services.

###########################################################################
#
# News system messages
#
###########################################################################

OPER_NEWS_LOGON
	[Flash info - %s] %s
OPER_NEWS_OPER
	[Oper info - %s] %s
OPER_NEWS_RANDOM
	[Info utile - %s] %s

# NEWS responses
OPER_NEWS_SYNTAX
	NEWS {LOGON | OPER | RANDOM} {ADD | DEL | LIST | CLEAR} [texte | numro | liste-d'entres]
OPER_NEWS_ADD_SYNTAX
	NEWS {LOGON | OPER | RANDOM} ADD texte
OPER_NEWS_DEL_SYNTAX
	NEWS {LOGON | OPER | RANDOM} %s {numro | liste}
OPER_NEWS_LIST_SYNTAX
	NEWS {LOGON | OPER | RANDOM} %s {liste}
OPER_NEWS_DISABLED
	Dsol, la modification des nouvelles est temporairement suspendue.
OPER_NEWS_EMPTY
	La liste des nouvelles %s est vide.
OPER_NEWS_TEXT_TOO_LONG
	Le texte doit avoir une longueur infrieure ou gale  %u caractres.
OPER_NEWS_TOO_MANY
	La liste des nouvelles %s est pleine!
OPER_NEWS_ADDED
	La nouvelle a t ajoute  la liste des nouvelles %s.
OPER_NEWS_NO_SUCH_ENTRY
	L'entre %d n'existe pas dans la liste des nouvelles %s.
OPER_NEWS_NO_MATCH
	Aucune entre correspondante n'a t trouve dans la liste des nouvelles %s.
OPER_NEWS_DELETED_ONE
	1 entre a t supprime de la liste des nouvelles %s.
OPER_NEWS_DELETED_SEVERAL
	%d entres ont t supprimes de la liste des nouvelles %s.
OPER_NEWS_LIST_HEADER
	Liste des nouvelles %s:
OPER_NEWS_LIST_COLHEAD
	Num  Texte
# num, text
OPER_NEWS_LIST_FORMAT
	%3d  %s
OPER_NEWS_LISTED_ONE
	1 entre a t affiche.
OPER_NEWS_LISTED_SEVERAL
	%d entres ont t affiches.
OPER_NEWS_CLEAR_PARTIALLY
	La liste des nouvelles %s a t partiellement vide.
OPER_NEWS_CLEAR
	La liste des nouvelles %s a t vide.

OPER_HELP_NEWS
	Syntaxe: NEWS {LOGON | OPER | RANDOM} ADD texte
	         NEWS {LOGON | OPER | RANDOM} DEL {numro | liste}
	         NEWS {LOGON | OPER | RANDOM} LIST [liste]
	         NEWS {LOGON | OPER | RANDOM} CLEAR
	
	Edite ou affiche la liste des nouvelles d'accueil (LOGON,
	jusqu' trois envoyes  un utilisateur se connectant), des
	nouvelles pour oprateurs IRC (OPER, jusqu' trois
	envoyes  un utilisateur utilisant la commande /OPER) et
	des nouvelles alatoires (RANDOM, une seule, choisie au
	hasard, envoye  un utilisateur se connectant).
	
	LIST est utilisable par tous les oprateurs IRC pour 
	afficher la liste des nouvelles. ADD, DEL et CLEAR
	sont rserves aux administrateurs des services.

###########################################################################
#
# HelpServ help message
#
###########################################################################

HELP_HELP
	%S est un service conu pour donner des informations
	sur les autres services. Les rubriques d'aide sont
	accessibles via les commandes HELP des diffrents
	services:

	/msg %s HELP
	     pour des informations sur l'enregistrement des pseudos

	/msg %s HELP
	     pour des informations sur l'enregistrement et le
	     contrle des canaux

	/msg %s HELP
	     pour des informations sur l'envoi de messages aux
	     utilisateurs non connects

HELP_HELP_BOT
	
	/msg %s HELP
	     pour des informations sur l'installation d'un robot
	     sur votre canal

###########################################################################
#
# NickServ help messages
#
###########################################################################

NICK_HELP
	%S vous permet d'enregistrer un pseudo et
	d'empcher les autres de l'utiliser. Les commandes
	suivantes permettent l'enregistrement et la gestion des
	pseudos; pour les utiliser, tapez /msg %S commande.
	Pour plus d'informations sur une commande en particulier,
	tapez /msg %S HELP commande.
	
	    REGISTER   Enregistre un pseudo
	    GROUP      Joint un groupe
	    IDENTIFY   Vous identifie avec votre mot de passe
	    ACCESS     Modifie la liste des adresses autorises
	    SET        Configure les options, protection comprise
	    DROP       Efface un pseudo
	    RECOVER    Change le pseudo d'un utilisateur qui a pris 
	               votre pseudo
	    RELEASE    Pour retrouver l'usage de votre pseudo aprs
	               un RECOVER
	    SENDPASS    utiliser en cas de perte de mot de passe
	
	Autres commandes: AUTH, GHOST, HOST, INFO, GLIST, LIST,
	                  LOGOUT, STATUS
	
	REMARQUE: Ce service est conu pour fournir un moyen aux
	utilisateurs IRC d'assurer que leur identit n'est pas
	usurpe. Il n'est PAS destin  faciliter le "vol" des
	pseudos ou autres choses de ce genre. L'abus de %S
	entranera, au minimum, la perte du (des) pseudo(s) faisant
	l'objet de l'abus.
	
NICK_HELP_EXPIRES
	
	Les pseudos sont automatiquement effacs aprs %d jours
	de non-utilisation.

NICK_HELP_REGISTER
	Syntaxe: REGISTER motdepasse [courriel]
	
	Enregistre votre pseudo dans la base de donnes de
	%S. Cela fait, vous pouvez utiliser les commandes
	SET et ACCESS pour configurer votre pseudo comme bon
	vous semble. Rappelez-vous bien du mot de passe utilis
	pendant l'enregistrement - vous en aurez besoin pour
	effectuer des changements sur votre pseudo plus tard.
	(Attention au respect des majuscules dans le mot de passe
	que vous choisissez -- EPONA, Epona, et epona sont
	tous diffrents!)
	
	Conseils pour choisir un bon mot de passe:
	
	Les mots de passe ne doivent pas tre trop facilement
	devinables. Par exemple, utiliser votre vrai nom ou votre
	date de naissance est une mauvaise ide. Utiliser votre
	pseudo est une solution encore pire ;) et, en fait,
	%S vous en empchera. De mme, les mots de passe
	courts sont plus vulnrables aux recherches mthodiques,
	donc vous devez choisir un mot de passe d'au moins 5
	caractres. Enfin, le caractre espace ne peut tre
	utilis dans les mots de passe.
	
	Le paramtre courriel est optionnel et permet d'associer
	une adresse de courriel  votre pseudo immdiatement.
	Toutefois, il est obligatoire sur certains rseaux.
	Votre vie prive est respecte; cette adresse ne sera pas
	divulgue  des tiers.
	
	Cette commande cre galement un nouveau groupe pour votre
	pseudo. Celui-ci vous permettra plus tard d'enregistrer
	d'autres pseudos en partageant entre eux la configuration,
	les mmos, et les privilges sur vos canaux. Pour plus
	d'informations sur cette fonctionnalit, tapez
	/msg %S HELP GROUP.

NICK_HELP_GROUP
	Syntaxe: GROUP cible motdepasse
	
	Cette commande joint votre pseudo au groupe du pseudo
	cible. motdepasse est le mot de passe du pseudo cible.
	
	Joindre un groupe vous permet de partager votre
	configuration, vos mmos et vos privilges de canal avec
	tous les pseudos du groupe, et bien plus encore!
	 
	Un groupe existe tant qu'il est utile. Cela signifie que
	mme si un des pseudos du groupe est effac, les lments
	partags sus-nomms sont conservs pour peu qu'il reste
	d'autres pseudos dans le groupe.
	
	Il est prfrable d'utiliser cette commande avec un pseudo
	non enregistr puisque joindre un groupe vaut
	enregistrement du pseudo. Vous ne pouvez l'utiliser avec un
	pseudo enregistr (pour changer de groupe) que si vos
	administrateurs ont choisi de le permettre.
	
	Vous ne pouvez tre que dans un groupe  la fois. La fusion
	de groupes n'est pas possible.
	
	Note: tous les pseudos d'un groupe partagent le mme mot
	de passe.

NICK_HELP_IDENTIFY
	Syntaxe: IDENTIFY motdepasse
	
	Confirme  %S que vous tes bien le propritaire
	de ce pseudo. Beaucoup de commandes demandent que vous
	soyez identifi avec cette commande pour les utiliser. Le
	mot de passe est celui que vous avez utilis pour
	enregistrer votre pseudo avec la commande REGISTER.

NICK_HELP_LOGOUT
	Syntaxe: LOGOUT
	
	Cette commande inverse l'effet de la commande IDENTIFY,
	c'est--dire qu'elle fait en sorte que vous ne soyez plus
	reconnu en tant que propritaire du pseudo. Toutefois,
	aucune demande de ridentification n'est effectue.

NICK_HELP_AUTH
	Syntaxe: AUTH
	         AUTH code
	         AUTH PASS code nouveau-mot-de-passe
	         AUTH CANCEL
	
	Sans paramtre, cette commande dbute un processus
	d'authentification, qui consiste en un courriel envoy 
	l'adresse associe  votre groupe et contenant un code
	servant  vrifier la validit de votre adresse de
	courriel.
	
	Avec un paramtre code, cette commande termine le
	processus d'authentification en cours. Le code provient du
	courriel qui vous a t envoy au dbut du processus. Une
	fois votre adresse authentifie, vous avez accs  toutes
	les commandes et fonctionnalits que vos administrateurs
	ont choisi de rserver aux groupes dont l'adresse de
	courriel est authentifie.
	
	La commande AUTH PASS termine galement le processus
	d'authentification en cours, mais vous permet en plus de
	changer le mot de passe de votre pseudo. Cette commande
	peut tre indisponible.
	
	La commande AUTH CANCEL annule le processus
	d'authentification en cours.
	
	Cette commande peut tre dsactive sur certains rseaux.

NICK_HELP_DROP
	Syntaxe: DROP [pseudo]
	
	Efface votre pseudo de la base de donnes de %S.
	Un pseudo qui a t effac est libre d'tre renregistr
	par qui que ce soit.
	
	Si un pseudo est prcis et qu'il fait partie de votre
	groupe, c'est celui-ci qui sera effac.
	
	Pour utiliser cette commande, vous devez d'abord tre
	identifi (tapez /msg %S HELP IDENTIFY pour plus
	d'informations).

NICK_HELP_ACCESS
	Syntaxe: ACCESS ADD mask
	         ACCESS DEL {masque | numro-d'entre | liste}
	         ACCESS LIST [masque | liste]
	         ACCESS VIEW [masque | liste]
	         ACCESS CLEAR
	
	Modifie ou affiche la liste d'accs de votre groupe de
	pseudos. Il s'agit de la liste des adresses qui sont
	automatiquement reconnues par %S comme tant
	autorises  utiliser les pseudos. Si vous souhaitez
	utiliser le pseudo d'une adresse diffrente, vous devez
	utiliser la commande IDENTIFY pour vous identifier 
	%S.
	
	La commande ACCESS ADD ajoute le masque donn (au format
	user@host)  la liste d'accs; par exemple:
	
	  ACCESS ADD pegase@*.pegase.net
	      Autorise l'accs  l'utilisateur pegase se
	      connectant d'une machine sous le domaine pegase.net.
	
	La commande ACCESS DEL supprime le masque donn de la
	liste d'accs s'il existe. Si une liste de numros d'entres
	est donne, ces entres sont supprimes. (Voyez l'exemple
	pour LIST ci-dessous.)
	
	La commande ACCESS LIST affiche la liste d'accs. Si un
	masque joker est donn, seules les entres correspondantes
	au masque sont affiches. Si une liste de numros d'entres
	est donne, seules ces entres sont affiches; par exemple:

	   ACCESS LIST 2,7-9
	      Affiche les entres de la liste d'accs numros
	      2 et 7  9.
	
	La commande ACCESS CLEAR supprime toutes les entres de la
	liste d'accs.

NICK_HELP_SET
	Syntaxe: SET option paramtres
	
	Configure les options relatives au pseudo. option peut
	tre:
	
	    GNAME      Change le nom de votre groupe
	    PASSWORD   Change le mot de passe de votre pseudo
	    LANGUAGE   Change la langue dans laquelle les services
	                   communiquent avec vous
	    URL        Associe un site web  votre pseudo
	    EMAIL      Associe un courriel  votre pseudo
	    IM         Associe des informations de contact par
	                   messagerie instantane  votre pseudo
	    GREET      Associe un message d'accueil  votre pseudo
	    KILL       Active ou dsactive la protection
	    SECURE     Active ou dsactive la scurit du pseudo
	    PRIVATE    Empche votre pseudo d'tre affich par
	                   /msg %S LIST
	    HIDE       Cache certaines informations du pseudo
	    HOST       Personnalise votre nom d'hte sur IRC
	
	Pour utiliser cette commande, vous devez d'abord tre
	identifi (tapez /msg %S HELP IDENTIFY pour plus
	d'informations).
	
	Tapez /msg %S HELP SET option pour plus d'informations
	sur une option en particulier.

NICK_HELP_SET_GNAME
	Syntaxe: SET GNAME nouveau-nom
	
	Change le nom utilis par %S pour parler de votre groupe.
	Le nouveau-nom DOIT tre un pseudo membre de votre
	groupe.

NICK_HELP_SET_PASSWORD
	Syntaxe: SET PASSWORD nouveau-mot-de-passe
	
	Change le mot de passe utilis pour vous identifier en tant
	que propritaire du pseudo.

NICK_HELP_SET_LANGUAGE
	Syntaxe: SET LANGUAGE numro
	
	Change la langue utilise par les services pour communiquer
	avec vous (par exemple, lorsqu'ils rpondent  une commande
	que vous avez envoye). numro doit tre choisi
	parmi la liste suivante des langues disponibles:

NICK_HELP_SET_URL
	Syntaxe: SET URL adresse
	
	Associe une adresse de site  votre pseudo, qui est
	affiche lorsque quelqu'un cherche  obtenir plus
	d'information sur vous via la commande INFO.

NICK_HELP_SET_EMAIL
	Syntaxe: SET EMAIL courriel
	
	Associe une adresse de courriel  votre pseudo, qui est
	affiche lorsque quelqu'un cherche  obtenir plus
	d'information sur vous via la commande INFO (sauf si
	vous avez choisi de la masquer via la commande
	SET HIDE EMAIL).

NICK_HELP_SET_IM
	Syntax: SET IM programme identifiant

	Associe les informations de contact par messagerie
	instantane donnes  votre pseudo. programme est le
	nom du programme de messagerie instantane et identifiant
	est votre identifiant. Cela sera affich lorsque quelqu'un
	demande des informations sur votre pseudo via la commande
	INFO.

NICK_HELP_SET_GREET
	Syntaxe: SET GREET message
	
	Associe un message d'accueil  votre pseudo, qui est
	affich lorsque vous entrez dans un canal qui a l'option
	GREET active,  condition d'avoir un niveau d'accs
	suffisant.

NICK_HELP_SET_KILL
	Syntaxe: SET KILL {ON | QUICK | IMMED | OFF}
	
	Contrle l'activation de la protection automatique de votre
	pseudo. Si cette option est active et qu'un utilisateur
	indlicat tente de prendre votre pseudo, il aura une minute
	pour en changer, faute de quoi %S s'y emploiera de force.
	La protection est toujours inactive pour les utilisateurs
	dont le masque correspond  une des entres de la liste
	d'accs du pseudo; tapez /msg %S HELP ACCESS pour plus
	d'information.
	
	Si vous choisissez le mode QUICK, le dlai pour changer
	de pseudo n'est que de 20 secondes au lieu des 60
	habituelles. Si vous choisissez le mode IMMED, le pseudo
	est chang immdiatement avant que l'utilisateur ne soit
	prvenu ou ait l'occasion de prendre un autre pseudo;
	n'utilisez cette option que si ncessaire et surtout,
	vrifiez que la liste d'accs de votre pseudo est  jour,
	ou vous ne pourrez plus non plus utiliser votre pseudo!
	De plus, les administrateurs de votre rseau peuvent avoir
	interdit l'utilisation de ce mode.

NICK_HELP_SET_SECURE
	Syntaxe: SET SECURE {ON | OFF}
	
	Contrle l'activation des mesures de scurit dans
	l'utilisation de votre pseudo. Si cette option est active,
	vous devez obligatoirement vous identifier  l'aide de
	votre mot de passe pour tre reconnu(e) en tant que
	propritaire du pseudo et ainsi avoir accs  ses
	privilges, mmos et options, que votre masque soit dans la
	liste d'accs ou non.

NICK_HELP_SET_PRIVATE
	Syntaxe: SET PRIVATE {ON | OFF}
	
	Contrle l'activation des mesures de confidentialit. Si
	cette option est active, votre pseudo n'apparait pas dans
	les listes de pseudos gnres par la commande LIST de
	%S. (Cependant, quiconque ayant connaissance de votre
	pseudo peut malgr tout obtenir des informations via la
	commande  INFO).

NICK_HELP_SET_HIDE
	Syntaxe: SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
	
	Configure l'affichage (ou non) de certaines informations
	personnelles via la commande INFO. Vous pouvez ainsi
	cacher votre adresse de courriel (EMAIL), votre dernier
	masque de connexion -- au format user@host -- (USERMASK),
	et votre message de /QUIT le plus rcent (QUIT). Le
	second paramtre indique si l'information doit tre
	affiche (OFF) ou cache (ON).

NICK_HELP_SET_HOST
	Syntaxe: SET HOST {ON | OFF}
	
	Contrle l'activation du nom d'hte personnalis (visible
	dans le /WHOIS) qui vous a ventuellement t attribu.
	
	Note: cette option peut ne pas tre disponible.

NICK_HELP_RECOVER
	Syntaxe: RECOVER pseudo [motdepasse]
	
	Cette commande vous permet de rcuprer votre pseudo qu'un
	autre utilisateur aurait pris, de la mme faon que ce que
	%S ferait automatiquement si la protection (via 
	SET KILL) tait active.
	
	Lors de l'utilisation de cette commande, %S connecte
	un faux utilisateur avec le mme pseudo que celui que vous
	essayez de rcuprer. Cela entrane le changement de pseudo
	ou la dconnexion de l'autre utilisateur. Le faux reste
	connect pendant une minute afin d'empcher que l'autre
	utilisateur ne reprenne le pseudo immdiatement; une fois
	cette minute coule, le pseudo est  nouveau libre d'tre
	utilis. Il est galement possible d'utiliser la commande
	RELEASE (/msg %S HELP RELEASE) pour librer votre
	pseudo plus tt.
	
	Pour utiliser la commande RECOVER pour un pseudo, il faut
	soit que l'adresse telle qu'elle est affiche par un /WHOIS
	figure dans la liste d'accs du pseudo, soit que vous soyez
	identifi et dans le groupe du pseudo, ou soit que vous
	devez fournir le mot de passe correct du pseudo.

NICK_HELP_RELEASE
	Syntaxe: RELEASE pseudo [motdepasse]
	
	Cette commande supprime toute tutelle sur votre pseudo qui
	a pu tre cause par la protection offerte par SET KILL
	ou l'utilisation de la commande RECOVER. Par dfaut, les
	mises sous tutelle durent une minute; cette commande les
	arrte plus tt.
	
	Pour utiliser la commande RELEASE pour un pseudo, il faut
	soit que l'adresse telle qu'elle est affiche par un /WHOIS
	figure dans la liste d'accs du pseudo, soit que vous soyez
	identifi et dans le groupe du pseudo, ou soit que vous
	devez fournir le mot de passe correct du pseudo.

NICK_HELP_GHOST
	Syntaxe: GHOST pseudo [motdepasse]
	
	Termine une session IRC "fantme" utilisant votre pseudo.
	Une session "fantme" est un utilisateur qui n'est plus
	rellement connect actuellement, mais que le serveur
	IRC croit toujours connect pour une raison ou une autre.
	Habituellement, cela arrive lorsque votre ordinateur plante
	ou que votre connexion  Internet est interrompue alors que
	vous tes sur IRC. 
	
	Pour utiliser la commande GHOST pour un pseudo, il faut
	soit que l'adresse telle qu'elle est affiche par un /WHOIS
	figure dans la liste d'accs du pseudo, soit que vous soyez
	identifi et dans le groupe du pseudo, ou soit que vous
	devez fournir le mot de passe correct du pseudo.

NICK_HELP_INFO
	Syntaxe: INFO pseudo [ALL]
	
	Affiche des informations sur le pseudo donn, telles que
	le vrai nom du propritaire du pseudo, l'adresse avec
	laquelle il tait connect pour la dernire fois, ou les
	options du pseudo. Si vous tes identifi pour le pseudo
	pour lequel vous demandez des informations et que ALL
	est spcifi, toutes les informations sont affiches,
	qu'elles soient normalement caches ou non.

NICK_HELP_LIST
	Syntaxe: LIST [[modle] [liste]]
	
	Affiche la liste des pseudos enregistrs. Les pseudos dont
	les mesures de confidentialit sont actives (via la
	commande SET PRIVATE) ne sont pas inclus.
	
	Si un modle est donn, seuls les pseudos dont le
	masque (au format pseudo!nom-utilisateur@nom-hte)
	correspond sont affichs. Le nombre de rsultats montrs
	en une seule fois est limit; vous pouvez spcifier une
	liste pour voir les rsultats au-del de cette limite.
	Par exemple:
	
	   LIST 51-100
	       Montre les rsultats 51  100.
	   LIST *Pegase*!* 15-20
	       Montre les rsultats 15  20 dont le pseudo
	       contient "Pegase".
	   LIST *!pegase@pegase.net
	        Affiche la liste des pseudos enregistrs 
	        appartenant  pegase@pegase.net.
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).

	Sur certains rseaux, cette commande est rserve aux
	oprateurs IRC.
	
NICK_HELP_GLIST
	Syntaxe: GLIST
	
	Affiche la liste des pseudos appartenant  votre groupe,
	ainsi que leurs dates d'expiration.

NICK_HELP_STATUS
	Syntaxe: STATUS pseudo...
	
	Informe du statut vis--vis de %S de l'utilisateur ayant le
	pseudo donn. La rponse est au format suivant:
	
	    pseudo code-statut
	
	o pseudo est le pseudo sur lequel la requte portait, et
	code-statut est l'un des codes suivants:
	
	    0 - cet utilisateur n'est pas connect ou le pseudo
	        n'est pas enregistr
	    1 - utilisateur non reconnu comme propritaire
	    2 - utilisateur reconnu comme propritaire uniquement
	        via la liste d'accs
	    3 - utilisateur reconnu comme propritaire via
	        l'identification
	
	Jusqu' seize pseudos peuvent tre soumis  chaque commande;
	tout dpassement est ignor. Aucun message d'erreur n'est
	gnr si aucun pseudo n'est donn.

NICK_HELP_SENDPASS
	Syntaxe: SENDPASS pseudo
	
	Envoie le mot de passe du pseudo donn par courriel 
	l'adresse qui lui aura t assign au pralable. Cette
	commande est trs utile pour rgler les problmes de
	mots de passe perdus.
	
	Sur certains rseaux, cette commande n'est utilisable
	que par les oprateurs IRC.
	
	Cette commande est indisponible quand l'encryption est
	active et qu'il est impossible de gnrer un nouveau mot
	de passe.

NICK_HELP_HOST
	Syntaxe: HOST SET [hte-perso]
	
	HOST SET dfinit le nom d'hte personnalis de
	votre pseudo. Le nom d'hte est effac si aucun paramtre
	n'est prcis.
	
	Note: sur certains rseaux, cette commande peut tre
	indisponible, dsactive ou rserve aux oprateurs IRC.

NICK_SERVADMIN_HELP
	
	Les commandes suivantes sont rserves aux 
	administrateurs des services:
	
	    GETPASS    Affiche le mot de passe d'un pseudo
	                   (uniquement si l'encryption est 
	                   dsactive)
	
	Les administrateurs des services peuvent galement
	effacer n'importe quel pseudo sans avoir besoin d'tre
	identifi  celui-ci.
	
NICK_SERVADMIN_HELP_LOGOUT
	Syntaxe: LOGOUT [pseudo [REVALIDATE]]
	
	Cette commande inverse l'effet de la commande IDENTIFY,
	c'est--dire qu'elle fait en sorte que vous ne soyez plus
	reconnu en tant que propritaire du pseudo. Toutefois,
	aucune demande de ridentification n'est effectue.
	
	Les administrateurs des services peuvent en plus utiliser
	cette commande pour n'importe quel pseudo et forcer une
	demande de ridentification en ajoutant l'option
	REVALIDATE.
	
NICK_SERVADMIN_HELP_DROP
	Syntaxe: DROP [pseudo]
	
	Efface votre pseudo de la base de donnes de %S.
	Un pseudo qui a t effac est libre d'tre renregistr
	par qui que ce soit.
	
	Si un pseudo est prcis et qu'il fait partie de votre
	groupe, c'est celui-ci qui sera effac.
	
	Les administrateurs des services peuvent, quant  eux,
	effacer n'importe quel pseudo.
	
NICK_SERVADMIN_HELP_SET
	
	Les administrateurs des services peuvent galement utiliser
	l'option NOEXPIRE, qui empche les pseudos d'expirer. De
	plus,  les administrateurs des services peuvent changer les
	options de n'importe quel pseudo sans avoir  entrer de mot
	de passe, en utilisant la syntaxe 
	SET =pseudo option paramtres.

NICK_SERVADMIN_HELP_SET_NOEXPIRE
	Syntaxe: SET [=pseudo] NOEXPIRE {ON | OFF}
	
	Contrle l'activation de l'expiration automatique du
	pseudo. Si cette option est active, le pseudo n'expirera
	jamais. Si aucun pseudo n'est spcifi, la modification
	est effectue sur votre propre pseudo.
	
	Rserve aux administrateurs des services.
	
NICK_SERVADMIN_HELP_INFO
	
	Les administrateurs des services peuvent utiliser le
	paramtre ALL avec n'importe quel pseudo.

NICK_SERVADMIN_HELP_LIST
	Syntaxe: LIST [[modle] [liste] [NOLIMIT] [NOEXPIRE]]
	
	Affiche la liste des pseudos enregistrs. Les pseudos dont
	les mesures de confidentialit sont actives (via la
	commande SET PRIVATE) ne sont montrs qu'aux
	administrateurs des services.
	
	Si un modle est donn, seuls les pseudos dont le
	masque (au format pseudo!nom-utilisateur@nom-hte)
	correspond sont affichs. Le nombre de rsultats montrs
	en une seule fois est limit; vous pouvez spcifier une
	liste pour voir les rsultats au-del de cette limite.
	Par exemple:
	
	   LIST 51-100
	       Montre les rsultats 51  100.
	   LIST *Pegase*!* 15-20
	       Montre les rsultats 15  20 dont le pseudo
	       contient "Pegase".
	   LIST *!pegase@pegase.net
	        Affiche la liste des pseudos enregistrs 
	        appartenant  pegase@pegase.net.
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).
	
	Si un modle ou une liste est donn, spcifier l'option
	NOLIMIT affiche un nombre illimit de rsultats.
	
	Les administrateurs des services peuvent utiliser l'option
	NOEXPIRE pour n'afficher que les pseudos dont
	l'expiration est inactive. Dans tous les cas, ces pseudos
	apparaitront prfixs par un !.

NICK_SERVADMIN_HELP_GLIST
	Syntaxe: GLIST [pseudo]
	
	Affiche la liste des pseudos appartenant  votre groupe,
	ainsi que leurs dates d'expiration.
	
	Les administrateurs des services peuvent galement
	utiliser cette commande pour n'importe quel pseudo.

NICK_SERVADMIN_HELP_GETPASS
	Syntaxe: GETPASS pseudo
	
	Affiche le mot de passe du pseudo donn. Notez qu'
	chaque utilisation de cette commande, un message indiquant
	par qui et pour quel pseudo cette commande a t utilise
	sera archiv et envoy par WALLOPS/GLOBOPS.
	
	Rserve aux administrateurs des services.
	
	Cette commande est indisponible quand l'encryption est
	active et qu'il est impossible de gnrer un mot de passe
	via OpenSSL.

NICK_SERVADMIN_HELP_HOST
	Syntaxe: HOST SET [pseudo] [hte-perso]
	         HOST LIST [masque] [liste]
	
	HOST SET dfinit le nom d'hte personnalis de
	votre pseudo ou celui qui a t prcis. Le nom d'hte
	est effac si aucun n'est donn.
	
	HOST LIST affiche la liste des groupes qui ont un nom
	d'hte personnalis. Si un masque est donn, seuls les
	groupes dont le nom d'hte personnalis correspond
	sont affichs. Le nombre de rsultats affichs  la
	fois est limit; vous pouvez utiliser une liste pour 
	voir les rsultats au-del de cette limite. Par exemple:
	
	   HOST LIST 51-100
	       Affiche les rsultats 51  100.
	
	(Note: contrairement aux listes numrotes, il n'est
	pas possible d'utiliser des combinaisons comme
	51-60,75-80).
	
	Rserve aux oprateurs des services, sauf HOST SET
	qui peut avoir t configure pour tre utilisable par 
	tous.
	
	Note: cette commande peut tre indisponible ou dsactive
	sur votre rseau.

###########################################################################
#
# ChanServ help messages
#
###########################################################################

CHAN_HELP
	%S vous permet d'enregistrer et de contrler divers
	aspects des canaux. %S propose ainsi toute une srie
	de fonctionnalits qui empchent notamment des utilisateurs
	malintentionns de prendre le contrle de vos canaux,
	en contrlant strictement les personnes autorises  tre
	oprateurs sur le canal. Les commandes disponibles sont
	affichs ci-dessous; pour les utiliser, tapez
	/msg %S command. Pour plus d'informations sur
	une commande spcifique, tapez
	/msg %S HELP command.
	
	    REGISTER   Enregistre un canal
	    IDENTIFY   Vous identifie en tant que propritaire avec
	               le mot de passe du canal
	    SET        Configure les options du canal
	    ACCESS     Gre la liste des utilisateurs privilgis
	    LEVELS     Redfinit la valeur des niveaux d'accs
	    AKICK      Gre la liste des expulsions automatiques
	    DROP       Efface l'enregistrement d'un canal
	    SENDPASS   Aide  retrouver les mots de passe gars
	
	Autres commandes: BAN, CLEAR, CLIST, DEOP, DEVOICE,
	                  GETKEY, INFO, INVITE, KICK, LIST,
	                  LOGOUT, OP, TOPIC, UNBAN, VOICE

CHAN_HELP_UNREAL
	
	Ces commandes sont galement disponibles sur ce rseau:
	    DEHALFOP, DEOWNER, DEPROTECT, HALFOP, OWNER, PROTECT

CHAN_HELP_ULTIMATE
	
	Ces commandes sont galement disponibles sur ce rseau:
	    DEHALFOP, HALFOP

CHAN_HELP_EXPIRES
	
	Notez que tout canal non utilis pendant %d jours
	(c'est--dire une priode pendant laquelle aucun
	utilisateur figurant sur la liste d'accs ne vient
	sur le canal) est automatiquement effac.

CHAN_HELP_REGISTER
	Syntaxe: REGISTER canal motdepasse description
	
	Enregistre un canal dans la base de donnes de %S. Pour
	utiliser cette commande, vous devez pralablement tre
	oprateur sur le canal que vous essayez d'enregistrer.
	Le mot de passe est utilis avec la commande IDENTIFY
	pour permettre  d'autres personnes que le propritaire
	de faire des changements dans la configuration du canal
	plus tard. Le dernier paramtre, qui doit tre inclus,
	est une description gnrale du canal.
	
	Quand vous enregistrez un canal, vous en devenez le
	"propritaire", ce qui vous permet de tout changer dans
	la configuration du canal; %S donne aussi automatiquement
	au propritaire les droits d'oprateur du canal quand il
	ou elle joint le canal.
	Consultez l'aide de la commande ACCESS
	(/msg %S HELP ACCESS) pour savoir comment donner tout
	ou partie de ces droits  d'autres utilisateurs du canal.
	
	REMARQUE: Pour enregistrer un canal, vous devez
	avoir un pseudo enregistr et y tre identifi. Si ce n'est
	pas dj fait, tapez /msg %s HELP pour savoir comment
	faire.

CHAN_HELP_IDENTIFY
	Syntaxe: IDENTIFY canal motdepasse
	
	Vous donne un niveau d'accs au canal donn quivalent 
	celui de son propritaire. Beaucoup de commandes demandent
	que vous utilisiez cette commande avant de pouvoir vous en
	servir si vous n'tes pas le propritaire lgitime du
	canal.
	
	Le mot de passe est celui qui a t spcifi via la
	commande REGISTER de %S.
	
CHAN_HELP_LOGOUT
	Syntaxe: LOGOUT canal pseudo
	
	Cette commande annule l'identification d'une personne au
	canal donn.
	
	Si vous tes le propritaire du canal, vous pouvez utiliser
	la commande sur n'importe qui, sinon vous ne pouvez
	l'utiliser que sur vous-mme.

CHAN_HELP_DROP
	Syntaxe: DROP canal
	
	Efface le canal donn. Peut uniquement tre utilis par
	le propritaire du canal.

CHAN_HELP_SET
	Syntaxe: SET canal option paramtres
	
	Permet au propritaire du canal de configurer diverses
	options du canal et d'autres informations.
	
	Options disponibles:
	
	    FOUNDER       Dfinit le propritaire du canal
	    SUCCESSOR     Dfinit le successeur du canal
	    PASSWORD      Dfinit le mot de passe du canal
	    DESC          Dfinit la description du canal
	    URL           Associe un site avec le canal
	    EMAIL         Associe une adresse de courriel avec le
	                      canal
	    ENTRYMSG      Dfinit un message envoy aux utilisateurs
	                      qui entrent sur le canal
	    BANTYPE       Dfinit comment les services placent les
	                      bannissements sur le canal
	    MLOCK         Verrouille ou interdit des modes du canal
	    KEEPTOPIC     Maintient le topic quand le canal n'est
	                      pas utilis
	    OPNOTICE      Envoie une notice quand les commandes
	                      OP/DEOP sont utilises
	    PEACE         Rgule l'usage de commandes sensibles
	    PRIVATE       Cache le canal dans la commande LIST
	    RESTRICTED    Restreint l'accs au canal
	    SECURE        Active les fonctions de scurit de %S
	    SECUREOPS     Contrle plus strict du statut d'oprateur
	    SECUREFOUNDER Contrle plus strict du statut de
	                      propritaire du canal
	    SIGNKICK      Signe les expulsions effectues par la
	                      commande KICK
	    TOPICLOCK     Empche le topic d'tre chang par un
	                      autre moyen que la commande TOPIC
	
	Tapez /msg %S HELP SET option pour plus d'informations sur
	une option particulire.

CHAN_HELP_SET_FOUNDER
	Syntaxe: SET canal FOUNDER pseudo
	
	Change le propritaire d'un canal. Le nouveau propritaire
	doit avoir un pseudo enregistr.

CHAN_HELP_SET_SUCCESSOR
	Syntaxe: SET canal SUCCESSOR pseudo
	
	Change le successeur d'un canal. Si le pseudo du propritaire
	expire ou est effac alors que le canal est toujours
	enregistr, le successeur devient le nouveau propritaire du
	canal. Cependant, si le successeur a dj trop de canaux
	enregistrs (%d), le canal est tout de mme effac, comme
	si aucun successeur n'avait t nomm. Le successeur doit
	avoir un pseudo enregistr.

CHAN_HELP_SET_PASSWORD
	Syntaxe: SET canal PASSWORD motdepasse
	
	Dfinit le mot de passe utilis pour s'identifier en tant
	que propritaire du canal.

CHAN_HELP_SET_DESC
	Syntaxe: SET canal DESC description
	
	Dfinit la description du canal, qui apparait dans les
	commandes LIST et INFO.

CHAN_HELP_SET_URL
	Syntaxe: SET canal URL [adresse]
	
	Associe l'adresse de site Internet donne avec le canal.
	Elle est affiche chaque fois que quelqu'un demande des
	informations sur le canal via la commande INFO. Si aucun
	paramtre n'est donn, l'adresse actuelle est supprime.

CHAN_HELP_SET_EMAIL
	Syntaxe: SET canal EMAIL [adresse]
	
	Associe l'adresse de courriel donne avec le canal. Elle
	est affiche chaque fois que quelqu'un demande des
	informations sur le canal via la commande INFO. Si aucun
	paramtre n'est donn, l'adresse actuelle est supprime.

CHAN_HELP_SET_ENTRYMSG
	Syntaxe: SET canal ENTRYMSG [message]
	
	Dfinit le message qui est envoy par /NOTICE aux
	utilisateurs qui entrent sur un canal. Si aucun paramtre
	n'est donn, plus aucun message n'est envoy.
	
CHAN_HELP_SET_BANTYPE
	Syntaxe: SET canal BANTYPE type
	
	Dfinit le type de bannissement utilis par les services
	pour bannir quelqu'un de votre canal.
	
	type est un chiffre entre 0 et 3 qui signifie:
	
	0: bannissement de style *!user@host
	1: bannissement de style *!*user@host
	2: bannissement de style *!*@host
	3: bannissement de style *!*user@*.domain

CHAN_HELP_SET_KEEPTOPIC
	Syntaxe: SET canal KEEPTOPIC {ON | OFF}
	
	Contrle l'activation du maintien du topic d'un canal.
	Si cette option est active, le topic du canal est retenu
	par %S mme aprs que le dernier utilisateur l'ait quitt,
	et est restaur automatiquement lorsqu'un utilisateur
	rejoint le canal.

CHAN_HELP_SET_TOPICLOCK
	Syntaxe: SET canal TOPICLOCK {ON | OFF}
	
	Contrle l'activation du verrouillage du topic d'un
	canal. Si cette option est active, %S ne permet pas
	de changement de topic sauf s'il est effectu via la
	commande TOPIC.

CHAN_HELP_SET_MLOCK
	Syntaxe: SET canal MLOCK modes
	
	Configure les modes verrouills d'un canal. %S vous permet
	de toujours en garder actifs certains, d'en empcher
	d'autres d'tre utiliss et de laisser ceux qui restent
	libres d'tre mis ou retirs par les oprateurs du canal.
	
	Le paramtre modes est construit de la mme faon que
	pour la commande /MODE, les modes prcds d'un + tant
	toujours actifs, et ceux prcds d'un - tant interdits.
	Notez cependant que, contrairement  la commande /MODE,
	chaque utilisation de SET MLOCK remettra les modes
	verrouills  zro avant de mettre en place les nouveaux!
	
	Remarque: Si vous choisissez de toujours garder actif le
	mode +k, comme dans le second exemple ci-dessous, vous
	devriez galement activer l'option RESTRICTED du canal
	(tapez /msg %S HELP SET RESTRICTED pour plus
	d'informations), sans quoi toute personne entrant sur le
	canal lorsqu'il est vide verra le mot de passe!  
	
	Exemples:
	
	    SET #canal MLOCK +nt-iklps
		  Garde toujours les modes n et t actifs, et interdit 
		  les modes i, k, l, p, et s. Le mode m est libre d'tre 
		  mis ou retir.
	
	    SET #canal MLOCK +knst-ilmp mon-mot
	      Garde toujours les modes k, n, s, et t actifs, et
	      interdit les modes i, l, m, et p. Le mot de passe
	      du canal est "mon-mot".
	
	    SET #canal MLOCK +
	      Supprime le verrou, tous les modes peuvent ainsi tre
	      librement utiliss.

CHAN_HELP_SET_PEACE
	Syntaxe: SET canal PEACE {ON | OFF}
	
	Contrle l'activation de l'option paix d'un canal.
	Si elle est active, elle empche un utilisateur d'expulser,
	bannir ou enlever un privilge de canal (via %S)
	un autre autre utilisateur qui a un niveau suprieur ou
	gal au sien.

CHAN_HELP_SET_PRIVATE
	Syntaxe: SET canal PRIVATE {ON | OFF}
	
	Contrle l'activation de la confidentialit d'un canal.
	Si cette option est active, il ne figure plus dans la
	liste des canaux affiche via la commande
	/msg %S LIST.
	
CHAN_HELP_SET_RESTRICTED
	Syntaxe: SET canal RESTRICTED {ON | OFF}
	
	Contrle l'activation de l'accs restreint d'un canal.
	Si cette option est active, les utilisateurs n'ayant
	normalement pas la permission d'tre oprateur du canal
	(c'est--dire ceux ayant un niveau d'accs ngatif et, si
	le contrle des oprateurs est activ, ceux qui ne sont
	pas sur la liste d'accs) sont expulss et bannis du canal.

CHAN_HELP_SET_SECURE
	Syntaxe: SET canal SECURE {ON | OFF}
	
	Contrle l'activation de la scurit d'un canal.
	Si cette option est active, seuls les utilisateurs
	identifis avec leur mot de passe via %s peuvent utiliser
	leurs privilges octroys via la liste d'accs du canal.

CHAN_HELP_SET_SECUREOPS
	Syntaxe: SET canal SECUREOPS {ON | OFF}
	
	Contrle l'activation du contrle des oprateurs d'un
	canal. Si cette option est active, seuls les utilisateurs
	figurant sur la liste d'accs peuvent tre oprateurs.
	
CHAN_HELP_SET_SECUREFOUNDER
	Syntaxe: SET canal SECUREFOUNDER {ON | OFF}
	
	Contrle l'activation du contrle du propritaire d'un
	canal. Si cette option est active, seul le vritable
	propritaire peut effacer le canal, changer son mot de
	passe ou ses propritaire et successeur, et non pas ceux
	qui sont simplement identifis avec le mot de passe du
	canal via %S.
	
CHAN_HELP_SET_SIGNKICK
	Syntaxe: SET canal SIGNKICK {ON | LEVEL | OFF}
	
	Contrle l'activation des expulsions signes d'un
	canal. Si cette option est active, la raison d'une
	expulsion gnre via la commande KICK de %S inclue le
	pseudo de l'initiateur de la commande.
	
	Si vous utilisez le mot-clef LEVEL pour activer cette
	option, les utilisateurs qui ont un niveau suprieur ou
	gal  celui requis pour le privilge SIGNKICK sur le
	canal sont dispenss de signature. Consultez 
	/msg %S HELP LEVELS pour plus d'informations.

CHAN_HELP_SET_OPNOTICE
	Syntaxe: SET canal OPNOTICE {ON | OFF}
	
	Contrle l'activation des notices sur OP/DEOP d'un
	canal. Si cette option est active, %S envoie une notice au
	canal chaque fois que les commandes OP ou DEOP sont
	utilises par un utilisateur sur le canal.

CHAN_HELP_ACCESS
	Syntaxe: ACCESS canal ADD pseudo niveau
	         ACCESS canal DEL {pseudo | numro-d'entre | liste}
	         ACCESS canal LIST [masque | liste]
	         ACCESS canal CLEAR
	
	Modifie ou affiche la liste d'accs d'un canal, qui
	dtermine quels utilisateurs ont le statut d'oprateur ou
	peuvent utiliser les commandes de %S sur le canal.
	Diffrents niveaux donnent accs  diffrents privilges;
	consultez /msg %S HELP ACCESS LEVELS pour plus
	d'information. Tout utilisateur ne figurant pas sur la
	liste d'accs a un niveau de 0.
	
	La commande ACCESS ADD ajoute le pseudo donn  la
	liste d'accs au niveau choisi; s'il est dj sur la liste,
	son niveau est substitu pour le nouveau. Un utilisateur
	ne peut attribuer qu'un niveau infrieur au sien; de plus,
	il est impossible de procder  un changement sur un pseudo
	ayant un niveau plus lev.
	
	La commande ACCESS DEL supprime le pseudo donn de
	la liste d'accs. Si une liste de numros d'entres est 
	donne, ces entres sont supprimes. (Consultez l'exemple
	pour LIST ci-dessous.)
	
	La commande ACCESS LIST affiche la liste d'accs. Si un
	masque joker est donn, seules les entres correspondantes
	au masque sont affiches. Si une liste de numros d'entres
	est donne, seules ces entres sont affiches; par exemple:

	   ACCESS #canal LIST 2,7-9
	        Affiche les entres de la liste d'accs numros 2 et
	        7  9.
	
	La commande ACCESS CLEAR supprime toutes les entres
	de la liste d'accs.

CHAN_HELP_ACCESS_LEVELS
	Niveaux d'accs
	
	Par dfaut, les niveaux d'accs suivants sont dfinis:
	
	   Proprio   Plein pouvoir sur le canal via %S; Statut
	               d'oprateur automatique  l'entre du canal.
	               Une seule personne par canal peut bnficier
	               de ce statut (il ne peut tre donn en
	               utilisant la commande ACCESS).
	        10   Accs  la commande AKICK; Statut d'oprateur
	               automatique.
	         5   Statut d'oprateur automatique.
	         3   Mode +v automatique.
	         0   Aucun privilge particulier.
	        <0   Ne peut pas tre oprateur.
	
	Ces niveaux sont donns  titre indicatif et peuvent tre
	rdfinis et complts en utilisant la commande LEVELS;
	tapez /msg %S HELP LEVELS pour plus d'informations.

CHAN_HELP_AKICK
	Syntaxe: AKICK canal ADD [+expiry] {masque | pseudo} [raison]
	         AKICK canal STICK masque
	         AKICK canal UNSTICK masque
	         AKICK canal DEL {masque | numro-d'entre | liste}
	         AKICK canal LIST [masque | liste]
	         AKICK canal VIEW [masque | liste]
	         AKICK canal ENFORCE
	         AKICK canal CLEAR
	
	Modifie ou affiche la liste des expulsions automatiques
	d'un canal. Si un utilisateur figurant sur la liste des
	expulsions automatiques tente de joindre un canal, %S
	l'expulsera aprs avoir pris soin de le bannir.
	
	La commande AKICK ADD ajoute le pseudo ou le masque
	utilisateur donn  la liste des expulsions automatiques.
	chance est un nombre entier suivi par un w (semaines),
	d (jours), h (heures), ou m (minutes). Les 
	combinaisons (telles que 1h30m) sont possibles. Pour
	ajouter une expulsion qui n'expire pas, ne donnez aucune
	chance. Si une raison est galement prcise, elle est
	utilise lorsque l'utilisateur est expuls; sinon, une
	raison par dfaut est utilise. 
	
	La commande AKICK STICK bannit en permanence le masque
	donn sur le canal. Si quelqu'un essaie d'enlever le
	bannissement, %S le remettra automatiquement. Vous ne
	pouvez utiliser cette option que sur des masques
	utilisateur, et non sur des pseudos enregistrs.
	
	La commande AKICK UNSTICK annule les effets de la commande
	AKICK STICK, vous permettant  nouveau de retirer le
	bannissement correspondant du canal.
	
	La commande AKICK DEL supprime le pseudo ou le masque
	donn de la liste des expulsions automatiques. Toutefois,
	elle ne retire pas les bannissements prcdemment placs
	via les entres supprimes; ceux-ci doivent tre enlevs
	manuellement. Si une liste de numros d'entres est donne,
	ces entres sont supprimes. (Consultez l'exemple pour LIST
	ci-dessous.)
	
	La commande AKICK LIST affiche la liste des expulsions
	automatiques. Si un masque joker est donn, seules les
	entres correspondantes au masque sont affiches. Si une
	liste de numros d'entres est donne, seules ces entres
	sont affiches; par exemple:

	   AKICK #canal LIST 2,7-9
	        Affiche les entres de la liste des expulsions
	        automatiques numros 2 et 7  9.
	
	La commande AKICK VIEW est une version plus dtaille de
	la commande AKICK LIST.
	
	La commande AKICK ENFORCE oblige %S  bannir tous les
	utilisateurs prsents sur le canal concerns par une
	des entres de la liste des expulsions automatiques.
	
	La commande AKICK CLEAR supprime toutes les entres
	de la liste des expulsions automatiques.

CHAN_HELP_LEVELS
	Syntaxe: LEVELS canal SET type level
	         LEVELS canal {DIS | DISABLE} type
	         LEVELS canal LIST
	         LEVELS canal RESET
	
	La commande LEVELS permet un contrle prcis de la 
	signification des levels d'accs utiliss pour les canaux.
	Avec cette commande, vous pouvez dfinir le level d'accs
	requis pour la majorit des fonctions de %S. (Les commandes
	SET FOUNDER et SET PASSWORD, ainsi que cette commande,
	sont toujours rserves au propritaire du canal.)
	
	LEVELS SET permet au level d'accs pour une fonction ou un
	groupe de fonctions d'tre chang. LEVELS DISABLE (ou DIS
	en abrg) dsactive une fonction automatique ou empche l'accs
	 une fonction par quiconque sauf le propritaire du canal.
	LEVELS LIST montre les levels courants pour chaque fonction
	ou groupe de fonctions. LEVELS RESET rinitialise les levels
	avec les levels par dfaut d'un canal fraichement cr 
	(consultez HELP ACCESS LEVELS).

	Pour une liste de caractristiques et fonctions pour lesquels
	des levels peuvent tre dfinis, consultez HELP LEVELS DESC.

CHAN_HELP_LEVELS_DESC
	Les noms de caractristiques/fonctions suivants sont utiliss.
	Notez que les levels pour AUTODEOP et NOJOIN sont des levels
	maximum, alors que tous les autres sont des levels minimum.

CHAN_HELP_LEVELS_DESC_FORMAT
	    %-*s  %s

CHAN_HELP_INFO
	Syntaxe: INFO canal [ALL]
	
	Affiche des informations concernant le canal enregistr
	donn, dont le propritaire, la date d'enregistrement,
	la date de dernire utilisation et la description. Si
	le paramtre ALL est utilis, plus d'informations comme
	le message d'accueil, le successeur ou les options sont
	galement affichs.
	
	Par dfaut, l'option ALL est rserve  ceux ayant un
	niveau d'accs de propritaire sur le canal.

CHAN_HELP_LIST
	Syntaxe: LIST [[modle] [liste]]
	
	Affiche la liste des canaux enregistrs. Les canaux dont
	les mesures de confidentialit sont actives (via la
	commande SET PRIVATE) ne sont pas inclus.
	
	Si un modle est donn, seuls les canaux dont le
	masque correspond sont affichs. Le nombre de rsultats
	montrs en une seule fois est limit; vous pouvez spcifier
	une liste pour voir les rsultats au-del de cette
	limite. Par exemple:
	
	   LIST 51-100
	       Montre les rsultats 51  100.
	   LIST *aide* 15-20
	       Montre les rsultats 15  20 dont le nom
	       contient "aide".
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).

	Sur certains rseaux, cette commande est rserve aux
	oprateurs IRC.

CHAN_HELP_CLIST
	Syntaxe: CLIST [pseudo] [privilge]
	
	Affiche la liste des canaux o vous avez le privilge
	donn.
	
	Exemples d'utilisation:
	
	  CLIST
	  
	    Affiche la liste de tous les canaux o vous avez des
	    privilges.
	  
	  CLIST FOUNDER
	  
	    Affiche la liste de tous les canaux dont vous tes le
	    propritaire.
	    
	  CLIST SUCCESSOR
	  
	    Affiche la liste de tous les canaux dont vous tes le
	    successeur.
	
	  CLIST 3
	  
	    Affiche la liste de tous les canaux o vous avez un
	    niveau d'accs de 3 ou plus.
	  
	  CLIST -1
	  
	    Affiche la liste de tous les canaux o vous avez un
	    niveau d'accs de -1 ou moins.

CHAN_HELP_OP
	Syntaxe: OP [#canal [pseudo]]
	
	Donne les privilges d'oprateur au pseudo donn sur le
	canal. Si le pseudo n'est pas spcifi, %S vous
	donne les privilges d'oprateur sur le canal donn, et
	sur tous les canaux si ce dernier est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal.

CHAN_HELP_DEOP
	Syntaxe: DEOP [#canal [pseudo]]
	
	Retire les privilges d'oprateur au pseudo donn sur le
	canal. Si le pseudo n'est pas spcifi, %S vous
	retire les privilges d'oprateur sur le canal donn, et
	sur tous les canaux si ce dernier est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal.
	
CHAN_HELP_VOICE
	Syntaxe: VOICE [#canal [pseudo]]
	
	Donne le mode +v au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous donne le mode
	+v sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal, ou  ceux ayant un niveau d'accs de 3
	ou plus en cas d'utilisation pour soi-mme.

CHAN_HELP_DEVOICE
	Syntaxe: DEVOICE [#canal [pseudo]]
	
	Retire le mode +v au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous retire le mode
	+v sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal, ou  ceux ayant un niveau d'accs de 3
	ou plus en cas d'utilisation pour soi-mme.
	
CHAN_HELP_HALFOP
	Syntaxe: HALFOP [#canal [pseudo]]
	
	Donne le mode +h au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous donne le mode
	+h sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal, ou  ceux ayant un niveau d'accs de 4
	ou plus en cas d'utilisation pour soi-mme.

CHAN_HELP_DEHALFOP
	Syntaxe: DEHALFOP [#canal [pseudo]]
	
	Retire le mode +h au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous retire le mode
	+h sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5 ou
	plus sur le canal, ou  ceux ayant un niveau d'accs de 4
	ou plus en cas d'utilisation pour soi-mme.
	
CHAN_HELP_PROTECT
	Syntaxe: PROTECT [#canal [pseudo]]
	
	Donne le mode +a au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous donne le mode
	+a sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.
	
	Par dfaut, rserv  ceux ayant un accs de propritaire
	sur le canal, ou  ceux ayant un niveau d'accs de 10 ou
	plus en cas d'utilisation pour soi-mme.
	
CHAN_HELP_DEPROTECT
	Syntaxe: DEPROTECT [#canal [pseudo]]
	
	Retire le mode +a au pseudo donn sur le canal. Si le
	pseudo n'est pas spcifi, %S vous retire le mode
	+a sur le canal donn, et sur tous les canaux si ce dernier
	est galement omis.

	Par dfaut, rserv  ceux ayant un accs de propritaire
	sur le canal, ou  ceux ayant un niveau d'accs de 10 ou
	plus en cas d'utilisation pour soi-mme.

CHAN_HELP_OWNER
	Syntaxe: OWNER [#canal]
	
	Vous donne le mode +q sur le canal donn, et sur tous
	les canaux si ce dernier est omis.
	
	Rserv  ceux ayant un accs de propritaire sur le canal.

CHAN_HELP_DEOWNER
	Syntaxe: DEOWNER [#canal]
	
	Vous retire le mode +q sur le canal donn, et sur tous
	les canaux si ce dernier est omis.
	
	Limit  ceux ayant un accs de propritaire sur le canal.

CHAN_HELP_KICK
	Syntaxe: KICK [#canal [pseudo [raison]]]
	
	Expulse l'utilisateur ayant le pseudo donn du canal.
	Si le pseudo n'est pas spcifi, %S vous expulse
	du canal donn, et de tous les canaux si ce dernier est
	galement omis.
	
	Par dfaut, rserv aux  ceux ayant un niveau d'accs de 5
	ou plus sur le canal.

CHAN_HELP_BAN
	Syntaxe: BAN [#canal [pseudo [raison]]]
	
	Bannit l'utilisateur ayant le pseudo donn du canal.
	Si le pseudo n'est pas spcifi, %S vous bannit du
	canal donn, et de tous les canaux si ce dernier est
	galement omis.

	Par dfaut, rserv aux  ceux ayant un niveau d'accs de 5
	ou plus sur le canal.

CHAN_HELP_TOPIC
	Syntaxe: TOPIC canal [topic]
	
	Change le topic du canal pour celui donn. Si topic
	est omis, alors le topic du canal est supprim. Cette
	commande est surtout utile en conjonction avec la commande
	SET TOPICLOCK. Consultez  /msg %S HELP SET TOPICLOCK
	pour plus d'informations.
	
	Par dfault, rserv  ceux ayant un accs de propritaire
	sur le canal.

CHAN_HELP_INVITE
	Syntaxe: INVITE canal
	
	Demande  %S de vous inviter sur le canal donn. 
	
	Par dfaut, rserv  ceux ayant un niveau d'accs de 5
	ou plus sur le canal.

CHAN_HELP_UNBAN
	Syntaxe: UNBAN canal
	
	Demande  %S d'enlever tous les bannissements vous
	empchant d'entrer sur le canal donn. 

	Par dfaut, rserv aux  ceux ayant un niveau d'accs de 5
	ou plus sur le canal.

CHAN_HELP_CLEAR
	Syntaxe: CLEAR canal quoi
	
	Demande  %S de faire le mnage pour certains aspects
	d'un canal. 
	quoi peut tre une des options suivantes:
	
	     MODES   Rinitialise tous les modes d'un canal
	     BANS    Enlve tous les bannissements d'un canal.
	     OPS     Retire les privilges d'oprateurs  tous
	             les oprateurs du canal.
	     VOICES  Retire le mode +v  toute personne ayant ce
	             mode.
	     USERS   Expulse tous les utilisateurs d'un canal.
	
	Par dfault, rserv  ceux ayant un accs de propritaire
	sur le canal.
	
CHAN_HELP_GETKEY
	Syntaxe: GETKEY canal
	
	Affiche la clef du canal donn. GETKEY est une commande
	qui est principalement destin  tre utilise par des
	robots ou des scripts;  cet effet, la rponse a le format
	suivant:
	
	KEY <canal> <clef>
	
	La clef est "NO KEY" si aucune clef n'est actuellement
	dfinie.
	
CHAN_HELP_SENDPASS
	Syntaxe: SENDPASS canal
	
	Envoie le mot de passe du canal donn par courriel 
	l'adresse assigne au pseudo du propritaire du canal.
	Cette commande est trs utile pour rgler les problmes
	de mots de passe perdus.
	
	Sur certains rseaux, cette commande n'est utilisable
	que par les oprateurs IRC.
	
	Cette commande est indisponible lorsque l'encryption est
	active et qu'il est impossible de gnrer un nouveau mot
	de passe.

CHAN_SERVADMIN_HELP
	
	Les commandes suivantes sont disponibles pour les
	administrateurs des services:
	
	    GETPASS    Affiche le mot de passe d'un canal
	    STATUS     Affiche le level d'accs courant d'un
	                 utilisateur sur un canal
	
	Les administrateurs des services peuvent aussi effacer
	tout canal sans avoir  en tre propritaire, et peuvent
	voir les listes d'accs, d'expulsions automatiques, et de
	dfinitions de privilges de tout canal, ainsi que les
	listes de privilges de canal de tout pseudo.

CHAN_SERVADMIN_HELP_LOGOUT
	Syntaxe: LOGOUT canal [pseudo]
	
	Cette commande annule l'identification d'une personne au
	canal donn.
	
	Si vous tes le propritaire du canal, vous pouvez utiliser
	la commande sur n'importe qui, sinon vous ne pouvez que
	l'utiliser sur vous-mme.
	
	Si vous tes un administrateur des services, vous pouvez
	utiliser cette commande sur n'importe qui et pour n'importe
	quel canal sans tre propritaire du canal. Vous pouvez
	galement omettre le paramtre pseudo; cela a pour effet
	d'annuler l'identification pour tous les utilisateurs
	identifis au canal.

CHAN_SERVADMIN_HELP_DROP
	Syntaxe: DROP canal
	
	Efface le canal donn. Seuls les administrateurs des
	services peuvent effacer un canal dont ils ne sont pas
	propritaires.

CHAN_SERVADMIN_HELP_SET
	
	Les administrateurs des services peuvent galement
	configurer l'option NOEXPIRE, avec laquelle les canaux
	peuvent tre empchs d'expirer. De plus, les
	administrateurs des services peuvent configurer les options
	de tout canal sans en tre propritaire. 

CHAN_SERVADMIN_HELP_SET_NOEXPIRE
	Syntaxe: SET canal NOEXPIRE {ON | OFF}
	
	Dtermine si un canal peut expirer.
	
	Rserve aux administrateurs des services.

CHAN_SERVADMIN_HELP_INFO
	
	Les administrateurs des services peuvent utiliser le
	paramtre ALL pour n'importe quel canal.

CHAN_SERVADMIN_HELP_LIST
	Syntaxe: LIST [[modle] [liste] [NOLIMIT] [NOEXPIRE]]
	
	Affiche la liste des canaux enregistrs. Les canaux dont
	les mesures de confidentialit sont actives (via la
	commande SET PRIVATE) ne sont montrs qu'aux
	administrateurs des services.
	
	Si un modle est donn, seuls les canaux dont le masque
	correspond sont affichs. Le nombre de rsultats montrs
	en une seule fois est limit; vous pouvez spcifier une
	liste pour voir les rsultats au-del de cette limite.
	Par exemple:
	
	   LIST 51-100
	       Montre les rsultats 51  100.
	   LIST *aide* 15-20
	       Montre les rsultats 15  20 dont le nom
	       contient "aide".
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).
	
	Si un modle ou une liste est donn, spcifier l'option
	NOLIMIT affiche un nombre illimit de rsultats.
	
	Les administrateurs des services peuvent utiliser l'option
	NOEXPIRE pour n'afficher que les canaux dont
	l'expiration est inactive. Dans tous les cas, ces pseudos
	apparaitront prfixs par un !.

CHAN_SERVADMIN_HELP_CLIST
	Syntaxe: CLIST [pseudo] [privilge]
	
	Affiche les canaux o vous avez le privilge donn. Si
	un pseudo est spcifi, affiche tous les privilges
	de cet utilisateur  la place (cet usage est rserv
	aux administrateurs des services).
	Les canaux dont l'option NOEXPIRE est active sont
	prfixs par un point d'exclamation.
	
	Exemples d'utilisation:
	
	  CLIST Epona
	  
	    Affiche la liste de tous les canaux o Epona a des
	    privilges.
	  
	  CLIST Pegase FOUNDER
	  
	    Affiche la liste de tous les canaux dont Pegase est le
	    propritaire.
	    
	  CLIST SUCCESSOR
	  
	    Affiche la liste de tous les canaux dont vous tes le
	    successeur.
	
	  CLIST 3
	  
	    Affiche la liste de tous les canaux o vous avez un
	    niveau d'accs de 3 ou plus.
	  
	  CLIST LaLicorne -1
	  
	    Affiche la liste de tous les canaux o LaLicorne a un
	    niveau d'accs de -1 ou moins.

CHAN_SERVADMIN_HELP_GETPASS
	Syntaxe: GETPASS canal
	
	Affiche le mot de passe du canal donn. Notez qu'
	chaque utilisation de cette commande, un message indiquant
	par qui et pour quel canal cette commande a t utilise
	sera archiv et envoy par WALLOPS/GLOBOPS.
	
	Rserve aux administrateurs des services.
	
	Cette commande est indisponible quand l'encryption est
	active et qu'il est impossible de gnrer un mot de passe
	via OpenSSL.

CHAN_SERVADMIN_HELP_STATUS
	Syntaxe: STATUS canal pseudo
	
	Affiche le niveau d'accs actuel du pseudo sur le
	canal. La rponse est de la forme:
	
	    STATUS canal pseudo niveau-accs
	
	Si une erreur se produit, la rponse est de la forme:
	
	    STATUS ERROR message-erreur
	
	Rserve aux administrateurs des services.

###########################################################################
#
# MemoServ help messages
#
###########################################################################

MEMO_HELP
	%S est un service vous permettant d'envoyer de courts
	messages  d'autres utilisateurs, qu'ils soient connects 
	ce moment-l ou non. Les pseudos de l'expditeur ET du
	destinataire doivent tre enregistrs pour que l'envoi d'un
	mmo soit possible.
	
	Les commandes de %S sont:
	
	    SEND   Envoie un mmo  un pseudo ou un canal
	    CANCEL Annule le dernier mmo que vous avez envoy
	    LIST   Affiche la liste de vos mmos
	    READ   Affiche des mmos
	    DEL    Efface des mmos
	    SET    Configure des options relatives aux mmos
	
	Tapez /msg %S HELP commande pour obtenir de l'aide sur
	une de ces commandes.

MEMO_HELP_SEND
	Syntaxe: SEND {pseudo | canal} texte du mmo
	
	Envoie au pseudo donn un mmo contenant texte du mmo.
	Si un canal est spcifi au lieu d'un pseudo, le mmo est
	envoy  tous les utilisateurs prsents sur sa liste
	d'accs dont le niveau est au moins 10 (par dfaut; cela
	peut tre chang via la commande %s LEVELS).
	
	Le(s) destinataire(s) seront informs de l'arrive d'un
	nouveau mmo. Le pseudo ou canal cible doit tre
	enregistr.
	
MEMO_HELP_CANCEL
	Syntaxe: CANCEL pseudo
	
	Supprime le dernier mmo que vous avez envoy  un pseudo
	donn,  condition qu'il n'ait pas dj t lu au moment o
	vous utilisez la commande.

MEMO_HELP_LIST
	Syntaxe: LIST [liste | NEW]
	
	Affiche la liste des mmos que vous possdez actuellement.
	Si vous utilisez l'option NEW, seuls les mmos non lus
	sont concerns. Ces mmos sont reprable par la prsence
	d'un astrisque  gauche de leur numro. Vous pouvez
	galement spcifier une liste de numros, comme dans
	l'exemple ci-dessous:

	   LIST 2-5,7-9
	      Affiche la liste des mmos 2  5 et 7  9.

MEMO_HELP_READ
	Syntaxe: READ {numro | liste | LAST | NEW}
	
	Affiche le contenu des mmos spcifis. Si l'option LAST
	est donne, seul le dernier mmo reu est affich. Si
	l'option NEW est donne, seuls les mmos non lus sont
	affichs. Sinon, le mmo avec le numro donn est
	affich. Vous pouvez galement donner une liste de
	numros, comme dans cet exemple:
	
	   READ 2-5,7-9
	      Affiche les mmos 2  5 et 7  9.

MEMO_HELP_DEL
	Syntaxe: DEL {numro | liste | ALL}
	
	Supprime le ou les mmos spcifis. Vous pouvez fournir
	une liste de numros de mmos au lieu d'un numro unique,
	comme dans le second exemple ci-dessous.
	
	Si l'option ALL est donne, tous vos mmos sont supprims.
	
	Exemples:
	
	   DEL 1
	      Supprime votre premier mmo.
	
	   DEL 2-5,7-9
	      Supprime les mmos compris entre 2 et 5 et entre 7 et 9.

MEMO_HELP_SET
	Syntaxe: SET option paramtres
	
	Configure les options relatives aux mmos. option peut
	tre:
	
	    NOTIFY      Change votre prfrence de notification
	                  pour les nouveaux mmos que vous recevez
	    LIMIT       Change le nombre maximum de mmos que vous
	                  pouvez conserver
	    FORWARD     Dtermine si vous recevez une copie de vos
	                  nouveaux mmos par courriel
	
	Tapez /msg %S HELP SET option pour plus d'informations
	sur une option en particulier.

MEMO_HELP_SET_NOTIFY
	Syntaxe: SET NOTIFY {ON | LOGON | NEW | OFF}
	
	Change votre prfrence de notification pour les nouveaux
	mmos que vous recevez:
	
	    ON     Vous tes notifi  la connexion, lorsque vous
	           enlevez /AWAY, et au moment o ils vous sont
	           envoys.
	    LOGON  Vous tes uniquement notifi  la connexion et
	           lorsque vous enlevez /AWAY.
	    NEW    Vous tes uniquement notifi au moment o ils
	           vous sont envoys.
	    OFF    Vous ne recevez aucune notification.
	
	ON est l'quivalent de LOGON et NEW runis.

MEMO_HELP_SET_LIMIT
	Syntaxe: SET LIMIT limite
	
	Change le nombre maximum de mmos que vous pouvez conserver.
	Si vous choisissez une limite de 0, personne ne pourra vous
	envoyer de mmo. Il ne vous est pas possible de choisir une
	limite suprieure  %d.

MEMO_HELP_SET_FORWARD
	Syntaxe: SET FORWARD {ON | OFF}
	
	Dtermine si vous recevez une copie de vos nouveaux mmos
	par courriel (ON) ou non (OFF).
	
	Vous ne pouvez pas activer cette option  moins d'avoir
	une adresse de courriel authentifie associe  votre
	pseudo. Tapez /msg %s HELP SET EMAIL et
	/msg %s HELP AUTH pour plus d'informations.
	
	Cette option peut tre dsactive sur certains rseaux.

MEMO_HELP_INFO
	Syntaxe: INFO
	
	Affiche des informations sur le nombre de mmos que vous
	avez, combien sont non lus, et combien vous pouvez en
	conserver en tout.

MEMO_SERVADMIN_HELP_SET_LIMIT
	Syntaxe: SET LIMIT [utilisateur] {limite | NONE} [HARD]
	
	Change le nombre maximum de mmos qu'un utilisateur est
	autoris  conserver. Une limite de 0 empche l'utilisateur
	de recevoir des mmos; si l'option NONE est utilise,
	l'utilisateur peut recevoir et conserver autant de mmos
	qu'ils le souhaitent. Si vous ne prcisez pas de pseudo,
	les changements s'appliquent  votre propre limite.
	
	L'option HARD empche l'utilisateur de changer la
	limite que vous dfinissez. Sans l'option HARD,
	l'utilisateur peut changer cette limite (mme si une limite
	antrieure avait t spcifie avec HARD).
	
	Cette version de la commande SET LIMIT est rserve aux
	administrateurs des services. Les utilisateurs normaux
	peuvent uniquement configurer leur propre limite et ne
	peuvent la supprimer ni utiliser l'option HARD.

MEMO_SERVADMIN_HELP_INFO
	Syntaxe: INFO [pseudo]
	
	Si aucun paramtre n'est donn, cette commande affiche le
	nombre de mmos que vous avez, combien sont non lus, et
	combien vous pouvez en conserver en tout.
	
	Si un pseudo est donn, affiche la mme information pour
	le pseudo donn. Cette possibilit est rserve aux
	administrateurs des services.

###########################################################################
#
# OperServ help messages
#
###########################################################################

OPER_HELP
	Commandes %S:
	    GLOBAL      Envoie un message  tous les utilisateurs
	    STATS       Affiche le status des services et du rseau
	    OPER LIST   Affiche les oprateurs des services
	    ADMIN LIST  Affiche les administrateurs des services
	
	Commandes rserves aux oprateurs des services:
	    MODE        Change les modes d'un canal
	    KICK        Expulse un utilisateur d'un canal
	    CLEARMODES  Supprime tous les modes d'un canal
	    AKILL       Gre la liste des AKILLs
	    SGLINE      Gre la liste des SGLINEs
	    SQLINE      Gre la liste des SQLINEs
	    SZLINE      Gre la liste des SZLINEs
	
	Commandes rserves aux administrateurs des services:
	    OPER        Gre la liste des oprateurs des services
	    CHANLIST    Affiche la liste des canaux du rseau
	    USERLIST    Affiche la liste des utilisateurs du rseau
	    NEWS        Dfinit les nouvelles affiches  diverses
	                occasions
	    SESSION     Affiche la liste des sessions par hte
	    EXCEPTION   Modifie la liste des exceptions  la limite
	                de session
	    BLACKLIST   Modifie les htes de la liste noire
	    NOOP        Supprime temporairement toutes les O:lines
	                d'un serveur
	    JUPE        Empche un serveur de se connecter au rseau
	    SET         Configure des options globales d'Epona
	    RELOAD      Recharge la configuration d'Epona
	    SYNC        Synchronize les modules immdiatement
	    RESTART     Relance Epona
	    STOP        Arrte Epona
	    FATAL       Arrte Epona brutalement
	
	Commandes rserves aux super-utilisateurs des services:
	    ADMIN       Modifie la liste des administrateurs des services
	    MODULES     Gre la liste des modules chargs
	
	Remarque: Toutes les commandes envoyes  %S sont enregistres!

OPER_HELP_GLOBAL
	Syntaxe: GLOBAL message
	
	Permet aux oprateurs IRC d'envoyer un message  tous les
	utilisateurs du rseau. Le message est envoy sous le
	pseudo %s.

OPER_HELP_STATS
	Syntaxe: STATS [AKILL | ALL | RESET]
	
	Si aucune option n'est prcise, cette commande affiche
	le nombre d'utilisateurs et d'oprateurs IRC actuellement
	connects (hors services), le plus grand nombre
	d'utilisateurs connects depuis la mise en place des
	services, et la dure de fonctionnement des services depuis
	le dernier dmarrage.
	
	Si l'option AKILL est prcise, cette commande affiche la
	taille actuelle des liste des AKILLs, des SGLINEs, des
	SQLINEs et des SZLINEs et le temps d'chance par dfaut
	pour chacune d'elles.
	
	Si l'option ALL, rserve aux administrateurs des
	services, est prcise, cette commande affiche des
	informations dtailles notamment sur la quantit de
	mmoire utilise par les services. L'utilisation de cette
	commande peut entraner le gel des services pendant un
	bref instant sur de grands rseaux, alors n'en abusez pas!
	
	Si l'option RESET est prcise, cette commande
	rinitialise le nombre maximum d'utilisateurs en fonction
	de leur nombre actuel sur le rseau.
	
	Cette commande peut aussi tre utilise sous le nom
	d'UPTIME.

OPER_HELP_OPER
	Syntaxe: OPER ADD pseudo
	         OPER DEL {pseudo | numro-d'entre | liste}
	         OPER LIST [mask | liste]
	         OPER CLEAR
	
	Permet aux administrateurs des services d'ajouter ou de
	supprimer des utilisateurs dans la liste des oprateurs des
	services. Un utilisateur figurant dans la liste et
	identifi auprs de %s aura accs aux commandes rserves
	aux oprateurs des services.
	
	La commande OPER ADD ajoute l'utilisateur donn  la
	liste des oprateurs des services.
	
	La commande OPER DEL supprime l'utilisateur donn de la
	liste des oprateurs des services. Si une liste d'entres
	est donne, ces entres sont supprimes. (Consultez
	l'exemple pour LIST ci-dessous.)
	
	La commande OPER LIST affiche la liste des oprateurs des
	services. Si un masque joker est donn, seules les entres
	correspondantes sont affiches. Si une liste d'entres est
	donne, seules ces entres sont affiches; par exemple:

	   OPER LIST 2-5,7-9
	        Affiche toutes les entres comprises entre 2 et 5
	        et entre 7 et 9.
	
	La commande OPER CLEAR supprime toutes les entres de la
	liste des oprateurs des services.
	
	Un oprateur IRC peut utiliser la forme OPER LIST de la
	commande. Tous les autres usages sont rservs aux
	administrateurs des services.

OPER_HELP_ADMIN
	Syntaxe: ADMIN ADD pseudo
	         ADMIN DEL {pseudo | numro-d'entre | liste}
	         ADMIN LIST [masque | liste]
	         ADMIN CLEAR
	
	Permet aux super-utilisateurs des services d'ajouter ou de
	supprimer des utilisateurs dans la liste des
	administrateurs des services. Un utilisateur figurant dans
	la liste et identifi auprs de %s aura accs aux commandes
	rserves aux administrateurs des services (qui incluent
	celles rserves aux oprateurs des services).
	
	La commande ADMIN ADD ajoute l'utilisateur donn  la liste
	des administrateurs des services.
	
	La commande ADMIN DEL supprime l'utilisateur donn de la
	liste des administrateurs des services. Si une liste
	d'entres est donne, ces entres sont supprimes. (Consultez 
	l'exemple pour LIST ci-dessous.)
	
	La commande ADMIN LIST affiche la liste des
	administrateurs des services. Si un masque joker est donn,
	seules les entres correspondantes sont affiches. Si une
	liste d'entres est donne, seules ces entres sont
	affiches; par exemple:

	   ADMIN LIST 2-5,7-9
	        Affiche toutes les entres comprises entre 2 et 5
	        et entre 7 et 9.
	
	La commande ADMIN CLEAR supprime toutes les entres de la
	liste des administrateurs des services.
	
	Un oprateur IRC peut utiliser la forme ADMIN LIST de la
	commande. Tous les autres usages sont rservs aux
	super-utilisateurs des services.

OPER_HELP_MODE
	Syntaxe: MODE canal modes
	
	Permet aux oprateurs des services de dfinir les modes
	d'un canal. Les paramtres sont les mmes que pour la
	commande /MODE normale.
	
	Rserve aux oprateurs des services.

OPER_HELP_CLEARMODES
	Syntaxe: CLEARMODES canal [ALL]
	
	Enlve tous les modes binaires (tels que i,k,l,m,n,p,s,t)
	et les bannissements d'un canal. Si ALL est donn, 
	cette commande enlve galement tous les modes utilisateur
	(tels que +o et +v) du canal.
	
	Rserve aux oprateurs des services.

OPER_HELP_KICK
	Syntaxe: KICK canal utilisateur raison
	
	Permet aux oprateurs IRC d'expulser un utilisateur d'un
	canal. Les paramtres sont les mmes que pour la commande
	/KICK normale. Le message d'expulsion sera prfix du
	pseudo de l'oprateur IRC ayant utilis la commande KICK;
	par exemple:
	
	*** Spammeur a t expuls de #moncanal par %S (Pegase (Spam))
	
	Rserve aux oprateurs des services.

OPER_HELP_AKILL
	Syntaxe: AKILL ADD [+chance] {masque | pseudo[:type]} raison
	         AKILL DEL {masque | numro-d'entre | liste}
	         AKILL LIST [masque | liste]
	         AKILL VIEW [masque | liste]
	         AKILL CLEAR
	
	Permet aux oprateurs des services de manipuler la liste
	des AKILLs. Si un utilisateur correspondant  un masque
	d'un AKILL tente de se connecter, les services le
	dconnecteront aussitt et, sur les rseaux le supportant,
	demanderont  tous les serveurs le bannissement (K-line) du
	masque incrimin.
	
	La commande AKILL ADD ajoute le masque donn (au format
	user@host)  la liste des AKILLs pour la raison
	prcise (qui doit tre donne). Si un pseudo est
	fourni, il est automatiquement traduit en un masque
	appropri pour cet utilisateur connect (un type
	peut ventuellement tre inclus pour changer le
	type de masque qui est gnr). chance est un nombre
	entier suivi par un w (semaines), d (jours),
	h (heures), ou m (minutes). Les combinaisons (telles
	que 1h30m) sont possibles. Pour ajouter un AKILL qui
	n'expire pas, utilisez +0. Si le masque utilisateur 
	ajouter commence par un +, spcifier l'chance devient
	obligatoire dans tous les cas. L'chance par dfaut des
	AKILLs peut tre consulte via la commande STATS AKILL.
	
	La commande AKILL DEL supprime le masque donn de la liste
	des AKILLs s'il existe. Si une liste de numros d'entres
	est donne, ces entres sont supprimes. (Voyez l'exemple
	pour LIST ci-dessous.)
	
	La commande AKILL LIST affiche la liste des AKILLs. Si un
	masque joker est donn, seules les entres correspondantes
	au masque sont affiches. Si le masque commence par un #,
	l'entre avec le mme numro de suivi est affich (ce
	numro est automatiquement ajout  la raison des AKILLs
	avant la dconnexion d'un utilisateur). Si une liste de
	numros d'entres est donne, seules ces entres sont
	affiches; par exemple:

	   AKILL LIST 2-5,7-9
	      Affiche les entres de la liste des AKILLs numros
	      2  5 et 7  9.
	      
	La commande AKILL VIEW est une version plus dtaille de
	AKILL LIST, qui affiche par qui et quand a t ajout un
	AKILL, ainsi que sa date d'expiration, en plus du masque
	utilisateur et de la raison. 
	
	La commande AKILL CLEAR supprime toutes les entres de la
	liste des AKILLs.
	
	Rsrve aux oprateurs des services.

OPER_HELP_SGLINE
	Syntaxe: SGLINE ADD [+chance] masque:raison
	         SGLINE DEL {masque | numro-d'entre | liste}
	         SGLINE LIST [masque | liste]
	         SGLINE VIEW [masque | liste]
	         SGLINE CLEAR
	
	Permet aux oprateurs des services de manipuler la liste
	des SGLINEs. Si un utilisateur dont le vrai nom correspond
	 un masque d'un SGLINE se connecte, les services le
	dconnecteront.
	
	La commande SGLINE ADD ajoute le masque donn  la
	liste des SGLINEs pour la raison prcise (qui doit tre
	donne). chance est un nombre entier suivi par un w
	(semaines), d (jours), h (heures), ou m (minutes).
	Les combinaisons (telles que 1h30m) sont possibles. Pour
	ajouter un SGLINE qui n'expire pas, utilisez +0. Si le
	masque  ajouter commence par un +, spcifier l'chance
	devient obligatoire dans tous les cas. L'chance par
	dfaut des SGLINEs peut tre consulte via la commande
	STATS AKILL.
	Note: comme le masque de vrai nom peut contenir des
	espaces, il est spar de la raison par un deux-points et
	non un espace.
	
	La commande SGLINE DEL supprime le masque donn de la
	liste des SGLINEs s'il existe. Si une liste de numros
	d'entres est donne, ces entres sont supprimes. (Voyez
	l'exemple pour LIST ci-dessous.)
	
	La commande SGLINE LIST affiche la liste des SGLINEs. Si
	un masque joker est donn, seules les entres
	correspondantes au masque sont affiches. Si le masque
	commence par un #, l'entre avec le mme numro de suivi
	est affich (ce numro est automatiquement ajout  la
	raison des SGLINEs envoye aux serveurs IRC). Si une liste
	de numros d'entres est donne, seules ces entres sont
	affiches; par exemple:
	
	   SGLINE LIST 2-5,7-9
	      Affiche les entres de la liste des SGLINEs numros
	      2  5 et 7  9.
	
	La commande SGLINE VIEW est une version plus dtaille de
	SGLINE LIST, qui affiche par qui et quand a t ajout un
	SGLINE, ainsi que sa date d'expiration, en plus du masque
	et de la raison. 
	
	La commande SGLINE CLEAR supprime toutes les entres de la
	liste des SGLINEs.
	
	Rsrve aux oprateurs des services.

OPER_HELP_SQLINE
	Syntaxe: SQLINE ADD [+chance] masque raison
	         SQLINE DEL {masque | numro-d'entre | liste}
	         SQLINE LIST [masque | liste]
	         SQLINE VIEW [masque | liste]
	         SQLINE CLEAR
	
	Permet aux oprateurs des services de manipuler la liste
	des SQLINEs. Si un utilisateur dont le pseudo correspond 
	un masque d'un SQLINE se connecte, les services
	l'empcheront aussitt de l'utiliser.
	
	Si le premier caractre du masque est un #, les services
	empcheront la cration de canaux dont le nom correspond.
	
	La commande SQLINE ADD ajoute le masque donn  la
	liste des SQLINEs pour la raison prcise (qui doit tre
	donne). chance est un nombre entier suivi par un w
	(semaines), d (jours), h (heures), ou m (minutes).
	Les combinaisons (telles que 1h30m) sont possibles. Pour
	ajouter un SQLINE qui n'expire pas, utilisez +0. Si le
	masque  ajouter commence par un +, spcifier l'chance
	devient obligatoire dans tous les cas. L'chance par
	dfaut des SQLINEs peut tre consulte via la commande
	STATS AKILL.
	
	La commande SQLINE DEL supprime le masque donn de la
	liste des SQLINEs s'il existe. Si une liste de numros
	d'entres est donne, ces entres sont supprimes. (Voyez
	l'exemple pour LIST ci-dessous.)
	
	La commande SQLINE LIST affiche la liste des SQLINEs. Si
	un masque joker est donn, seules les entres
	correspondantes au masque sont affiches. Si le masque
	commence par un #, l'entre avec le mme numro de suivi
	est affich (ce numro est automatiquement ajout  la
	raison des SQLINEs envoye aux serveurs IRC). Si une liste
	de numros d'entres est donne, seules ces entres sont
	affiches; par exemple:
	
	   SQLINE LIST 2-5,7-9
	      Affiche les entres de la liste des SQLINEs numros
	      2  5 et 7  9.
	
	La commande SQLINE VIEW est une version plus dtaille de
	SQLINE LIST, qui affiche par qui et quand a t ajout un
	SQLINE, ainsi que sa date d'expiration, en plus du masque
	et de la raison. 
	
	La commande SQLINE CLEAR supprime toutes les entres de la
	liste des SQLINEs.
	
	Rsrve aux oprateurs des services.

OPER_HELP_SZLINE
	Syntaxe: SZLINE ADD [+chance] masque raison
	         SZLINE DEL {masque | numro-d'entre | liste}
	         SZLINE LIST [masque | liste]
	         SZLINE VIEW [masque | liste]
	         SZLINE CLEAR
	
	Permet aux oprateurs des services de manipuler la liste
	des SZLINEs. Si un utilisateur dont l'IP correspond 
	un masque d'un SZLINE se connecte, les services le
	dconnecteront -- et ce, mme si l'IP a un PTR RR.
	
	La commande SZLINE ADD ajoute le masque donn  la
	liste des SZLINEs pour la raison prcise (qui doit tre
	donne). La notation CIDR est possible sur certains
	serveurs. chance est un nombre entier suivi par un w
	(semaines), d (jours), h (heures), ou m (minutes).
	Les combinaisons (telles que 1h30m) sont possibles. Pour
	ajouter un SZLINE qui n'expire pas, utilisez +0. Si le
	masque  ajouter commence par un +, spcifier l'chance
	devient obligatoire dans tous les cas. L'chance par
	dfaut des SZLINEs peut tre consulte via la commande
	STATS AKILL.
	
	La commande SZLINE DEL supprime le masque donn de la
	liste des SZLINEs s'il existe. Si une liste de numros
	d'entres est donne, ces entres sont supprimes. (Voyez
	l'exemple pour LIST ci-dessous.)
	
	La commande SZLINE LIST affiche la liste des SZLINEs. Si
	un masque joker est donn, seules les entres
	correspondantes au masque sont affiches. Si le masque
	commence par un #, l'entre avec le mme numro de suivi
	est affich (ce numro est automatiquement ajout  la
	raison des SZLINEs envoye aux serveurs IRC). Si une liste
	de numros d'entres est donne, seules ces entres sont
	affiches; par exemple:
	
	   SZLINE LIST 2-5,7-9
	      Affiche les entres de la liste des SZLINEs numros
	      2  5 et 7  9.
	
	La commande SZLINE VIEW est une version plus dtaille de
	SZLINE LIST, qui affiche par qui et quand a t ajout un
	SZLINE, ainsi que sa date d'expiration, en plus du masque
	et de la raison. 
	
	La commande SZLINE CLEAR supprime toutes les entres de la
	liste des SZLINEs.
	
	Rsrve aux oprateurs des services.

OPER_HELP_SET
	Syntaxe: SET option valeur
	
	Contrle diffrentes options globales d'Epona.
	Les noms des options possibles sont:
	
	    READONLY   Active ou dsactive le mode lecture-seule
	    DEBUG      Active ou dsactive le mode de dbogage
	    NOEXPIRE   Active ou dsactive le mode sans expiration
	    IGNORE     Active ou dsactive le mcanisme d'ignorance
	
	Rserve aux administrateurs des services.

OPER_HELP_SET_READONLY
	Syntaxe: SET READONLY {ON | OFF}
	
	Active ou dsactive le mode lecture-seule. En mode
	lecture-seule, les utilisateurs (y compris les oprateurs
	IRC) ne sont pas autoriss  modifier des donnes des
	services.
	
	Cette option est quivalente au paramtre de la ligne de
	commande --readonly.

OPER_HELP_SET_DEBUG
	Syntaxe: SET DEBUG {ON | OFF | nombre}
	
	Active ou dsactive le mode dbogage. En mode dbogage,
	toutes les donnes envoyes par et vers les services ainsi
	que bon nombre d'autres messages utiles au dbogage sont
	archivs. Si nombre est donn, le mode dbogage est
	activ au niveau nombre.
	
	Cette option est quivalente au paramtre de la ligne de
	commande --debug.
	
OPER_HELP_SET_NOEXPIRE
	Syntaxe: SET NOEXPIRE {ON | OFF}
	
	Active ou dsactive le mode sans expiration. En mode 
	sans expiration, aucune expiration ne se produira jusqu'
	ce que l'option soit dsactive.
	
	Cette option est quivalente au paramtre de la ligne de
	commande --noexpire.

OPER_HELP_SET_IGNORE
	Syntaxe: SET IGNORE {ON | OFF}
	
	Active ou dsactive l'utilisation du mcanisme d'ignorance
	dont le but est de contrer des utilisateurs malicieux qui
	pourraient abuser des services par l'usage conscutif de
	commandes dont la dure totale d'excution excderait une
	seconde, ce qui empcherait d'autres utilisateurs 
	d'utiliser les services.
	
	Il est activ par dfaut, ce qui est recommand. Les
	oprateurs IRC ne sont pas affects.

OPER_HELP_NOOP
	Syntaxe: NOOP SET serveur
	         NOOP REVOKE serveur
	
	NOOP SET retire toutes les O:lines du serveur donn
	et dconnecte tous les oprateurs IRC qui s'y trouvent
	actuellement pour les empcher de recharger la
	configuration du serveur (ce qui annulerait les effets
	de la commande).
	
	NOOP REVOKE remet en place toutes les O:lines 
	supprimes du serveur donn.
	
	Note: Le paramtre serveur n'est en aucun cas 
	vrifi par les services.

	Rserve aux administrateurs des services.

OPER_HELP_JUPE
	Syntaxe: JUPE serveur [raison]
	
	Demande aux services de bannir un serveur en crant un faux
	serveur connect aux services ce qui empche le vrai
	serveur ayant ce nom de se reconnecter. Le bannissement
	peut tre enlev en utilisant un SQUIT normal. Si une
	raison est donne, elle est place dans la description du
	serveur; sinon, l'information du serveur contiendra le
	texte "Juped by <pseudo>", laissant paratre le pseudo
	de la personne qui a banni le serveur.
	
	Rserve aux administrateurs des services.

OPER_HELP_RAW
	Syntaxe: RAW texte
	
	Envoie une chane de caractres directement au serveur sur
	lequel les services sont connects. Cette commande a un
	champ d'utilisation trs limit, et peut causer des
	problmes dans un rseau en cas de mauvaise utilisation.
	N'UTILISEZ PAS CETTE COMMANDE  moins d'tre absolument
	sr de ce que vous faites!
	
	Rserve aux administrateurs des services.

OPER_HELP_SYNC
	Syntaxe: SYNC
	
	Provoque l'envoi d'une requte de synchronisation aux
	modules. Les modules peuvent interprter ce message de la
	manire dont ils le souhaitent (y compris l'ignorer), mais
	les modules de base de donnes s'en servent gnralement
	pour sauvegarder ou importer leurs donnes, selon ce qui
	est pertinent pour eux.
	
	Rserve aux administrateurs des services.
	
OPER_HELP_RELOAD
	Syntaxe: RELOAD
	
	Provoque le rechargement de la configuration d'Epona. Notez
	que certaines directives demandent tout de mme un
	redmarrage des Services avant de prendre effet.
	
	Rserve aux administrateurs des services.

OPER_HELP_RESTART
	Syntaxe: RESTART
	
	Provoque l'arrt de tous les modules et le redmarrage
	d'Epona.
	
	Rserve aux administrateurs des services.

OPER_HELP_STOP
	Syntaxe: STOP
	
	Provoque l'arrt de tous les modules et d'Epona.
	
	Rserve aux administrateurs des services.

OPER_HELP_FATAL
	Syntaxe: FATAL
	
	Provoque un arrt brutal d'Epona; les modules ne sont pas
	stopps normalement. Cette commande ne doit tre utilise
	que si vous souponnez des dgts irrversibles si un
	module venait  s'arrter normalement. Dans les autres cas,
	prfrez la commande STOP.
	
	Rserve aux administrateurs des services.

OPER_HELP_CHANLIST
	Syntaxe: CHANLIST [{modle [liste] [NOLIMIT] | pseudo} [SECRET]]
	
	Affiche la liste de tous les canaux actuellement existsnts
	sur le rseau IRC, qu'ils soient enregistrs ou non.
	
	Si un modle est donn, seuls les canaux dont le nom
	correspond sont affichs. Le nombre de rsultats montrs
	en une seule fois est limit; vous pouvez spcifier une
	liste pour voir les rsultats au-del de cette limite.
	Par exemple:
	
	   CHANLIST 51-100
	       Montre les rsultats 51  100.
	   CHANLIST *epona* 15-20
	       Montre les rsultats 15  20 dont le nom
	       contient "epona".
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).
	
	Si un modle ou une liste est donn, spcifier l'option
	NOLIMIT affiche un nombre illimit de rsultats.
	
	Si un pseudo est donn au lieu d'un modle, tous les
	canaux sur lesquels se trouvent cet utilisateur sont
	affichs.
	
	Dans les deux cas, vous pouvez utiliser l'option SECRET
	pour n'afficher que les canaux en mode +s ou +p.
	
	Rserve aux administrateurs des services.
	
OPER_HELP_USERLIST
	Syntaxe: USERLIST [{[modle] [liste] [NOLIMIT] | canal} [INVISIBLE]]
	
	Affiche la liste de tous les utilisateurs connects au
	rseau IRC, qu'ils soient enregistrs ou non.
	
	Si un modle est donn, seuls les utilisateurs dont le
	masque (au format nick!user@host) correspond sont affichs.
	Le nombre de rsultats montrs en une seule fois est
	limit; vous pouvez spcifier une liste pour voir les
	rsultats au-del de cette limite. Par exemple:
	
	   USERLIST 51-100
	       Montre les rsultats 51  100.
	   USERLIST *epona*!* 15-20
	       Montre les rsultats 15  20 dont le pseudo
	       contient "epona".
	
	(Note: contrairement aux listes numrotes, il n'est pas
	possible d'utiliser des combinaisons comme 51-60,75-80).
	
	Si un modle ou une liste est donn, spcifier l'option
	NOLIMIT affiche un nombre illimit de rsultats.
	
	Si un canal est donn au lieu d'un modle, seuls les
	utilisateurs de ce canal sont affichs.
	
	Dans les deux cas, vous pouvez utiliser l'option
	INVISIBLE pour n'afficher que les utilisateurs en
	mode +i.
	
	Rserve aux administrateurs des services.

OPER_HELP_BLACKLIST
	Syntaxe: BLACKLIST DEL nom d'hte
	         BLACKLIST LIST [modle]
	
	La commande BLACKLIST DEL supprime le nom d'hte donn de
	la liste noire. Notez que ce changement est uniquement
	temporaire; le fichier de liste noire ne sera pas modifi.
	
	La commande BLACKLIST LIST affiche tous les noms d'hte en
	liste noire ou ceux correspondant au modle donn.

	Rserve aux administrateurs des services.

OPER_HELP_MODULES
	Syntaxe: MODULES LOAD nom
	         MODULES UNLOAD nom
	         MODULES LIST
	         MODULES INFO nom
	         MODULES QUERY nom requte
	
	La commande MODULES LOAD charge dynamiquement le module
	nom.
	
	Attention! Le chargement d'un module qui a t compil pour
	une version diffrente d'Epona et/ou des autres modules
	chargs peut entraner le plantage du programme entier dans
	certains cas. Il est donc recommand de n'utiliser cette
	commande pour faire a que si vous tes sr(e) de ce que
	vous faites.
	
	La commande MODULES UNLOAD dcharge dynamiquement le
	module nom. Il est impossible de dcharger un module dont
	le nombre de rfrences est diffrent de zro.
	
	La commande MODULES LIST affiche la liste des modules
	actuellement chargs ainsi que leurs descriptions et
	leurs nombres de rfrences.
	
	La commande MODULES INFO affiche des informations
	gnrales concernant le module nom.
	
	La commande MODULES QUERY envoie la requte spcifie
	au module nom, et affiche la rponse ventuelle.
		
	Rserve aux super-utilisateurs des services.

###########################################################################
#
# BotServ help messages
#
###########################################################################
	
BOT_HELP
	%S est un service qui vous permet d'avoir un robot
	rpondant  des besoins de base sur votre canal.
	Il a t conu pour les utilisateurs qui ne peuvent
	ou veulent pas hberger ou configurer de robot, ou pour
	tre utilis sur les rseaux qui n'autorisent pas
	les utilisateurs  avoir leurs propres robots. Les
	commandes disponibles sont affiches ci-dessous; pour
	les utiliser, tapez /msg %S commande. Pour plus
	d'information sur une commande spcifique, tapez
	/msg %S HELP commande.
	
	BOTLIST            Affiche les robots disponibles
	ASSIGN             Attribue un robot  un canal
	SET                Configure les options du robot
	KICK               Configure les expulseurs automatiques
	BADWORDS           Gre la liste des mots interdits
	
	Autres commandes: ACT INFO SAY UNASSIGN
	
	Un robot attribu  un canal le joint ds lors qu'il y
	a au moins %d utilisateurs dessus.

BOT_HELP_BOTLIST
	Syntaxe: BOTLIST
	
	Affiche la liste des robots disponibles sur ce rseau.
	
BOT_HELP_ASSIGN
	Syntaxe: ASSIGN canal robot
	
	Attribue le robot dsign par pseudo au canal spcifi.
	Vous pouvez ensuite configurer le robot pour qu'il
	convienne  vos besoins.
	
BOT_HELP_UNASSIGN
	Syntaxe: UNASSIGN canal
	
	Retire un robot qui a t attribu auparavant  un canal.
	Aprs l'utilisation de cette commande, le robot ne joint
	plus le canal. Toutefois, la configuration du robot est
	conserve et elle sera utilise telle quelle au cas o
	vous choisiriez de rattribuer un robot ultrieurement.
	
BOT_HELP_INFO
	Syntax: INFO {canal | robot}
	
	Cette commande vous permet de voir les informations %S
	d'un canal ou d'un robot. Si le paramtre est un canal,
	vous verrez des informations sur le canal tels que les
	options et expulseurs actifs. Si le paramtre est le
	pseudo d'un robot, vous verrez des informations 
	propos de celui-ci, comme la date de cration ou le
	nombre de canaux auxquels il a t attribu.
	
BOT_HELP_SET
	Syntaxe: SET canal option paramtres
	
	Configure les options du robot du canal donn. 
	option peut tre:
	
	    DONTKICKOPS      Active ou dsactive la protection des
	                       oprateurs contre les expulsions du robot
	    DONTKICKVOICES   Active ou dsactive la protection des
	                       mode +v contre les expulsions du robot
	    FANTASY          Active ou dsactive les commandes
	                       fantaisistes
	    GREET            Active ou dsactive les messages
	                       d'accueil
	    SYMBIOSIS        Permet au robot de faire lui-mme tous
	                       les changements de mode et expulsions
	
	Tapez /msg %S HELP SET option pour plus d'infos
	sur une option spcifique.
	
BOT_HELP_SET_DONTKICKOPS
	Syntaxe: SET canal DONTKICKOPS {ON | OFF}
	
	Contrle l'activation de la protection des oprateurs
	d'un canal. Si cette option est active, le robot n'expulse
	jamais les oprateurs qui enfreignent les rgles du canal
	dictes via la commande KICK, quel que soit leur
	niveau dans la liste d'accs.
	
BOT_HELP_SET_DONTKICKVOICES
	Syntaxe: SET canal DONTKICKVOICES {ON | OFF}
	
	Contrle l'activation de la protection des utilisateurs
	ayant le mode +v d'un canal. Si cette option est active,
	le robot n'expulse jamais ces utilisateurs s'ils
	enfreignent les rgles du canal dictes via la commande
	KICK, quel que soit leur niveau dans la liste d'accs.
	
BOT_HELP_SET_FANTASY
	Syntax: SET canal FANTASY {ON | OFF}
	
	Contrle l'activation des commandes fantaisistes sur
	un canal. Si cette option est active, elle permet aux
	utilisateurs d'utiliser les commandes !op, !deop, !voice,
	!devoice, !kick, !kb, !unban, !seen, etc. (Trouvez
	comment les utiliser; essayez avec ou sans pseudo pour
	chacune, et avec une raison pour certaines?)
	
	Notez que les utilisateurs souhaitant utiliser
	les commandes fantaisistes DOIVENT avoir un niveau
	suffisant pour le privilge FANTASIA et un autre privilge
	qui dpend de la commande (par exemple, pour utiliser !op,
	un utilisateur doit avoir un niveau d'accs suffisant pour
	le privilge OPDEOP).
	
BOT_HELP_SET_GREET
	Syntaxe: SET canal GREET {ON | OFF}
	
	Contrle l'activation de l'affichage des messages
	d'accueil personnaliss sur un canal. Si cette option
	est active, le robot affiche  l'entre de chaque
	utilisateur qui a un niveau d'accs suffisant, un message
	d'accueil que celui-ci aura au pralable choisi.

BOT_HELP_SET_SYMBIOSIS
	Syntax: SET canal SYMBIOSIS {ON | OFF}
	
	Contrle l'activation de la symbiose sur un canal. Si
	cette option est active, le robot effectue toutes les
	actions normalement dvolues  %s comme les changements
	de mode, les expulsions, et mme l'affichage du message
	d'entre.
	
BOT_HELP_KICK
	Syntaxe: KICK canal option paramtres
	
	Configure les expulseurs automatiques du robot. option
	peut tre:
	
	    BOLDS         Configure l'expulseur de caractres gras
	    BADWORDS      Configure l'expulseur de mots interdits
	    CAPS          Configure l'expulseur de majuscules
	    COLORS        Configure l'expulseur de couleurs
	    FLOOD         Configure l'expulseur de flood
	    REPEAT        Configure l'expulseur de rptitions
	    REVERSES      Configure l'expulseur de caractres inverss
	    UNDERLINES    Configure l'expulseur de caractres souligns
	
	Tapez /msg %S HELP KICK option pour plus d'informations
	sur une option en particulier.

BOT_HELP_KICK_BOLDS
	Syntaxe: KICK canal BOLDS {ON | OFF} [eab]

	Sanctionne l'emploi de caractres gras. Quand cette option
	est active, le robot expulse les utilisateurs qui crivent
	avec des caractres gras.
	
	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_COLORS
	Syntaxe: KICK canal COLORS {ON | OFF} [eab]
	
	Sanctionne l'emploi de couleurs. Quand cette option
	est active, le robot expulse les utilisateurs qui crivent
	en couleurs.
	
	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_REVERSES
	Syntaxe: KICK canal REVERSES {ON | OFF} [eab]

	Sanctionne l'emploi de caractres inverss. Quand cette
	option est active, le robot expulse les utilisateurs qui
	crivent avec des caractres inverss.
	
	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_UNDERLINES
	Syntaxe: KICK canal UNDERLINES {ON | OFF} [eab]

	Sanctionne l'emploi de caractres souligns. Quand cette
	option est active, le robot expulse les utilisateurs qui
	crivent avec des caractres souligns.
	
	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.
	
BOT_HELP_KICK_BADWORDS
	Syntaxe: KICK #canal BADWORDS {ON | OFF} [eab]

	Sanctionne l'emploi de mots interdits. Quand cette
	option est active, le robot expulse les utilisateurs qui
	s'expriment avec certains mots, dfinis via la commande
	BADWORDS. Tapez /msg %S HELP BADWORDS pour
	plus d'informations.

	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_CAPS
	Syntaxe: KICK canal CAPS {ON | OFF} [eab [min [pourcentage]]]
	
	Sanctionne l'emploi de majuscules. Quand cette
	option est active, le robot expulse les utilisateurs qui
	crivent en MAJUSCULES sur le canal, sous rserve qu'il
	y ait au minimum min majuscules et qu'elles constituent
	au moins pourcentage%% de la ligne de texte entire (si
	ces paramtres ne sont pas donns, les valeurs par dfaut
	sont 10 caractres et 25%%).

	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_FLOOD
	Syntaxe: KICK canal FLOOD {ON | OFF} [eab [nombre [secs]]]

	Sanctionne le flood. Quand cette option est active, le
	robot expulse les utilisateurs qui crivent au moins
	nombre lignes en secs secondes (si ces paramtres
	ne sont pas donns, les valeurs par dfaut sont 6
	lignes en 10 secondes).
	
	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_KICK_REPEAT
	Syntaxe: KICK #canal REPEAT {ON | OFF} [eab [nombre]]

	Sanctionne les rptitions. Quand cette option est active,
	le robot expulse les utilisateurs qui se rptent
	nombre fois (si ce paramtre n'est pas donn, la
	valeur par dfaut est 3).

	eab est le nombre de fois qu'un utilisateur peut se
	faire expulser avant d'tre banni. Si vous ne prcisez
	pas ce paramtre ou que vous le dfinissez  zro,
	aucun bannissement n'a lieu pour cette sanction.

BOT_HELP_BADWORDS
	Syntaxe: BADWORDS canal ADD expr [SINGLE | START | END]
	         BADWORDS canal DEL {expr | numro-d'entre | liste}
	         BADWORDS canal LIST [masque | liste]
	         BADWORDS canal CLEAR
	
	Modifie ou affiche la liste des mots interdits d'un
	canal, qui dtermine quels mots dclenchent la sanction
	des mots interdits quand elle est active. Pour plus
	d'informations, consultez /msg %S HELP KICK BADWORDS.
	
	La commande BADWORDS ADD ajoute l'expression donne 
	la liste des mots interdits. L'option SINGLE, lorsque
	demande, s'assure que l'expression est un mot entier
	avant de dclencher la sanction, l'option START que
	l'expression est au dbut d'un mot et l'option END
	que l'expression est  la fin d'un mot. Lorsqu'aucune
	option n'est spcifie, la sanction est dclenche 
	chaque fois que l'expression fait partie d'un mot.
	Par exemple:
	
	  BADWORDS ADD ver
	        Ajoute l'expression ver  la liste des mots
	        interdits. La sanction serait dclenche par
	        des mots tels que "ver", "hiver", "verte" ou
	        "averse".
	  BADWORDS ADD ver SINGLE
	        Ajoute l'expression ver  la liste des mots
	        interdits avec l'option SINGLE. La sanction
	        serait dclenche par le mot "ver".
	  BADWORDS ADD ver START
	        Ajoute l'expression ver  la liste des mots
	        interdits avec l'option START. La sanction
	        serait dclenche par des mots tels que "ver"
	        ou "verte".
	  BADWORDS ADD ver END
	        Ajoute l'expression ver  la liste des mots
	        interdits avec l'option END. La sanction
	        serait dclenche par des mots tels que "ver"
	        ou "hiver".
	
	Attention, l'expression ne prend pas en charge les
	caractres joker.
	
	La commande BADWORDS DEL supprime l'expression donn de
	la liste des mots interdits s'il existe. Si une liste de
	numros d'entres est donne, ces entres sont supprimes.
	(Voyez l'exemple pour LIST ci-dessous.)
	
	La commande BADWORDS LIST affiche la liste des mots
	interdits. Si un masque joker est donn, seules les entres
	correspondantes au masque sont affiches. Si une liste de
	numros d'entres est donne, seules ces entres sont
	affiches; par exemple:

	   BADWORDS LIST 2,7-9
	      Affiche les entres de la liste des mots interdits
	      numros 2 et 7  9.
	
	La commande BADWORDS CLEAR supprime toutes les entres de la
	liste des mots interdits.

BOT_HELP_SAY
	Syntaxe: SAY canal texte
	
	Fait dire au robot le texte donn sur le canal spcifi.

BOT_HELP_ACT
	Syntaxe: ACT canal texte
	
	Fait faire au robot l'quivalent d'une commande "/me" sur
	le canal donn avec le texte donn.

BOT_SERVADMIN_HELP
	
	La commande suivante est disponible pour les
	administrateurs des services:
	
	    BOT              Gre la liste des robots du rseau

BOT_SERVADMIN_HELP_BOT
	Syntax: BOT ADD pseudo nom-utilisateur nom-d'hte vrai-nom
	        BOT CHANGE ancien-pseudo nouveau-pseudo [nom-utilisateur [nom-d'hte [vrai-nom]]]
	        BOT DEL pseudo
	        BOT LIST
	
	Permet aux administrateurs des services de crer, modifier
	et supprimer les robots que les utilisateurs peuvent
	utiliser sur leurs canaux.
	
	BOT ADD ajoute un robot avec les pseudo, nom
	d'utilisateur, nom d'hte et vrai nom donns. Aucun test
	d'intgrit n'est effectu sur ces donnes, donc
	assurez-vous qu'elles soient valides.
	BOT CHANGE permet de changer le pseudo, nom
	d'utilisateur, nom d'hte et/ou vrai nom d'un robot tout
	en conservant les donnes qui lui sont attaches.
	BOT DEL supprime le robot donn de la liste des robots.  
	BOT LIST est un alias de BOTLIST qui affiche la
	liste des robots existants sur le rseau.
	
	Note: si vous crez un robot dont le pseudo est
	enregistr, il est effac. De plus, si un utilisateur
	utilise le pseudo du robot lors de sa cration ou
	modification, il est automatiquement dconnect.
	
BOT_SERVADMIN_HELP_SET
	
	Ces options sont rserves aux administrateurs des services:
	
	    NOBOT            Empche un robot d'tre attribu 
	                         un canal
	    PRIVATE          Empche un robot d'tre attribu par
	                         des non-oprateurs IRC

BOT_SERVADMIN_HELP_SET_NOBOT
	Syntaxe: SET canal NOBOT {ON | OFF}
	
	Cette option empche un robot d'tre attribu au canal.
	Si un robot est dj attribu, il est automatiquement
	retir quand vous activez l'option.
	
	Rserve aux administrateurs des services.

BOT_SERVADMIN_HELP_SET_PRIVATE
	Syntaxe: SET pseudo-du-robot PRIVATE {ON | OFF}
	
	Cette option empche un robot d'tre attribu  un
	canal par des utilisateurs qui ne sont pas des oprateurs
	IRC.
	
	Rserve aux administrateurs des services.
